;==============================================================================
;;;
;;; VELUX.LSP
;;; PAUsoft (+45 46 18 59 85)
;;;
;==============================================================================
; ***************************************************************************
; *                                                                         *
; *  VELUX.LSP                                    User   VELUX,      *
; *                                                                         *
; *  Version   1.00 for R2004    04/2004            Author www.PAUsoft.dk   *
; *                                                                         *
; *                        0                                        *
; *                        4                                            *
; *                        5    GIL                              *
; *                        6    VFE                           *
; *                        7  -                                   *
; *                        8                                         *
; *                                                                         *
; *  Global variables:                                                      *
; *                                                                         *
; *    VER            : version number                                      *
; *                                                                         *
; *    VELUX-DIR      : the directory                                       *
; *                                                                         *
; *    USER-GT        : list containing the window thickness                *
; *                                                                         *
; *    USER-VAR       : list containing the system variables.               *
; *    USER-LAG       : list containing the current layer.                  *
; *    USER-DATA      : list containing the last data.                      *
; *                                                                         *
; *    USER-TYP-LIS   : list containing the                                 *
; *    USER-TYP-LIS-3D: list containing the                                 *
; *                                                                         *
; *    USER-C1        : list containing the color for Pane                  *
; *    USER-C2        : list containing the color for Sash/Frame            *
; *    USER-C3        : list containing the color for Metall sheet          *
; *    USER-C4        : list containing the color for Bfx                   *
; *    USER-C5        : list containing the color for Interior lining       *
; *    USER-C6        : list containing the color for Accessories           *
; *    USER-C8        : list containing the color for Hatching              *
; *    USER-C10       : list containing the layer for Productcode           *
; *                                                                         *
; *    USER-L1        : list containing the layer for Pane                  *
; *    USER-L2        : list containing the layer for Sash/Frame            *
; *    USER-L3        : list containing the layer for Metall sheet          *
; *    USER-L4        : list containing the layer for Bfx                   *
; *    USER-L5        : list containing the layer for Interior lining       *
; *    USER-L6        : list containing the layer for Accessories           *
; *    USER-L8        : list containing the layer for Hatching              *
; *    USER-L10       : list containing the layer for Productcode           *
; *                                                                         *
; *    USER-T10       : text attributes.                                    *
; *    USER-SC-TXT    : text scalefactor.                                   *
; *    USER-IP        : insertion point.                                    *
; *    USER-SCALE     : the scale factor for block                          *
; *                                                                         *
; *                                                                         *
; *                                                                         *
; *  Functions defined and used by this program:                            *
; *                                                                         *
; *     get-3d-l                                                            *
; *     get-gir                                                             *
; *                                                                         *
; *     ss-add                                                              *
; *                                                                         *
; *     rot-3d-prep                                                         *
; *     rot-3d-do                                                           *
; *     do-bl-3                                                             *
; *     do-block-3                                                          *
; *                                                                         *
; *     boks                                                                *
; *     k-tegn                                                              *
; *     flas                                                                *
; *     pss-boks                                                            *
; *     ptb-tegn                                                            *
; *     psx-tegn                                                            *
; *     psl-tegn                                                            *
; *     psr-tegn                                                            *
; *     red-lix                                                             *
; *     red-lin                                                             *
; *     b-tegn                                                              *
; *     m-tegn                                                              *
; *     f-tegn                                                              *
; *     gir-glass                                                           *
; *                                                                         *
; *     i-3d-0                                                              *
; *     i-3d-1                                                              *
; *     i-3d-2                                                              *
; *     i-3d-3                                                              *
; *     i-3d-4                                                              *
; *                                                                         *
; *                                                                         *
; *                                                                         *
; *  Files using by this program                                            *
; *                                                                         *
; *     velux.dcl                                                           *
; *     velux.dwg                                                           *
; *     velux.shx                                                           *
; *     velux.mnu                                                           *
; *     velux.cfg                                                           *
; *                                                                         *
; *  Revision :                                                             *
; *                                                                         *
; ***************************************************************************

  ;(prompt "VELUX .........")
  ;(grtext -1 "VELUX .........")

;==============================================================================
;******************************************************************************
;    V E L U X   productinformation
;******************************************************************************
;==============================================================================
;-----------------------------------------------------------
;------------   04/2004 --------------
;-----------------------------------------------------------
(defun c:VELUX-test () (setq paucheck t) (c:VELUX-1))
;-----------------------------------------------------------
(setq VELUX-DIR "./")
;------------------------------------------------------------------------------
(setq USER-DATA    '(0 "2d-l-o" 45
		    ((0 0 1 0)(300 0 0))
                    ("") ("") ("") ("") ("") )
      USER-ROT     t)
;------------------------------------------------------------------------------
;(kombitype slide text dc-min dc-max function dialogbox win-list dist-list size-list)
(setq U-KOMBI '(
  (0 "einzel" " "
     15 90 vx_0  "vx_0_a"
   '(("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GXL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU" "GTU"))
   nil nil)
  (4 "komblk" " "
     15 90 vx_4  "vx_4_a"
   '(("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GXL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU" "GTU"))
   '(((100 "100 ") (140 "140 ")) ((100 "100 ") (250 "250 "))) nil)
  (5 "komgil" "  GIL/GIU"
     15 90 vx_56 "vx_56_a"
   '(("GIL" "GIU") ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GGU" "eGGU" "bGGU" "GPU" "GTU"))
   nil nil)
  (6 "komvfe" "  . -"
     15 55 vx_56 "vx_56_a"
   '(("VFE" "VFA" "VFB" "VIU") ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GGU" "eGGU" "bGGU" "GPU" "GTU"))
   nil nil)
  (7 "balkon" "-  "
     35 53 vx_78 "vx_78_a"
   '(("..." "GIL") ("..." "GDL" "GGL" "GPL"))
   '(((100 "100 ") (140 "140 ")) ()) '(("P34") ("P10" "P19")))
  (8 "terras" "  "
     35 53 vx_78 "vx_78_a"
   '(("..." "VEA" "VEB" "VEC") ("..." "GEL"))
   '(((100 "100 ")) ()) '(("M35") ("M08")))
))
;------------------------------------------------------------------------------
;(text drawingfunction)
(setq U-DRAW '(
  ("2d-r"  "2D  "      )
  ("2d-h"  " 2D "   )
  ("2d-l"  "2D  "       )
  ("2d-p"  "2D    "     )
  ("2d-e"  "2D    "    )
  ("3d-c"  "3D "         )
 ;("3d-a"  " 3D  ")
  ("3d-o"  "3D "            )
 ;("2d-r-o" "2D  , ")
 ;("2d-l-o" "2D  , " )
))
;------------------------------------------------------------------------------
(setq USER-TYP-LIS '(
;------------------------------------------------------------------------------
; type  text  roofpitchmin/max  size variantcode  dialogboxtextline
  ("bGGL" ".  "          15 90
     ("F04" "F06" "M04" "M06" "M08" "M10" "M12" "P04" "P06" "P08" "P10" "S06" "S08" "S10" "U04" "U08" "U10")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("   " " "))
  ("bGGU" ".  "          15 90
     ("F04" "F06" "M04" "M06" "M08" "P06" "P08" "S06" "S08")
     ("0073" "0173" "0373" "0873")
     ("   " " "))
  ("eGGL" ".  Integra"          15 90
     ("C02" "C04" "F04" "F06" "M04" "M06" "M08" "M10" "M12" "P04" "P06" "P08" "P10" "S06" "S08" "S10" "U04" "U08" "U10")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     (" ,     " " "))
  ("eGGU" ".  Integra"          15 90
     ("C02" "C04" "F04" "F06" "M04" "M06" "M08" "P06" "P08" "S06" "S08")
     ("0073" "0173" "0373" "0873")
     (" ,     " " "))
  ("GGL" " "            15 90
     ("C02" "C04" "F04" "F06" "M04" "M06" "M08" "M10" "M12" "P04" "P06" "P08" "P10" "S06" "S08" "S10" "U04" "U08" "U10")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("   " " "))
  ("GGU" " "            15 90
     ("C02" "C04" "F04" "F06" "M04" "M06" "M08" "P06" "P08" "S06" "S08")
     ("0073" "0173" "0373" "0873")
     ("    " " "))
  ("GHL" "-.  30"      15 55
     ("C04" "F06" "M04" "M06" "M08" "P04" "S06" "S08" "U04")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("    30" " "))
  ("GPL" "-.  45"      15 55
     ("M06" "M08" "M10" "P06" "P08" "P10" "S06" "S08" "U08")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("    45" " "))
  ("GPU" "-.  45"      15 55
     ("C04" "F06" "M04" "M06" "M08" "M10" "P06" "P08" "P10" "S06" "S08")
     ("0073" "0173" "0373" "0873")
     ("    45" " "))
  ("GTL" "   "              20 65
     ("M08")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("      70" " "))  
  ("GTU" "   "              20 65
     ("M08")
     ("0073" "0173" "0373" "0873")
     ("      70" " "))
  ("GXL" "  "              15 85
     ("F06")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("     " " "))
  ("G64" ". ."         15 90
     ("C04" "F04" "F06" "M04" "M06" "M08" "P06" "P08" "S06")
     ("3064" "3164" "3364" "3864" "2064" "2164" "2364" "2864")
     ("Uw = 0,9 /2K" " "))
  ("G62" ". . ."         15 90
     ("C04" "F04" "F06" "M04" "M06" "M08" "M10" "P06" "P08" "P10" "S06" "S08")
     ("3062" "3162" "3362" "3862" "2062" "2162" "2362" "2862")
     ("Rw = 42 " " "))
  ("GIL" " "               15 90
     ("M34" "P34" "S34" "U34")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("  " " "))
  ("GIU" " "               15 90
     ("M34" "P34" "S34")
     ("0073" "0173" "0373" "0873")
     ("  " " "))
  ("VFE" " - "          15 55
     ("M31" "P31" "S31" "U31" "M34" "P34" "S34" "U34")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("       ."
      " "))
  ("VFA" "/. . " 15 55
     ("M34" "P34" "S34" "M36" "P36" "S36" "M38" "P38" "S38")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("/    ,   "
      " "))
  ("VFB" "/. . " 15 55
     ("M34" "P34" "S34" "M36" "P36" "S36" "M38" "P38" "S38")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("/    ,   "
      " "))
  ("VIU" "  " 15 55
     ("M34" "P34" "S34")
     ("0073" "0173" "0373" "0873")
     (" "  " "))
  ("GDL" "-"               35 53
     ("P19") ;P10
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("VIU 'WAND EVERFINISH',   ,     GGU,"
      "GPU  GTU    .          15  55."))
; for logic of bottom GDL
  ("   " "-"               35 53
     ("P34") ; not P04
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("    " " "))
		     
  ("GEL" "-.  45"     35 53
     ("M08")
      ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("    " " "))
  ("VEA" "  "           35 53
     ("M35")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("    " " "))
  ("VEB" "  "           35 53
     ("M35") 
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
     ("    " " "))
  ("VEC" "  "           35 53
     ("M35")
     ("3073" "3173" "3373" "3873" "2073" "2173" "2373" "2873")
      ("    " " "))

;------------------------------------------------------------------------------
; ------  flashings  ------
;------------------------------------------------------------------------------
; type  text  roofpitchmin/max  size variantcode dialogboxtextline
;SINGLE
  ("EDH" "" 15 90
     ()
     ("1000" "1100" "1300" "1800")
     (" " " "))
  ("EDW" "" 15 90
     ()
     ("1000" "1100" "1300" "1800")
     (" " " "))
  ("EDS" "" 15 90
     ()
     ("1000" "1100" "1300" "1800")
     (" " " "))
  ("EDE" "" 15 90
      ()
     ("0100" "0400" "0300"))
; ??		     
  ("ETW" "" 15 90
     ()
     ("0000" "0100" "0300" "0800")
     (" " " "))
  ("ETS" "" 15 90
     ()
     ("0000" "0100" "0300" "0800")
     (" " " "))
;ROOF/VERTICAL
  ("EFW" "" 15 55
     ()
     ("1000" "1100" "1300" "1800")
     (" " " "))
  ("EFS" "" 15 55
     ()
     ("1000" "1100" "1300" "1800")
     (" " " "))
;COMBI 100
  ("EKH" "" 15 90
     ()
     ("1000" "1100" "1300" "1800")
     (" " " "))
  ("EKS" "" 15 90
     ()
     ("1000" "1100" "1300" "1800")
     (" " " "))
  ("EKX" "" 15 90
     ()
     ("0000" "0100" "0300" "0800")
     (" " " "))
  ("EKW" "" 15 90
     ()
     ("0000" "0100" "0300" "0800")
     (" " " "))
; ??		     
  ("EEW" "" 35 53
     ()
     ("0000" "0100" "0300" "0800")
     (" " " "))
  ("EES" "" 35 53
     ()
     ("0000" "0100" "0300" "0800")
     (" " " "))
  ("EEX" "" 35 53
     ()
     ("0000" "0100" "0300" "0800")
     (" " " "))
;------------------------------------------------------------------------------
; ------  installation product  ------
;------------------------------------------------------------------------------
; type  text  min/max  size variantcode dialogboxtextline
  ("BBX" " " 15 90
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GXL" "G64" "G62"
      "GGU" "eGGU" "bGGU" "GPU" "GTU" "GIL" "GIU" "GDL" "GEL")
     ("0000")
     (" " " "))
  ("BFX" " " 15 90
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GXL" "G64" "G62"
      "GGU" "eGGU" "bGGU" "GPU" "GTU" "GIL" "GIU" "GDL" "GEL")
     ("0000")
     (" " " "))
;------------------------------------------------------------------------------
; ------  linnings  ------
;------------------------------------------------------------------------------
; type  text  min/max  win variantcode dialogboxtextline
  ("LGI"    " " 0 0
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GXL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU"
      "GTU" "GIL" "GIU" "VIU" "VFE" "VFA" "VFB" "GDL" "   " "GEL" "VEA" "VEB" "VEC")
     ("0000" "3000" "2000");
     (" " " "))

  ("LSC"    "" 125 400
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GXL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU" "GTU")
     ("2002")
     ("    ! "  "  "))
;------------------------------------------------------------------------------
; ------  accessories  ------
;------------------------------------------------------------------------------
; type  text  win variantcode dialogboxtextline         ; "   " is bottom GDL !
  ("FHL"    "-"
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GXL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU" "GTU"
      "GIL" "GIU" "VFE" "VFA" "VFB" "GDL" "   " "GEL" "VEA" "VEB" "VEC")
     ("9999")
     (" " " "))
  ("FML"    "-  "
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU" "GTU"
      "GIL" "GIU" "VFE" "GEL")
     ("9999")
     (". ,    "
     " "))
  ("PAL"    ""
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GXL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU" "GTU"
      "GIL" "GIU" "VFE" "VFA" "VFB" "GDL" "   " "GEL" "VEA" "VEB" "VEC")
     ("9999")
     (" " " "))
  ("PML"    "  "
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU" "GTU"
      "GIL" "GIU" "VFE" "GEL")
     ("9999")
     (". ,    "
     " "))
  ("DKL"    " "
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GXL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU" "GTU"
      "GIL" "GIU" "VFE" "VFA" "VFB" "GDL" "   " "GEL" "VEA" "VEB" "VEC")
     ("9999")
     (" " " "))
  ("DML"    "   ."
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU" "GTU"
      "GIL" "GIU" "VFE" "GEL")
     ("9999")
     (". ,    "
     " "))
  ("RHL"    " "
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GXL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU" "GTU"
      "GIL" "GIU" "VFE" "VFA" "VFB" "GDL" "   " "GEL" "VEA" "VEB" "VEC")
     ("9999")
     (" " " "))
  ("RML"    "   "
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU" "GTU"
      "GIL" "GIU" "VFE" "GEL")
     ("9999")
     (". ,    "
     " "))
  ("MHL"    "" ;GDL only top!
     ("GGL" "GHL" "GPL" "GTL" "G64" "G62" "GGU" "GPU" "GTU" "GDL" "GEL")
     ("9999")
     (" " " "))
  ("MAL"    "  " ;GDL only top!
     ("GGL" "GHL" "GPL" "GTL" "GGU" "GPU" "GTU" "GDL" "GEL")
     ("9999")
     (" " " "))
  ("MML"    "  " ;GDL only top!
     ("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU" "GTU" "GEL")
     ("9999")
     (". ,    "
     " "))
  ("SCL"    ""
     ("GGL" "eGGL" "GHL" "GPL" "GGU" "eGGU" "bGGU" "GPU")
     ("0000" "0700")
     (" " " "))
  ("SML"    "  "
     ("GGL" "eGGL" "GHL" "GPL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU")
     ("0000" "0700")
     (". ,    "
      " "))
  ("SSL"    "   " 
     ("GGL" "eGGL" "GHL" "GPL" "G64" "G62" "GGU" "eGGU" "bGGU" "GPU")
     ("0000" "0700")
     (".    ,   "
      " "))
  ("" "" 0 90
     ("")
     ("")
     ("" ""))
  ("..."    "..." 0 90
     ("")
     ("")
     ("" ""))
))
;------------------------------------------------------------------------------
;(text code)
(setq U-WIN-MAT1 '(
  ("3"  ". ,  ")
  ("2"  ". ,  " )
  ("0"  "  "  )
))
;------------------------------------------------------------------------------
;(text code)
(setq U-WIN-MAT2 '(
  ("0" "  ")
  ("1" ""         )
  ("3" "- "      )
  ("8" "   RAL"      )
))
;------------------------------------------------------------------------------
;(text code)
(setq U-WIN-MAT34 '(
  ("62" "    ")
  ("64" " ") 
  ("73" "  ")
))
;------------------------------------------------------------------------------
;(text code)
(setq U-FLA-MAT1 '(
  ("1"  " ")
  ("0"  "")
))
;------------------------------------------------------------------------------
;(text code)
(setq U-FLA-MAT2 '(
  ("0" "  ")
  ("1" ""         )
  ("3" "- "      )
  ("8" "   RAL"      )
))
;------------------------------------------------------------------------------
;(text code)
(setq U-FLA-MAT3 '(
  ("0"  "")
))
;------------------------------------------------------------------------------
;(text code)
(setq U-FLA-MAT4 '(
  ("0" "")
  ("1" " " )
  ("2" "  " )
  ("3" " ")
  ("4" " "  )
  ("5" "  "  )
  ("6" " " )
  ("7" " ")
))
;------------------------------------------------------------------------------
;(text code)
(setq U-FLA-MAT5 '(
  ("E"  ". 100 .")
  ("G"  ". 140 .")
  ("J"  ". 250 .")
))
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
;(text code)
(setq U-LIN-MAT1 '(
  ("2" "  ")
  ("3" "")
))
;------------------------------------------------------------------------------
;(text code)
(setq U-LIN-MAT2 '(
  ("0"  "")
))
;------------------------------------------------------------------------------
;(text code)
(setq U-LIN-MAT34 '(
  ("00"  "    ")
  ("02"  "   "      )
))
;------------------------------------------------------------------------------
;(text code)
(setq U-LIN-MAT '(
  ("2002" "  ")
  ("3000" "  ")
))
;==============================================================================
;******************************************************************************
;    V E L U X   menu
;******************************************************************************
;==============================================================================
(Defun C:velux-menu ()
  (command "_menuunload" "VELUX")
  (if (findfile (strcat VELUX-DIR "VELUX.mnu"))
    (progn
      (command "_menuload" (strcat VELUX-DIR "VELUX.mnu"))
      (menucmd "P16=+VELUX.POP1"))
    (progn
      (alert (strcat "no menu ")) )) )
;==============================================================================
;******************************************************************************
;    V E L U X   productdata
;******************************************************************************
;==============================================================================
(setq USER-SIZ-LIS '(
;------------------------------------------------------------------------------
; sizecode  text  width  height  lightarea ventilationarea
  ("W20" "2000 "          18 2000)
  ("W27" "2750 "          18 2750)
  ("W35" "3500 "          18 3500)
                     
  ("C25" "550 x 550 "    550  550)
  ("C01" "550 x 698 "    550  698)
  ("C02" "550 x 778 "    550  778)
  ("C04" "550 x 978 "    550  978)
  ("C06" "550 x 1178 "   550 1178)
  ("C08" "550 x 1398 "   550 1398)
  ("C10" "550 x 1600 "   550 1600)
  ("C12" "550 x 1800 "   550 1800)
                     
  ("F25" "660 x 660 "    660  660)
  ("F01" "660 x 698 "    660  698)
  ("F02" "660 x 778 "    660  778)
  ("F04" "660 x 978 "    660  978)
  ("F06" "660 x 1178 "   660 1178)
  ("F08" "660 x 1398 "   660 1398)
  ("F10" "660 x 1600 "   660 1600)
  ("F12" "660 x 1800 "   660 1800)
                     
  ("M25" "780 x 780 "    780  780)
  ("M01" "780 x 698 "    780  698)
  ("M02" "780 x 778 "    780  778)
  ("M04" "780 x 978 "    780  978)
  ("M06" "780 x 1178 "   780 1178)
  ("M08" "780 x 1398 "   780 1398)
  ("M10" "780 x 1600 "   780 1600)
  ("M12" "780 x 1800 "   780 1800)
                     
  ("P25" "942 x 942 "    942  942)
  ("P01" "942 x 698 "    942  698)
  ("P02" "942 x 778 "    942  778)
  ("P04" "942 x 978 "    942  978)
  ("P06" "942 x 1178 "   942 1178)
  ("P08" "942 x 1398 "   942 1398)
  ("P10" "942 x 1600 "   942 1600)
  ("P12" "942 x 1800 "   942 1800)
                     
  ("S25" "1140 x 1140 "   1140 1140)
  ("S01" "1140 x 698 "    1140  698)
  ("S02" "1140 x 778 "    1140  778)
  ("S04" "1140 x 978 "    1140  978)
  ("S06" "1140 x 1178 "   1140 1178)
  ("S08" "1140 x 1398 "   1140 1398)
  ("S10" "1140 x 1600 "   1140 1600)
  ("S12" "1140 x 1800 "   1140 1800)
                     
  ("U25" "1340 x 1340 "   1340 1340)
  ("U01" "1340 x 698 "    1340  698)
  ("U02" "1340 x 778 "    1340  778)
  ("U04" "1340 x 978 "    1340  978)
  ("U06" "1340 x 1178 "   1340 1178)
  ("U08" "1340 x 1398 "   1340 1398)
  ("U10" "1340 x 1600 "   1340 1600)
  ("U12" "1340 x 1800 "   1340 1800)

  ("M31" "780 x 620 "    780  620)
  ("P31" "942 x 620 "    942  620)
  ("S31" "1140 x 620 "  1140  620)
  ("U31" "1340 x 620 "  1340  620)
                     
  ("M34" "780 x 974 "    780  974)
  ("P34" "942 x 974 "    942  974)
  ("S34" "1140 x 974 "  1140  974)
  ("U34" "1340 x 974 "  1340  974)
                     
  ("M36" "780 x 1174 "    780  1174)
  ("P36" "942 x 1174 "    942  1174)
  ("S36" "1140 x 1174 "  1140  1174)
  ("U36" "1340 x 1174 "  1340  1174)
                     
  ("M38" "780 x 1394 "    780  1394)
  ("P38" "942 x 1394 "    942  1394)
  ("S38" "1140 x 1394 "  1140  1394)
  ("U38" "1340 x 1394 "  1340  1394)
                     
  ("M50" "780 x 570 "    780  570)
  ("P50" "942 x 570 "    942  570)
  ("S50" "1140 x 570 "  1140  570)
  ("U50" "1340 x 570 "  1340  570)
  ("M51" "780 x 680 "    780  680)
  ("P52" "942 x 820 "    942  820)
  ("S54" "1140 x 990 "  1140  990)
  ("U56" "1340 x 1160 " 1340 1160)
                     
; GVA
  ("___" "460 x 610 "  460 610)
; GVO
  ("..." "540 x 760 "  540 760)
; GVT
  ("103" "540 x 830 "  540 830)
  ("154" "560 x 980 "  560 980)
; VLT
  ("---" "460 x 610 "  460 610)
; GIL & GIU
  ("M34-"  "780 x 920 "  780  920)
  ("P34-"  "942 x 920 "  942  920)
  ("S34-" "1140 x 920 " 1140  920)
  ("U34-" "1340 x 920 " 1340  920)
; VIU 
  ("M34_"  "780 x 989 "  780  989)
  ("P34_"  "942 x 989 "  942  989)
  ("S34_" "1140 x 989 " 1140  989)
  ("U34_" "1340 x 989 " 1340  989)
; GEL
  ("M08-" "780 x 1360 "  780 1360)
  ("M35"  "780 x 1090 "  780 1090)
; GDL CABRIO                     
  ("P19" "942 x 2520 "   942 2520)
                     
  (""    ""                  0    0)
))
;------------------------------------------------------------------------------
(setq U-SIZ-LET '("B" "C" "F" "M" "P" "S" "U"))
;------------------------------------------------------------------------------
(setq U-WIN '("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "G62" "G64"
	      "GGU" "eGGU" "bGGU" "GPU" "GTU"
	      "GIL" "GIU" "GDL"
	      "VFE" "VFA" "VFB" "VIU"
	      "VEA" "VEB" "VEC" "GEL"
	      "cGGL" "cGPL"
	      "GVO" "GVT" "GVA" "VLT"))
(setq U-FLA-NON '("VFE" "VFA" "VFB" "VIU" "VEA" "VEB" "VEC"))
(setq U-RED-TOP '("GZL" "GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "GXL" "G62" "G64" "cGGL" "cGPL"
	          "GGU" "eGGU" "bGGU" "GPU" "GTU" "GDL-t" "GDL-b" "GEL"
		  "GIR" "GID" "GIV" "GVA" "VLT" "GVO" "GVT"))
(setq U-RED-BOT '("GGL" "eGGL" "bGGL" "GHL" "GPL" "GTL" "G62" "G64" "cGGL" "cGPL" "FRS" "eFRS"
                  "GGU" "eGGU" "bGGU" "GPU" "GTU" "GIL" "GIU" "GDL-b"))
;------------------------------------------------------------------------------
;(setq U-FLA-PRO '("EDH" "EBH" "EKH"
;                  "EDZ" "EBZ" "EKZ" "EAZ" "EUZ"
;                  "EDW" "EBW" "EKW" "EFW" "ETW" "EEW" "EAW" "EUW"))
(setq U-FLA-PRH '("EDH" "EBH" "EKH"))
(setq U-FLA-PRZ '("EDZ" "EBZ" "EKZ" "EAZ" "EUZ"))
(setq U-FLA-PRW '("EDW" "EBW" "EKW" "EFW" "ETW" "EEW" "EAW" "EUW"))

(setq U-FLA-FLL '("EDL" "EBL" "EKL" "EFL" "ETL" "EEL"))
(setq U-FLA-FLS '("EDS" "EBS" "EKS" "EFS" "ETS" "EES" "EAS" "EUS"))
(setq U-FLA-EDN '("EDN"))

(setq U-FLA-EDE '("EDE" "EKE" "EFE"))
(setq U-FLA-EDB '("EDB"))
(setq U-FLA-EDP '("EDP"))

(setq U-FLA-BTW '("EKH" "EKW" "EKL" "EKS" "EKE"
		  "EKX" "ETX" "EEX"
		  "EEW" "EKK" "ETN"))

(setq U-FLA (append U-FLA-FLS U-FLA-FLL U-FLA-BTW
		    U-FLA-PRH U-FLA-PRZ U-FLA-PRW
		    U-FLA-EDP U-FLA-EDN U-FLA-EDE))
;------------------------------------------------------------------------------
(setq U-LIN '("LGI" "LSB" "LSC" "LSD" "LST"))
;------------------------------------------------------------------------------
(setq U-DIS-CODE '((0   "")
		   (18  "")
		   (50  "N")
                   (100 "E")
		   (120 "F")
		   (140 "G")
                   (160 "H")
                   (250 "J")))
;------------------------------------------------------------------------------
(setq U-GLASS-TIK '(
  ("00" 24)
  ("12" 15)
  ("25" 15)
  ("31" 15)
  ("47" 15)
  ("48" 15)
  ("53" 15)
  ("54" 24)
  ("74" 15)
  ("75" 15)
  ("78" 15)
                    
  ("21" 17)
  ("33" 17)

  ("01" 24)
  ("02" 24)
  ("13" 24)
  ("22" 24)
  ("23" 24)
  ("24" 24)
  ("26" 24)
  ("27" 24)
  ("34" 24)
  ("41" 24)
  ("43" 24)
  ("44" 24)
  ("45" 24)
  ("46" 24)
  ("57" 24)
  ("58" 24)
  ("59" 24)
  ("60" 24)
  ("72" 24)
  ("73" 24)
  ("76" 24)
       
  ("56" 27)
  ("61" 27)
  ("62" 25)
  ("64" 26)
                    
  ("63" 10)
                    
  ("59S" 16)
                    
  ("93"  4)
  ("94"  4)
  (""  4);CLI
                    
  ("xx"  4)
))
;------------------------------------------------------------------------------
;============================================================================
;*************************************************************************
;    selection set
;*************************************************************************
;============================================================================
(defun ss-add (SS1 SS / M I)
  (setq M (sslength SS1)
        I 0)
  (while (< I M)
    (ssadd (ssname SS1 I) SS)
    (setq I (1+ I)))
  SS)
;==============================================================================
;*************************************************************************
;    trigonometriske  funktioner
;*************************************************************************
;==============================================================================
(defun get-tri-c (VA VB LA LB)
  (cond ((and VA LA) (/ LA (sin VA)))
        ((and VA LB) (/ LB (cos VA)))
        ((and VB LA) (/ LA (cos VB)))
        ((and VB LB) (/ LB (sin VB))) ))
;==============================================================================
(defun get-tri-a (VA VB LB LC)
  (cond ((and VA LC) (* LC (sin VA)) )
        ((and VA LB) (/ (* LB (sin VA)) (cos VA)) )
        ((and VB LC) (/ LC (cos VB)) )
        ((and VB LB) (/ (* LB (cos VB)) (sin VB)) ) ))
;==============================================================================
(defun get-tri-b (VA VB LA LC)
  (cond ((and VA LC) (* LC (cos VA)) )
        ((and VA LA) (/ (* LA (cos VA)) (sin VA)) )
        ((and VB LC) (/ LC (sin VB)) )
        ((and VB LA) (/ (* LA (sin VB)) (cos VB)) ) ))
;============================================================================
(defun memb (L1 ML / L M)
  (setq M nil)
  (foreach L L1 (if (member L ML) (setq M t)))
  M)
;==============================================================================
;******************************************************************************
;    V E L U X   initialize
;******************************************************************************
;==============================================================================
(defun velux-ini ( / FN N TOG)
  (if paucheck (princ "\nvelux-ini"))
  (if (or (not USER-SC-TXT)(not USER-SCALE)(not USER-IP))
    (if (findfile (strcat VELUX-DIR "velux.cfg"))
      (load (strcat VELUX-DIR "velux.cfg"))) )
  (setq N 1)
  (repeat 10
    (if (not (eval (read (strcat "USER-C" (itoa N)))))
      (set (read (strcat "USER-C" (itoa N))) "256"))
    (if (not (eval (read (strcat "USER-L" (itoa N)))))
      (set (read (strcat "USER-L" (itoa N))) "0"))
    (setq N (1+ N)))
  (foreach TOG '("8" "9" "10")
    (if (not (eval (read (strcat "USER-T" (itoa N)))))
      (set (read (strcat "USER-T" (itoa N))) "on")))
  (if (not USER-SC-TXT) (setq USER-SC-TXT 1))
  (if (not USER-SCALE) (setq USER-SCALE 1))
  (if (not USER-IP) (setq USER-IP "bot")) )
;==============================================================================
;******************************************************************************
;    V E L U X         2d and 3d generator
;******************************************************************************
;==============================================================================
(DeFun ins-fen (INS-P NR SCH PIT AFS
		TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS TGA5-LIS ENAM
               / I-E SC SS E TL0 TL1 TL2 TL3 TL4 SSB BN T4L I-P
                 AU SIZ1 SIZ2 P-NR DY1 DY2 DY3 BN-NR
                 TGA1-L TGA4-L N ANT)
;------------------------------------------------------------------------------
  (defun pr-lis (PL LL SL STRING / L)
    (foreach L LL
      (setq LLL (cond ((eq 'INT (type L))  (itoa L))
		      ((eq 'REAL (type L)) (rtos L))
		      (t L))
	    PL (if STRING
		 (strcat PL (chr 34) LLL (chr 34) (chr 32))
		 (strcat PL LLL (chr 32)))))
    (strcat PL SL))
;------------------------------------------------------------------------------
  (command "_.undo" "_begin")
  (velux-ini)
  (if (and (> (length TGA1-LIS) 0)
           (not (eq "" (car TGA1-LIS))) )
    (progn
      (if (not INS-P)
        (setq INS-P (getvar "viewctr"))
        (setq I-E t))
      (if (and (not 3d)
               (member SCH '("3d-c" "3d-a" "3d-o")))
        (load (strcat VELUX-DIR "velux_3.lsp")))
      (if (and (or (not ins-2d-v) (not ins-2d-h) (not ins-2d-p))
               (member SCH '("2d-l" "2d-r" "2d-l-o" "2d-r-o"
			     "2d-h" "2d-e" "2d-p")))
        (load (strcat VELUX-DIR "velux_2.lsp")))
      (if (member SCH '("3d-c" "3d-a" "3d-o"))
        (progn
          (if ENAM
            (setq INS-P (trans INS-P ENAM 0))
            (setq INS-P (trans INS-P 1 0)) )
          (rot-3d-prep)))
      (setq USER-ROT-VENT (if (member SCH '("3d-a" "3d-o" "2d-l-o" "2d-r-o"))
                            t nil)
            USER-ROT-SASH (if (member SCH '("3d-o" "2d-l-o" "2d-r-o"))
                            t nil))
      (if (eq 1 NR)
        (progn
          (setq T4L TGA4-LIS)
          (if (eq "EBY" (get-typ (last TGA1-LIS)))
           (repeat (/ (length TGA4-LIS) 2)
             (setq TGA4-LIS (append TGA4-LIS '("") '(""))) )) ))
      (if PAUCHECK
	(progn
	  (princ "\n")(print TGA1-LIS)
	  (princ "\n")(print TGA2-LIS)
	  (princ "\n")(print TGA3-LIS)
	  (princ "\n")(print TGA4-LIS)
 	  (princ "\n")(print TGA5-LIS) ))
     (setq SS
        (cond ((member SCH '("3d-c" "3d-a" "3d-o"))
                (ins-3d NR INS-P PIT AFS TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS))
	      ((member SCH '("2d-r" "2d-r-o"))
                 (ins-2d-v 1 NR INS-P PIT AFS TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS))
	      ((member SCH '("2d-l" "2d-l-o"))
                 (ins-2d-v -1 NR INS-P PIT AFS TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS))
	      ((member SCH '("2d-h"))
                 (ins-2d-h NR INS-P PIT AFS TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS))
	      ((member SCH '("2d-e"))
                 (ins-2d-p t NR INS-P PIT AFS TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS))
	      ((member SCH '("2d-p"))
                 (ins-2d-p nil NR INS-P PIT AFS TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS)) ))
      (if (eq 1 NR)
        (setq TGA4-LIS T4L))
      (if (and (eq USER-IP "top")
               (eq "POINT" (cdr (assoc 0 (entget (entlast))))))
        (setq I-P (cdr (assoc 10 (entget (entlast))))))
      (if (eq "POINT" (cdr (assoc 0 (entget (entlast)))))
        (command "_.erase" (entlast) ""))
      (if (findfile (strcat VELUX-DIR "velux.dwg"))
        (progn
          (setq TL0 (pr-lis "((" (car AFS) ")(" nil)
                TL0 (pr-lis TL0 (cadr AFS) "))" nil)
                TL1 (pr-lis "(" TGA1-LIS ")" t)
                TL2 (pr-lis "(" TGA2-LIS ")" t)
                TL3 (pr-lis "(" TGA3-LIS ")" t)
                TL4 (pr-lis "(" TGA4-LIS ")" t)
                TL5 (pr-lis "(" TGA5-LIS ")" t)
                SSB (ssadd))
          (command "_.insert" (strcat VELUX-DIR "velux.dwg")
                              INS-P 10 10 0 (itoa NR)
		              (strcat (chr 34) SCH (chr 34))
		              (rtos PIT)
                              TL0 TL1 TL2 TL3 TL4 TL5)
          (setq SSB (ssadd (entlast) SSB)))
        (progn
          (command "_.text" INS-P 50 0 (strcat VELUX-DIR "velux"))
          (setq SSB (ssadd (entlast) SSB))))
      (setq TL (reverse TGA1-LIS))
      (foreach T-L (list (reverse TGA2-LIS)(reverse TGA3-LIS)
			 (reverse TGA4-LIS)(reverse TGA5-LIS))
        (if (not (eq "" (car T-L)))
          (setq TL (append TL T-L))))
      (setq BN (strcat "velux-"
                            (substr (rtos (getvar "date") 2 10) 1 7)
                            "-"
                            (substr (rtos (getvar "date") 2 10) 9 9))
            SIZ1 (/ (caddr (assoc (get-siz (car TL)) USER-SIZ-LIS)) 2.0)
            SIZ2 (cadddr (assoc (get-siz (car TL)) USER-SIZ-LIS))
            SIZ3 (/ (cadddr (assoc (get-siz (car TL)) USER-SIZ-LIS)) 2.0)
            P-NR (cond ((member SCH '("2d-r" "2d-r-o"))
                          (polar INS-P (- pi (dtr PIT)) SIZ2))
                       ((member SCH '("2d-h"))
                          (polar INS-P pi SIZ1))
                       ((member SCH '("2d-l" "2d-l-o"))
                          (polar INS-P (dtr PIT) SIZ2))
                       ((eq "2d-p" SCH)
                          (polar INS-P 0 SIZ1))
                       ((eq "2d-e" SCH)
                          (polar INS-P 0 SIZ1))
                       ((member SCH '("3d-c" "3d-a" "3d-o"))
                          (polar INS-P 0 SIZ1)) )
            DY1  (+ 150 (* 30 (length TL)))
            DY2  (* (abs (sin (dtr PIT))) 200)
            DY3  50
            P-NR (cond ((member SCH '("2d-p" "2d-e"))
                          (list (- (car P-NR) 100)
                                (+ (cadr P-NR) DY1)
                                (caddr P-NR)))
                       ((member SCH '("2d-r" "2d-r-o"))
                          (list (- (car P-NR)
                                   (if (< PIT 60) 100 200))
                                (- (cadr P-NR) DY2)
                                (caddr P-NR)))
                       ((member SCH '("2d-l" "2d-l-o"))
                          (list (- (car P-NR)
                                   (if (< PIT 60) 100 0))
                                (- (cadr P-NR) DY2)
                                (caddr P-NR)))
                       ((member SCH '("2d-h"))
                          (list (- (car P-NR) 100)
                                (- (cadr P-NR) DY3)
                                (caddr P-NR)))
                       ((member SCH '("3d-c" "3d-a" "3d-o"))
                          (list (- (car P-NR) 100)
                                (+ (cadr P-NR) SIZ3)
                                (caddr P-NR))) )
            NR   0
            DY   (* USER-SC-TXT 30.0))
     (if (eq "on" USER-T10)
        (progn
          (setq STY (getvar "textstyle"))
          (command "_.style" "VELUX" (strcat VELUX-DIR "velux.shx") "" "" "" "" "" "")
          (entmake (list '(0 . "ATTDEF")
                        ; '(67 . 0)
                         (cons 8 USER-L10)
                         (cons 62 (atoi USER-C10))
                         (list 10 (car P-NR) (cadr P-NR) (caddr P-NR))
                         (cons 40 (* USER-SC-TXT 25.0))
                         '(1 . "VELUX")'(50 . 0.0)'(41 . 1.0)'(51 . 0.0)
                         (cons 7 (getvar "textstyle"))'(3 . "")(cons 2 "VELUX")
                         '(70 . 8) ))
          (setq SSB (ssadd (entlast) SSB))
          (foreach T-L TL
            (setq NR    (1+ NR)
                  P-NR  (list (car P-NR) (- (cadr P-NR) DY) (caddr P-NR))
                  BN-NR (strcat BN "-" (itoa NR))
                  T-L   (cond ((eq "CLI" (get-typ T-L))
                                 (strcat T-L "0000"))
			      ((eq "M" (substr (get-typ T-L) 2 1)); electric
                                 (strcat T-L (chr 164)))
			      ((and (eq "S" (substr (get-typ T-L) 2 1)); solar
				    (not (member (get-typ T-L) '("LSC" "LSD" "LST"))))
                                 (strcat T-L (chr 166)))
			      ((eq "_" (substr (get-typ T-L) 1 1))
			         (substr T-L 2))
			      (t T-L)) )
            (entmake (list '(0 . "ATTDEF")
                          ; '(67 . 0)
                           (cons 8 USER-L10)
                           (cons 62 (atoi USER-C10))
                           (list 10 (car P-NR) (cadr P-NR) (caddr P-NR))
                           (cons 40 (* USER-SC-TXT 25.0))
                           (cons 1 T-L)
                           '(50 . 0.0)'(41 . 1.0)'(51 . 0.0)
                           (cons 7 (getvar "textstyle"))'(3 . "")(cons 2 T-L)
                           '(70 . 8) ))
            (setq SSB (ssadd (entlast) SSB)) )
          (setvar "textstyle" STY) ))

      (if (member SCH '("3d-c" "3d-a" "3d-o"))
        (progn
          (setq SS-D (if (cadr SS) (cadr SS) (ssadd))
                SS   (car  SS))
          (rot-3d-do SSB INS-P PIT t) )
        (setq SS-D (ssadd)))
      (cond ((and I-P I-E (eq USER-IP "top"))
              (command "_.block" BN I-P SSB SS "") )
            ((and I-P  (eq USER-IP "top"))
              (command "_.block" BN I-P SSB SS "")
              (setq INS-P I-P) )
            (t
              (command "_.block" BN INS-P SSB SS "") ))
      (if (member SCH '("3d-c" "3d-a" "3d-o"))
        (if ENAM
          (progn
            (command "_.ucs" "_ob" ENAM
                     "_.ucs" "_or" (trans '(0 0 0) 0 1))
            (if I-P (setq I-P (trans I-P 0 1)))
            (setq INS-P (trans INS-P 0 1)) )
          (progn
            (if I-P (setq I-P (trans I-P 0 1)))
            (setq INS-P (trans INS-P 0 1)) )) )
      (cond ((and I-P I-E (eq USER-IP "top"))
              (command "_.insert" BN INS-P USER-SCALE USER-SCALE 0) )
            ((and I-P  (eq USER-IP "top"))
              (command "_.insert" BN I-P USER-SCALE USER-SCALE 0)
              (setq INS-P I-P) )
            (t
              (command "_.insert" BN INS-P USER-SCALE USER-SCALE 0) ))
      (if (and (member SCH '("3d-c" "3d-a" "3d-o"))
               (> (sslength SS-D) 0))
	(command "_.scale" SS-D "" INS-P USER-SCALE))
      (setq INS-P (trans INS-P 1 0))
      (if (member SCH '("3d-c" "3d-a" "3d-o"))
        (command "_.ucs" "_r" "VELUX") )
      (setq INS-P (trans INS-P 0 1)
            SS-D  (ssadd (entlast) SS-D))
      (command "_.undo" "_end")
      (list INS-P SS-D))
    (progn
      (alert "OK")
      (list nil nil))))
;==============================================================================
;*************************************************************************
;    Diverse funktioner
;*************************************************************************
;==============================================================================
(defun get-point-lis (E / LIS PL EN)
  (setq LIS (entget E)
        PL '())
  (cond  ((eq "LWPOLYLINE" (cdr (assoc 0 LIS)))
            (while (assoc 10 LIS)
               (setq PL (append (list (cdr (assoc 10 LIS))) PL)
                     LIS (cdr (member (assoc 10 LIS) LIS)) )))
         ((eq "POLYLINE" (cdr (assoc 0 LIS)))
            (setq EN  (entnext E)
                  LIS (entget EN))
            (while (eq "VERTEX" (cdr (assoc 0 LIS)))
               (setq PL (append (list (cdr (assoc 10 LIS))) PL)
                     EN  (entnext EN)
                     LIS (entget EN)))) )
  PL)
;==============================================================================
(defun skift (SS LAY COL / SSH LAY-LIS)
  (if paucheck (princ "\nskift"))
  (setq SSH     (ssadd)
        SSH     (ssadd (entlast) SSH)
        LAY-LIS (list (cdr (assoc 2 (tblnext "layer" t)))))
  (while (setq L (tblnext "layer"))
     (setq LAY-LIS (append LAY-LIS (list (cdr (assoc 2 L))))))
  (if (not (member LAY LAY-LIS))
    (command "_.layer" "_n" LAY ""))
  (if (eq COL "256")
    (command "_.chprop" SSH "" "_la" LAY "")
    (command "_.chprop" SSH "" "_la" LAY "_c" COL ""))
  (ssadd (entlast) SS))
;==============================================================================
(defun ent-pl (SS PLIS LAY COL ROT SK / SSK PA)
  (if paucheck (princ "\nent-pl"))
  (setq SSK (ssadd))
      (setq WWW (if (caddar PLIS) (caddar PLIS) 0.0))
  (if (> (atoi (substr (getvar "acadver") 1 2)) 13)
    (progn
      (setq ENLIS (list
          '(0 . "LWPOLYLINE")
          '(100 . "AcDbEntity")(cons 62 COL) (cons 8 LAY)
          '(100 . "AcDbPolyline")(cons 90 (length (cdr PLIS)))
          '(38 . 0.0) '(39 . 0.0)(cons 40 WWW)(cons 41 WWW)(cons 43 WWW)
      ))
      (if (not (eq 0 (cadar PLIS)))
        (setq ENLIS (append ENLIS (list (cons 70 (cadar PLIS))) )) )
      (foreach PA (cdr PLIS)
        (setq ENLIS (append ENLIS 
                 (list (list 10 (car (car PA))(cadr (car PA))
                                (if (caddr (car PA))(caddr (car PA)) 0.0) )
		       (cons 40 WWW)(cons 41 WWW)(cons 42 (cadr PA)) ))) )
      (entmake ENLIS) )
    (progn
      (if (eq 0 (cadar PLIS))
        (entmake (list '(0 . "POLYLINE")
                       (list 10 (car   (caar  PLIS))
                                (cadr  (caar  PLIS))
                                (if (caddr (caar  PLIS))
                                  (caddr (caar  PLIS))
                                  0.0) )
		       (cons 40 WWW)(cons 41 WWW)(cons 62 COL)(cons 8 LAY)))
        (entmake (list '(0 . "POLYLINE") (cons 70 (cadar   PLIS))
                       (list 10 (car   (caar  PLIS))
                                (cadr  (caar  PLIS))
                                (if (caddr (caar  PLIS))
                                  (caddr (caar  PLIS))
                                  0.0) )
		       (cons 40 WWW)(cons 41 WWW)(cons 62 COL)(cons 8 LAY))) )
      (foreach PA (cdr PLIS)
        (entmake (list '(0 . "VERTEX")
                       (cons 42 (cadr PA))
                       (list 10 (car (car PA))(cadr (car PA))
                                (if (caddr (car PA))
                                  (caddr (car PA))
                                  0.0) )
		       (cons 40 WWW)(cons 41 WWW)(cons 62 COL)(cons 8 LAY))) )
      (entmake '((0 . "SEQEND"))) ))
  (if ROT
    (command "_.rotate" (entlast) "" (car ROT) (cadr ROT)) )
  (setq SS (ssadd (entlast) SS))
  (if (and SK (eq USER-T8 "on"))
    (progn
      (command "_.hatch" "_u,_n" (dtr SK) 10 "_n" (entlast) "")
      (setq SSK (ssadd (entlast) SSK)
            SSK (skift SSK USER-L8 USER-C8)
            SS  (ssadd (entlast) SS)) ))
  SS)
;==============================================================================
(defun ent-l (SS P1 P2 LAY COL ROT)
  (if paucheck (princ "\nent-l"))
  (entmake (list '(0 . "LINE")
      (list 10 (car P1)(cadr P1)(if (caddr P1) (caddr P1) 0.0) )
      (list 11 (car P2)(cadr P2)(if (caddr P1) (caddr P1) 0.0) )
      (cons 62 COL)(cons 8 LAY)))
  (if ROT
    (command "_.rotate" (entlast) "" (car ROT) (cadr ROT)) )
  (setq SS (ssadd (entlast) SS))
  SS)
;==============================================================================

;==============================================================================
;******************************************************************************
;    V E L U X         MENUCALL
;******************************************************************************
;==============================================================================
(defun c:VELUX-1 (/ DCL-ID INS RES SS INS-P NR SEC PIT DIS
		    TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS TGA5-LIS)
  (if (setq DCL-ID (load_dialog (strcat VELUX-DIR "velux.dcl")))
    (progn
      (if (not USER-VAR) (sys-var t))
      (if (velux-ins DCL-ID USER-DATA)
        (progn
          (setq INS-P     (getvar "viewctr")
                NR        (nth 0 USER-DATA)
                SEC       (nth 1 USER-DATA)
                PIT       (nth 2 USER-DATA)
                DIS       (nth 3 USER-DATA)
                TGA1-LIS  (nth 4 USER-DATA)
                TGA2-LIS  (nth 5 USER-DATA)
                TGA3-LIS  (nth 6 USER-DATA)
                TGA4-LIS  (nth 7 USER-DATA)
                TGA5-LIS  (nth 8 USER-DATA))
          (if (setq RES (ins-fen INS-P NR SEC PIT DIS
				 TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS TGA5-LIS nil))
            (progn
              (setq INS-P (car RES)
                    SS    (cadr RES))
              (princ "Einfgepunkt: ")
              (command "_.move" SS "" INS-P pause)
              (if USER-VAR (sys-var nil))
              (if (and USER-ROT (member SEC '("3d-c" "3d-a" "3d-o")))
                (command "_.rotate" SS "" (getvar "lastpoint") pause)) )) )) ))
  (prin1))
;==============================================================================
(defun c:VELUX-2 (/ DCL-ID SS-P SS-EDI INS-P NR SEC PIT DIS
		    TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS TGA5-LIS)
  (if (setq DCL-ID (load_dialog (strcat VELUX-DIR "velux.dcl")))
    (progn
      (if (not USER-VAR) (sys-var t))
      (velux-ini)
      (if (setq EDI-SS-P  (velux-edi DCL-ID))
        (progn
	  (setq pau EDI-SS-P)
          (setq INS-P     (caddr EDI-SS-P)
                SS-EDI    (cadr EDI-SS-P)
                USER-DATA (car EDI-SS-P)
                NR        (nth 0 USER-DATA)
                SEC       (nth 1 USER-DATA)
                PIT       (nth 2 USER-DATA)
                DIS       (nth 3 USER-DATA)
                TGA1-LIS  (nth 4 USER-DATA)
                TGA2-LIS  (nth 5 USER-DATA)
                TGA3-LIS  (nth 6 USER-DATA)
                TGA4-LIS  (nth 7 USER-DATA)
                TGA5-LIS  (nth 8 USER-DATA))
          (if (ins-fen INS-P NR SEC PIT DIS
		       TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS TGA5-LIS SS-EDI)
            (command "_.erase" SS-EDI ""))
          (redraw) ))
      (if USER-VAR (sys-var nil)) ))
  (prin1))
;==============================================================================
(defun c:VELUX-4 ( / DCL-ID STY WS-L)
  (if (setq DCL-ID (load_dialog (strcat VELUX-DIR "velux.dcl")))
    (progn
      (if (not USER-VAR) (sys-var t))
      (velux-ini)
      (if (setq STY (velux-pla DCL-ID))
        (if (eq STY 1)
          (velux-p nil DCL-ID)
          (velux-p t DCL-ID)))
      (if USER-VAR (sys-var nil)) ))
  ; USER-LIN-LIST indeholder listen
  (prin1))
;==============================================================================
(defun c:VELUX-5 (/ DCL-ID )
  (if (setq DCL-ID (load_dialog (strcat VELUX-DIR "velux.dcl")))
    (progn
      (if (not USER-VAR) (sys-var t))
      (velux-ini)
      (velux-cfg DCL-ID)
      (if USER-VAR (sys-var nil)) ))
  (prin1))
;==============================================================================
(defun c:VELUX-6 (/ DCL-ID )
  (if (setq DCL-ID (load_dialog (strcat VELUX-DIR "velux.dcl")))
    (if (new_dialog "vx_info_a" DCL-ID)
      (progn
        (ima-sld "lgo" "logo")
        (action_tile "accept" "(done_dialog)")
        (start_dialog) ) ))
  (prin1))
;==============================================================================
;******************************************************************************
;    V E L U X         E D I T E R I N G
;******************************************************************************
;==============================================================================
(Defun velux-edi ( DCL-ID
		 / SS-EDI DATA NN BLK-LIS BLK-NAM IP TBL-BLK TBL-B
                   NR SEC PIT DIS TGA1 TGA2 TGA3 TGA4 TGA5)
  (if paucheck (princ "\nvelux-edi"))
  (setq SS-EDI (car (entsel)))
  (if SS-EDI
    (progn
      (setq DATA    nil
            NN      0
            BLK-LIS (entget SS-EDI))
      (if (and (eq "INSERT" (cdr (assoc 0 BLK-LIS)))
               (or 
                 (eq "VELUX-" (substr (cdr (assoc 2 BLK-LIS)) 1 6))
                 (eq "velux-" (substr (cdr (assoc 2 BLK-LIS)) 1 6))))
        (progn
          (setq BLK-NAM (cdr (assoc 2 BLK-LIS))
                IP      (cdr (assoc 10 BLK-LIS))
                TBL-BLK (tblsearch "BLOCK" BLK-NAM)
                TBL-B   (entget (cdr (assoc -2 TBL-BLK))) )
          (while (and (not DATA) (< NN 100))
            (if (and (eq "INSERT" (cdr (assoc 0 TBL-B)))
                     (or
                       (eq "VELUX"  (cdr (assoc 2 TBL-B)))
                       (eq "velux"  (cdr (assoc 2 TBL-B))) ))
	      (setq DATA (get-attrib TBL-B)))
            (setq NN    (1+ NN)
                  TBL-B (entget (entnext (cdr (assoc -1 TBL-B))))) )
	  (setq USER-DATA DATA)
          (setq DATA (velux-ins DCL-ID DATA))
          (if DATA 
            (list DATA SS-EDI IP)
            nil ) )
        (alert (strcat " !"
		       "\n      VELUX!")) ) )
    nil))
;==============================================================================
;******************************************************************************
;    V E L U X         INSERT and EDIT
;******************************************************************************
;==============================================================================
(defun velux-ins ( DCL-ID DATA
                 / OK NR SEC PIT DIS RES A-TGA1-LIS A-TGA3-LIS
		   TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS TGA5-LIS)
  (if paucheck (princ "\nvelux-ins"))
  (setq OK       nil
	USER-DATA-TEMP DATA
        NR       (nth 0 DATA)
        SEC      (nth 1 DATA)
        PIT      (nth 2 DATA)
        DIS      (nth 3 DATA)
        TGA1-LIS (nth 4 DATA)
        TGA2-LIS (nth 5 DATA)
        TGA3-LIS (nth 6 DATA)
        TGA4-LIS (nth 7 DATA)
        A-TGA1-LIS (list (car DIS) TGA1-LIS (caadr DIS))
        A-TGA3-LIS (list (cadr DIS) TGA3-LIS)
        SEC      (itoa (mem-a-nr SEC U-DRAW))
        NNR      (mem-a-nr NR U-KOMBI))
  (if (if paucheck
	(new_dialog "vx_ins_a_test" DCL-ID)
	(new_dialog "vx_ins_a" DCL-ID))
    (progn
      (ima-sld "lgo" "logo")
      (st-li "ima-txt" U-KOMBI 2 (itoa NNR))
      (ima-sld "ima" (cadr (assoc NR U-KOMBI)))
      (st-li "sec" U-DRAW 1 SEC)
      (set_tile "pit" (rtos PIT 2 1))
      (vx-lis-set DATA)
      (action_tile "ima-txt" "(setq NR  (vx-sld NR) SEC (vx-sec SEC SEC NR))")
      (action_tile "sec"     "(setq SEC (vx-sec SEC $value NR))")
      (action_tile "pit"     "(setq PIT (vx-pit PIT NR (cadr A-TGA1-LIS)))")
      (action_tile "pro"     "(vx-vx NR DCL-ID A-TGA1-LIS TGA2-LIS A-TGA3-LIS TGA4-LIS)")
      (action_tile "accept"
	"(setq PIT (atof (get_tile \"pit\")) OK t)(done_dialog)")
      (action_tile "cancel"  "(setq OK nil)(done_dialog)")
      (start_dialog)))
   (if OK
     (setq USER-DATA (append (list (nth 0 USER-DATA))
				    (list (car (nth (atoi SEC) U-DRAW)))
				    (list PIT)
				    (list (nth 3 USER-DATA))
				    (list (nth 4 USER-DATA))
				    (list (nth 5 USER-DATA))
				    (list (nth 6 USER-DATA))
				    (list (nth 7 USER-DATA))
			            (list  '("")) ))
     nil))
;==============================================================================
(Defun vx-lis-null ()
  (if paucheck (princ "\nvx-lis-null"))
  (setq USER-DATA (append (list (nth 0 USER-DATA))
			  (list (car (nth (atoi SEC) U-DRAW)))
			  (list PIT)
			  (list (nth 3 USER-DATA))
			  (list '(""))
			  (list '(""))
			  (list '(""))
			  (list '(""))
			  (list '(""))  )) )
;==============================================================================
(Defun vx-lis-set (DATA)
  (if paucheck (princ "\nvx-lis-set"))
  (st-lis "tga-1" (nth 4 DATA) "0")
  (st-lis "tga-2" (nth 5 DATA) "0")
  (st-lis "tga-3" (nth 6 DATA) "0")
  (st-lis "tga-4" (nth 7 DATA) "0")
  (if (or (eq 0 (car (nth 4 DATA)))
          (eq "" (car (nth 4 DATA))))
    (progn
      (mode_tile "accept" 1) )
    (progn
      (mode_tile "accept" 0) ))
  (set_tile "error" ""))
;==============================================================================
(defun vx-sld (NR / N RP RP-MIN RP-MAX)
  (if paucheck (princ "\nvx-sld"))
  (setq N  (car (nth (atoi $value) U-KOMBI))
        RP (distof (get_tile "pit") 2)
	RP-MIN (cadddr (assoc N U-KOMBI))
	RP-MAX (caddr(cddr (assoc N U-KOMBI))))
  (cond ((and (not (eq N NR)) (>= RP RP-MIN) (<= RP RP-MAX))
          (ima-sld "ima" (cadr (nth (atoi $value) U-KOMBI)))
          (vx-lis-null)
          (vx-lis-set USER-DATA))
        ((not (eq N NR))
	  (setq N NR)
          (set_tile  "ima-txt" (itoa N))
          (mode_tile "ima-txt" 2)
          (alert (strcat
	    "  !"
	    "\n      "
	    (rtos RP-MIN 2 1)"-"(rtos RP-MAX 2 1)
            " !"))))
  N)
;==============================================================================
(Defun vx-pit (PIT NR LIS / N RP RP-MIN RP-MAX)
  (defun pit-ok (RP LIS / OK L RPMIN RPMAX)
    (setq OK t)
    (foreach L LIS
      (setq RPMIN (nth 2 (assoc (get-typ L) USER-TYP-LIS))
            RPMAX (nth 3 (assoc (get-typ L) USER-TYP-LIS)))
      (if (or (< RP RPMIN) (> RP RPMAX))
        (setq OK nil)))
    OK)
;==============================================================================
  (if paucheck (princ "\nvx-pit"))(princ (setq pau7 lis))
  (setq N      (car (assoc NR U-KOMBI))
        RP     (distof $value 2)
	RP-MIN (cadddr (assoc N U-KOMBI))
	RP-MAX (caddr(cddr (assoc N U-KOMBI))))
  (if (and RP (>= RP RP-MIN) (<= RP RP-MAX))
    (progn
      (setq RP (atof $value))
      (if (not (pit-ok RP LIS))
        (progn
          (vx-lis-null)
          (vx-lis-set USER-DATA))))
    (progn
      (setq RP PIT)
      (set_tile  "pit" (rtos PIT 2 1))
      (mode_tile "pit" 2)
      (alert (strcat
	"  !"
	"\n      "
	(rtos RP-MIN 2 1)"-"(rtos RP-MAX 2 1)
        " !"))))
  RP)
;==============================================================================
(Defun vx-sec (SEC SEC- NR /)
  (if paucheck (princ "\nvx-sec"))
  (if (and (member (car (assoc NR U-KOMBI)) '(2 10))
           (member (car (nth (atoi SEC-) U-DRAW))'("3d-c" "3d-a" "3d-o")))
    (progn
      (alert " 3D  ")
      (if (member (car (nth (atoi SEC) U-DRAW))'("3d-c" "3d-a" "3d-o"))
        (setq SEC "1"))
      (set_tile "sec" SEC))
    (setq SEC SEC-))
  SEC)
;==============================================================================
;******************************************************************************
;    V E L U X         WINDOWTYPE
;******************************************************************************
;==============================================================================
(Defun vx-vx (NR DCL-ID TGA TGA2 TGA3 TGA4 / PIT FUNK RES)
  (if paucheck (princ "\nvx-vx"))
  (setq PIT   (atoi (get_tile "pit"))
	FUNK  (nth 5 (assoc NR U-KOMBI)))
  (setq USER-DATA ((eval FUNK) NR DCL-ID PIT TGA TGA2 TGA3 TGA4))
  (vx-lis-set USER-DATA)
  )
;==============================================================================
; single combination
;==============================================================================
(Defun vx_0 ( NR DCL-ID RP A-TGA TGA2 TGA3 TGA4
	    / TGA TY-VX M1-L M2-L COD TYP-LIS T-S-M TYP SIZ MAT1 MAT2)
;------------------------------------------------------------------------------
  (if paucheck (progn (princ "\nvx_0")
		 (princ	(list NR DCL-ID RP A-TGA TGA2 TGA3 TGA4))))
  (setq TY-VX    (eval (nth 7 (assoc NR U-KOMBI)))
	M1-L     (mat1-vx TY-VX)
	M2-L     (mat2-vx TY-VX)
	COD      (if (caadr A-TGA) (caadr A-TGA) "")
        TYP-LIS  (ty-vx-lis COD RP (car TY-VX))
        T-S-M    (tga-vx COD TYP-LIS M1-L M2-L)
        TYP      (nth 0 T-S-M)
        SIZ      (nth 1 T-S-M)
        MAT1     (nth 2 T-S-M)
        MAT2     (nth 3 T-S-M)
	
	DIS      (nth 3 USER-DATA)
	RT       (caadr (nth 3 USER-DATA))
	TGA2-LIS (nth 5 USER-DATA)
	TGA3-LIS (nth 6 USER-DATA)
	TGA4-LIS (nth 7 USER-DATA))
  (if (new_dialog (nth 6 (assoc NR U-KOMBI)) DCL-ID)
    (progn
      (st-li "mat1" M1-L 1 MAT1)
      (st-li "mat2" M2-L 1 MAT2)
     (setq TYP-LIS (mat-ty-vx 1 COD RP (car TY-VX) '() M1-L)
           COD     (si-co-vx 1 COD TYP-LIS M1-L M2-L))
      (ima-code-slide (list COD))
      (action_tile "mat1"  (strcat
        "(setq TYP-LIS (mat-ty-vx 1 COD RP (car TY-VX) '() M1-L)"
        " COD (si-co-vx 1 COD TYP-LIS M1-L M2-L))"
        "(ima-code-slide (list COD))"))
      (action_tile "type1" (strcat
	"(setq COD (si-co-vx 1 COD TYP-LIS M1-L M2-L))"
	"(setq TGA2-LIS '(\"\") TGA3-LIS '(\"\") TGA4-LIS '(\"\") )"
	"(ima-code-slide (list COD))"))
      (action_tile "size1" "(setq COD (code-vx 1 TYP-LIS M1-L M2-L))")
      (action_tile "glas1" "(setq COD (code-vx 1 TYP-LIS M1-L M2-L))")
      (action_tile "mat2"  "(setq COD (code-vx 1 TYP-LIS M1-L M2-L))")
      (setq TOM '(""))
      (action_tile "fla_lin" (strcat
	"(setq TGA (ok-vx (list (list 1 TYP-LIS)) M1-l M2-L))"
	"(setq RES (vx-fla-lin NR DCL-ID TGA2-LIS TGA3-LIS TGA (list 0 0 1 0)))"
	"(setq TGA2-LIS (car RES))"
	"(setq TGA3-LIS (cadr RES))"
	"(setq RT (caddr RES))"))
      (action_tile "acc" (strcat
	"(setq TGA (ok-vx (list (list 1 TYP-LIS)) M1-l M2-L))"
	"(setq TGA4-LIS (vx-acc NR DCL-ID TGA4-LIS TGA (list 0 0 1 0)))"))
      (action_tile "accept"
	"(setq TGA (ok-vx (list (list 1 TYP-LIS)) M1-l M2-L))(done_dialog)")
      (action_tile "cancel" "(setq TGA nil)(done_dialog)")
      (start_dialog) ))
  (if TGA
    (setq USER-DATA (append (list NR)
			  (list (nth 1 USER-DATA-TEMP))
			  (list RP)
			  (list (list (list 0 0 1 0)(list RT 0 0)))
			  (list TGA)
			  (list TGA2-LIS)
			  (list TGA3-LIS)
			  (list TGA4-LIS)
			  (list  '(""))  )) )
  (if paucheck (princ USER-DATA))
  USER-DATA)
;==============================================================================
; BLOCK combination
;==============================================================================
(Defun vx_4 ( NR DCL-ID RP A-TGA TGA2 TGA3 TGA4
	    / TGA  NA-LIS NB-LIS TY-VX DIST M1-L M2-L T-S-M
	      CDX TPX-LIS TPX SZX COD TYP-LIS TYP SIZ
	      MAT1 MAT2 DIS-A DIS-B N-A N-B CD)
  (if paucheck (princ "\nvx_4"))
  (setq NA-LIS   '("0" "1" "2" "3" "4" "5" "6" "7" "8")
	NB-LIS   '("0" "1" "2" "3" "4" "5" "6" "7" "8")
	TY-VX    (eval (nth 7 (assoc NR U-KOMBI)))
	DIST     (eval (nth 8 (assoc NR U-KOMBI)))
	M1-L     (mat1-vx TY-VX)
	M2-L     (mat2-vx TY-VX)
        CDX      (cond ((last (cadr A-TGA))
                         (last (cadr A-TGA)))
                       (t ""))
        TPX-LIS  (ty-vx-lis CDX RP (car TY-VX))
        T-S-M    (tga-vx CDX TPX-LIS M1-L M2-L)
        TPX      (nth 0 T-S-M)
        SZX      (nth 1 T-S-M)
	COD      (car (cadr A-TGA))
        TYP-LIS  (ty-vx-lis COD RP (car TY-VX))
        T-S-M    (tga-vx COD TYP-LIS M1-L M2-L)
        TYP      (nth 0 T-S-M)
        SIZ      (nth 1 T-S-M)
        MAT1     (nth 2 T-S-M)
        MAT2     (nth 3 T-S-M)
	RT       (caadr (nth 3 USER-DATA))
	TGA2-LIS (nth 5 USER-DATA)
	TGA3-LIS (nth 6 USER-DATA)
	TGA4-LIS (nth 7 USER-DATA)
	DIS-A    (itoa (mem-a-nr (nth 0 (car A-TGA)) (car DIST)))
	DIS-B    (itoa (mem-a-nr (nth 1 (car A-TGA)) (cadr DIST))))
  (if (eq "" (car(cadr A-TGA)))
    (setq N-A "1"
	  N-B "1")
    (setq N-A (itoa (mem-nr (itoa (nth 2 (car A-TGA))) (cdr NA-LIS)))
	  N-B (itoa (mem-nr (itoa (nth 3 (car A-TGA))) NB-LIS)) ))
  (if (new_dialog (nth 6 (assoc NR U-KOMBI)) DCL-ID)
    (progn
      (st-lis "count-a" (cdr NA-LIS) N-A)
      (st-lis "count-b" NB-LIS N-B)
      (st-li "dist-a" (car DIST) 1 DIS-A)
      (st-li "dist-b" (cadr DIST) 1 DIS-B)
      (st-li "mat1" M1-L 1 MAT1)
      (st-li "mat2" M2-L 1 MAT2)
      (setq TPX-LIS (mat-ty-vx 2 CDX RP (car TY-VX) '() M1-L)
            TYP-LIS (mat-ty-vx 1 COD RP (car TY-VX) (list (list 2 TPX-LIS)) M1-L)
            COD     (si-co-vx 1 COD TYP-LIS M1-L M2-L)
            CDX     (si-co-vx 2 CDX TPX-LIS M1-L M2-L))
      (size-ok (list (list 1 COD TYP-LIS) (list 2 CDX TPX-LIS)))
      (setq N-B     (count-set-b)
            COD     (si-co-vx 1 COD TYP-LIS M1-L M2-L)
            CDX     (si-co-vx 2 CDX TPX-LIS M1-L M2-L)
            CD      COD)
      (ima-ab-slide N-A N-B NA-LIS NB-LIS)
      (action_tile "count-a" "(setq N-A $value)(ima-ab-slide N-A N-B NA-LIS NB-LIS)")
      (action_tile "count-b" "(setq N-B (count-set-b))(ima-ab-slide N-A N-B NA-LIS NB-LIS)")
      (action_tile "dist-a"  "(setq DIS-A $value)")
      (action_tile "dist-b"  "(setq DIS-B $value)")
      (action_tile "mat1"  (strcat
        "(setq TPX-LIS (mat-ty-vx 2 CDX RP (car TY-VX) '() M1-L)"
        " CDX (si-co-vx 2 CDX TPX-LIS M1-L M2-L)"
        " TYP-LIS (mat-ty-vx 1 COD RP (car TY-VX) (list (list 2 TPX-LIS)) M1-L)"
        " COD (si-co-vx 1 COD TYP-LIS M1-L M2-L))"))
      (action_tile "type2" (strcat
	"(setq CDX (si-co-vx 2 CDX TPX-LIS M1-L M2-L))"
	"(size-ok (list (list 2 CDX TPX-LIS) (list 1 COD TYP-LIS)))"
	"(setq CDX (si-co-vx 2 CDX TPX-LIS M1-L M2-L)"
	" CD CDX COD (code-vx 1 TYP-LIS M1-L M2-L))"
	"(setq TGA2-LIS '(\"\") TGA3-LIS '(\"\") TGA4-LIS '(\"\") )"
	;"(ima-code-slide (list CDX))"
        ))
      (action_tile "size2" (strcat
	"(setq CDX (code-vx 2 TPX-LIS M1-L M2-L))"
	"(size-ok (list (list 2 CDX TPX-LIS) (list 1 COD TYP-LIS)))"
	"(setq CDX (code-vx 2 TPX-LIS M1-L M2-L)"
	" CD CDX COD (code-vx 1 TYP-LIS M1-L M2-L))"))
      (action_tile "glas2" (strcat
	"(setq CDX (code-vx 2 TPX-LIS M1-L M2-L)"
	" CD CDX COD (code-vx 1 TYP-LIS M1-L M2-L))"))
      (action_tile "type1" (strcat
	"(setq COD (si-co-vx 1 COD TYP-LIS M1-L M2-L))"
	"(size-ok (list (list 1 COD TYP-LIS) (list 2 CDX TPX-LIS)))"
	"(setq COD (si-co-vx 1 COD TYP-LIS M1-L M2-L)"
	" CD COD CDX (code-vx 2 TPX-LIS M1-L M2-L))"
	"(setq TGA2-LIS '(\"\") TGA3-LIS '(\"\") TGA4-LIS '(\"\") )"
	;"(ima-code-slide (list COD))"
        ))
      (action_tile "size1"  (strcat
	"(setq COD (code-vx 1 TYP-LIS M1-L M2-L))"
	"(size-ok (list (list 1 COD TYP-LIS) (list 2 CDX TPX-LIS)))"
	"(setq COD (code-vx 1 TYP-LIS M1-L M2-L)"
	" CD COD CDX (code-vx 2 TPX-LIS M1-L M2-L))"))
      (action_tile "glas1"  (strcat
	"(setq COD (code-vx 1 TYP-LIS M1-L M2-L)"
	" CD COD CDX (code-vx 2 TPX-LIS M1-L M2-L))"))
      (action_tile "mat2"  (strcat
	"(setq CDX (code-vx 2 TPX-LIS M1-L M2-L)"
	" COD (code-vx 1 TYP-LIS M1-L M2-L))"))
      (action_tile "fla_lin" (strcat
	"(setq TGA (ok-vx (list (list 1 TYP-LIS)(list 2 TPX-LIS)) M1-l M2-L)"
	" TGA (count-tga NR N-A N-B TGA TPY-LIS))"
	"(setq RES (vx-fla-lin NR DCL-ID TGA2-LIS TGA3-LIS TGA"
	"(list (car (nth (atoi DIS-A)(car DIST)))"
	"      (if (eq 0 (atoi (nth (atoi N-B) NB-LIS)))"
	"        0"
	"        (car (nth (atoi DIS-B)(cadr DIST))) )"
	"      (atoi (nth (atoi N-A) (cdr NA-LIS)))"
	"      (atoi (nth (atoi N-B) NB-LIS)) )))"
	"(setq TGA2-LIS (car RES))"
	"(setq TGA3-LIS (cadr RES))"
	"(setq RT (caddr RES))"))
      (action_tile "acc" (strcat
	"(setq TGA (ok-vx (list (list 1 TYP-LIS)(list 2 TPX-LIS)) M1-l M2-L)"
	" TGA (count-tga NR N-A N-B TGA TPY-LIS))"
	"(setq TGA4-LIS (vx-acc NR DCL-ID TGA4-LIS TGA"
	"(list (car (nth (atoi DIS-A)(car DIST)))"
	"      (if (eq 0 (atoi (nth (atoi N-B) NB-LIS)))"
	"        0"
	"        (car (nth (atoi DIS-B)(cadr DIST))) )"
	"      (atoi (nth (atoi N-A) (cdr NA-LIS)))"
	"      (atoi (nth (atoi N-B) NB-LIS)) )))"))
      (action_tile "accept" (strcat
	"(setq TGA (ok-vx (list (list 1 TYP-LIS)(list 2 TPX-LIS)) M1-l M2-L)"
	" TGA (count-tga NR N-A N-B TGA TPY-LIS))(done_dialog)"))
      (action_tile "cancel" "(setq TGA nil)(done_dialog)")
      (start_dialog)))
  (if (and (not NO-SCL-ALERT)
           (> (atoi (nth (atoi N-B) NB-LIS)) 0)
	   (< (car (nth (atoi DIS-B)(cadr DIST))) 250))
    (alert (strcat "   ,  100 ,   "
		   "\n     !")))
  (if TGA
    (setq USER-DATA (append (list NR)
			  (list (nth 1 USER-DATA-TEMP))
			  (list RP)
			  (list (list (list (car (nth (atoi DIS-A)(car DIST)))
					     (if (eq 0 (atoi (nth (atoi N-B) NB-LIS)))
					       0
					       (car (nth (atoi DIS-B)(cadr DIST))) )
					    (atoi (nth (atoi N-A) (cdr NA-LIS)))
					    (atoi (nth (atoi N-B) NB-LIS)) )
				      (list RT 0 0)))
			  (list TGA)
			  (list TGA2-LIS)
			  (list TGA3-LIS)
			  (list TGA4-LIS)
			  (list  '(""))  )) )
  (if paucheck (princ USER-DATA))
  USER-DATA)
;==============================================================================
; GIL/GIU combination     &      VFE (A/B) combination
;==============================================================================
(Defun vx_56 ( NR DCL-ID RP A-TGA TGA2 TGA3 TGA4
	     / TGA TY-VX DIST M1-L M2-L T-S-M
	       CDX TPX-LIS TPX SZX COD TYP-LIS TYP SIZ
	       MAT1 MAT2 CD)
  (if paucheck (princ "\nvx_56"))
  (setq TY-VX    (eval (nth 7 (assoc NR U-KOMBI)))
	DIST     (eval (nth 8 (assoc NR U-KOMBI)))
	M1-L     (mat1-vx TY-VX)
	M2-L     (mat2-vx TY-VX)
	CDX      (if (car(cadr A-TGA)) (car(cadr A-TGA)) "")
        TPX-LIS  (ty-vx-lis CDX RP (car TY-VX))
        T-S-M    (tga-vx CDX TPX-LIS M1-L M2-L)
        TPX      (nth 0 T-S-M)
        SZX      (nth 1 T-S-M)
	COD      (if (cadr(cadr A-TGA)) (cadr(cadr A-TGA)) "")
        TYP-LIS  (ty-vx-lis COD RP (cadr TY-VX))
        T-S-M    (tga-vx COD TYP-LIS M1-L M2-L)
        TYP      (nth 0 T-S-M)
        SIZ      (nth 1 T-S-M)
        MAT1     (nth 2 T-S-M)
        MAT2     (nth 3 T-S-M)
	RT       (caadr (nth 3 USER-DATA))
	TGA2-LIS (nth 5 USER-DATA)
	TGA3-LIS (nth 6 USER-DATA)
	TGA4-LIS (nth 7 USER-DATA))
  (if (new_dialog (nth 6 (assoc NR U-KOMBI)) DCL-ID)
    (progn
      (st-li "mat1" M1-L 1 MAT1)
      (st-li "mat2" M2-L 1 MAT2)
      (if (eq 9 (car (assoc NR U-KOMBI)))
        (setq TYP-LIS (mat-ty-vx 2 COD RP (cadr TY-VX) '() M1-L)
              TPX-LIS (mat-ty-vx 1 CDX RP (car TY-VX) (list (list 2 TYP-LIS)) M1-L))
        (setq TPX-LIS (mat-ty-vx 1 CDX RP (car TY-VX) '() M1-L)
              TYP-LIS (mat-ty-vx 2 COD RP (cadr TY-VX) (list (list 1 TPX-LIS)) M1-L)))
      (setq COD     (si-co-vx 2 COD TYP-LIS M1-L M2-L)
            CDX     (si-co-vx 1 CDX TPX-LIS M1-L M2-L))
      (size-ok (list (list 2 COD TYP-LIS) (list 1 CDX TPX-LIS)))
      (setq COD     (si-co-vx 2 COD TYP-LIS M1-L M2-L)
            CDX     (si-co-vx 1 CDX TPX-LIS M1-L M2-L)
            CD COD)
      (ima-code-slide (list COD CDX))
      (action_tile "mat1"  (strcat
        "(setq TPX-LIS (mat-ty-vx 1 CDX RP (car TY-VX) '() M1-L)"
        " CDX (si-co-vx 1 CDX TPX-LIS M1-L M2-L)"
        " TYP-LIS (mat-ty-vx 2 COD RP (cadr TY-VX) (list (list 1 TPX-LIS)) M1-L)"
        " COD (si-co-vx 2 COD TYP-LIS M1-L M2-L))"))
      (action_tile "type2" (strcat
	"(setq COD (si-co-vx 2 COD TYP-LIS M1-L M2-L))"
	"(size-ok (list (list 2 COD TYP-LIS) (list 1 CDX TPX-LIS)))"
	"(setq COD (si-co-vx 2 COD TYP-LIS M1-L M2-L)"
	" CD COD CDX (code-vx 1 TPX-LIS M1-L M2-L))"
	"(setq TGA2-LIS '(\"\") TGA3-LIS '(\"\") TGA4-LIS '(\"\") )"
	"(ima-code-slide (list COD CDX))"))
      (action_tile "size2"  (strcat
	"(setq COD (code-vx 2 TYP-LIS M1-L M2-L))"
	"(size-ok (list (list 2 COD TYP-LIS) (list 1 CDX TPX-LIS)))"
	"(setq COD (code-vx 2 TYP-LIS M1-L M2-L)"
	" CD COD CDX (code-vx 1 TPX-LIS M1-L M2-L))"))
      (action_tile "type1" (strcat
	"(setq CDX (si-co-vx 1 CDX TPX-LIS M1-L M2-L))"
	"(size-ok (list (list 1 CDX TPX-LIS) (list 2 COD TYP-LIS)))"
	"(setq CDX (si-co-vx 1 CDX TPX-LIS M1-L M2-L)"
	" CD CDX COD (code-vx 2 TYP-LIS M1-L M2-L))"
	"(setq TGA2-LIS '(\"\") TGA3-LIS '(\"\") TGA4-LIS '(\"\") )"
	"(ima-code-slide (list COD CDX))"))
      (action_tile "size1" (strcat
	"(setq CDX (code-vx 1 TPX-LIS M1-L M2-L))"
	"(size-ok (list (list 1 CDX TPX-LIS) (list 2 COD TYP-LIS)))"
	"(setq CDX (code-vx 1 TPX-LIS M1-L M2-L)"
	" CD CDX COD (code-vx 2 TYP-LIS M1-L M2-L))"))
      (action_tile "mat2"  (strcat
	"(setq CDX (code-vx 1 TPX-LIS M1-L M2-L)"
	" COD (code-vx 2 TYP-LIS M1-L M2-L))"))
      (action_tile "fla_lin" (strcat
	"(setq TGA (ok-vx (list (list 1 TPX-LIS)(list 2 TYP-LIS)) M1-l M2-L))"
	"(setq RES (vx-fla-lin NR DCL-ID TGA2-LIS TGA3-LIS TGA (list 0 0 1 1)))"
	"(setq TGA2-LIS (car RES))"
	"(setq TGA3-LIS (cadr RES))"
	"(setq RT (caddr RES))"))
      (action_tile "acc" (strcat
	"(setq TGA (ok-vx (list (list 1 TPX-LIS)(list 2 TYP-LIS)) M1-l M2-L))"
	"(setq TGA4-LIS (vx-acc NR DCL-ID TGA4-LIS TGA (list 0 0 1 1)))"))
      (action_tile "accept" (strcat
	"(setq TGA (ok-vx (list (list 1 TPX-LIS)(list 2 TYP-LIS)) M1-l M2-L))"
	"(done_dialog)"))
      (action_tile "cancel" "(setq TGA nil)(done_dialog)")
      (start_dialog)))
  (if TGA
    (setq USER-DATA (append (list NR)
			  (list (nth 1 USER-DATA-TEMP))
			  (list RP)
			  (list (list (list 0 0 1 1)(list RT 0 0)))
			  (list TGA)
			  (list TGA2-LIS)
			  (list TGA3-LIS)
			  (list TGA4-LIS)
			  (list  '("")) )) )
  (if paucheck (princ USER-DATA))
  USER-DATA)
;==============================================================================
; BALCON  &  TERRASSE
;==============================================================================
(Defun vx_78 ( NR DCL-ID RP A-TGA TGA2 TGA3 TGA4
	     / IMA TGA TY-VX DIST SIZE M1-L M2-L LN LN-2 T-S-M
               CDX1 CDX2 CDX3 TPX-LIS TPX SZX
               COD4 COD5 COD6 TYP-LIS TYP SIZ MAT1 MAT2 DIS-A CD)
;------------------------------------------------------------------------------
  (defun type-tile ( N CD TL X CDX TLX M1-L M2-L
		   / CD- NN )
    (setq CD- (si-co-vx N CD TL M1-L M2-L))
    (if (member (get-typ CD-) '("VEA" "VEB"))
      (cond ((or (and (< N 3)
	              (not (member (get-typ (si-co-vx (1+ N) CD TL M1-L M2-L))
		              '("..." "VEC"))))
	         (and (> N 1)
	              (not (member (get-typ (si-co-vx (1- N) CD TL M1-L M2-L))
		              '("..." "VEC")))) )
	       (alert (strcat "      !"))
	       (setq NN (mem-a-nr "VEC" TL))
               (set_tile (strcat "type" (itoa N)) (itoa NN)) )) )
    (if (member N '(4 5 6))
      (cond ((member (get-typ CD-) '("..." "GDL"))
               (set_tile (strcat "type" (itoa X)) "0"))
            ((and (not (member (get-typ CD-) '("..." "GDL")))
	          (member (get-typ CDX) '("...")))
	       (set_tile (strcat "type" (itoa X)) (itoa (1- (length TLX))))) ))
    (if (member N '(1 2 3))
      (cond ((member (get-typ CDX) '("GDL"))
               (set_tile (strcat "type" (itoa N)) "0"))
            ((and (member (get-typ CD-) '("..."))(member N '(2 3)))
	       (set_tile (strcat "type" (itoa X)) "0"))
            ((and (member (get-typ CD-) '("..."))(eq N 1))
	       (set_tile (strcat "type" (itoa N)) "1"))
            ((and (not (member (get-typ CD-) '("...")))
	          (member (get-typ CDX) '("...")))
	       (set_tile (strcat "type" (itoa X)) (itoa (1- (length TLX))))) ))
    (setq CD (si-co-vx N CD TL M1-L M2-L))
    CD)
;------------------------------------------------------------------------------
  (defun mat1-tile (ANT)
    (setq TPX-LIS (mat-ty-vx 1 CDX1 RP (car TY-VX) '() M1-L)
          TYP-LIS (mat-ty-vx 4 COD4 RP (cadr TY-VX) (list (list 1 TPX-LIS)) M1-L)
          CDX1 (si-co-vx 1 CDX1 TPX-LIS M1-L M2-L)
          COD4 (si-co-vx 4 COD4 TYP-LIS M1-L M2-L))
    (if (>= ANT 4)
      (setq CDX2 (si-co-vx 2 CDX2 TPX-LIS M1-L M2-L)
            COD5 (si-co-vx 5 COD5 TYP-LIS M1-L M2-L)))
    (if (= ANT 6)
      (setq CDX3 (si-co-vx 3 CDX3 TPX-LIS M1-L M2-L)
            COD6 (si-co-vx 6 COD6 TYP-LIS M1-L M2-L))))
;------------------------------------------------------------------------------
  (defun mat2-tile (ANT)
    (setq CDX1 (code-vx 1 TPX-LIS M1-L M2-L)
	  COD4 (code-vx 4 TYP-LIS M1-L M2-L))
    (if (>= ANT 4)
      (setq CDX2 (code-vx 2 TPX-LIS M1-L M2-L)
            COD5 (code-vx 5 TYP-LIS M1-L M2-L)))
    (if (= ANT 6)
      (setq CDX3 (code-vx 3 TPX-LIS M1-L M2-L)
            COD6 (code-vx 6 TYP-LIS M1-L M2-L))))
;------------------------------------------------------------------------------
  (defun kombi ( / ANT)
;..............................................................................
    (defun reset (N)
      (set_tile (strcat "type" (itoa N)) "0")
      (set_tile (strcat "size" (itoa N)) "0")
      (set_tile (strcat "glas" (itoa N)) "0")
      (set_tile (strcat "code" (itoa N)) "")
      (set_tile (strcat "type" (itoa (- N 3))) "0")
      (set_tile (strcat "size" (itoa (- N 3))) "0")
      (set_tile (strcat "glas" (itoa (- N 3))) "0")
      (set_tile (strcat "code" (itoa (- N 3))) "") )
;..............................................................................
    (setq ANT 6)
    (if (eq (get_tile "type6") "0")
      (progn
        (reset 6)
	(setq ANT 4) ))
    (if (eq (get_tile "type5") "0")
      (progn
        (reset 6)
        (reset 5)
	(setq ANT 2) ))
    (if (eq (get_tile "type4") "0")
      (progn
        (reset 6)
        (reset 5)
        (set_tile "type4" "1")
	(setq ANT 2) ))
    (setq CDX1 (si-co-vx 1 CDX1 TPX-LIS M1-L M2-L)
	  CDX2 (si-co-vx 2 CDX2 TPX-LIS M1-L M2-L)
	  CDX3 (si-co-vx 3 CDX3 TPX-LIS M1-L M2-L)
	  COD4 (si-co-vx 4 COD4 TYP-LIS M1-L M2-L)
	  COD5 (si-co-vx 5 COD5 TYP-LIS M1-L M2-L)
	  COD6 (si-co-vx 6 COD6 TYP-LIS M1-L M2-L) )
    ANT)
;------------------------------------------------------------------------------
  (defun ima-78 (CDX1 CDX2 CDX3 COD4 COD5 COD6)
    (if (eq NR 7)
      (ima-code-slide (list "GDL"))
      (ima-code-slide (list "GEL"))))
;------------------------------------------------------------------------------
  (defun ok-78 (NR ANT TPX-LIS TYP-LIS M1-L M2-L / TG-A )
    ; -------------------------------------------------------
    (defun TY-8 (N TL)
      (car (nth (atoi (get_tile (strcat "type" N))) TL)))
    ; -------------------------------------------------------
    (setq TG-A
      (cond
        ((eq ANT 2)
           (ok-vx (list (list 1 TPX-LIS) (list 4 TYP-LIS)) M1-L M2-L))
        ((eq ANT 4)
	   (ok-vx (list (list 1 TPX-LIS) (list 2 TPX-LIS)
			(list 4 TYP-LIS) (list 5 TYP-LIS)) M1-L M2-L))
        ((eq ANT 6)
	   (ok-vx (list (list 1 TPX-LIS) (list 2 TPX-LIS) (list 3 TPX-LIS)
		        (list 4 TYP-LIS) (list 5 TYP-LIS) (list 6 TYP-LIS))
		  M1-L M2-L)) ))
    TG-A)
;------------------------------------------------------------------------------
  (if paucheck (princ "\nvx_78"))
  (setq TY-VX    (eval (nth 7 (assoc NR U-KOMBI)))
	DIST     (eval (nth 8 (assoc NR U-KOMBI)))
	SIZE     (eval (nth 9 (assoc NR U-KOMBI)))
	M1-L     (mat1-vx TY-VX)
	M2-L     (mat2-vx TY-VX)
	LN       (if (< (length (cadr A-TGA)) 2) 2 (length (cadr A-TGA)))
	LN-2     (if (< (/ LN 2) 1) 1 (/ LN 2))
	CDX1     (if (car(cadr A-TGA))                   (car   (cadr A-TGA)) "")
	CDX2     (if (and (>= LN 4)(nth 1 (cadr A-TGA))) (nth 1 (cadr A-TGA)) "")
	CDX3     (if (and (>= LN 6)(nth 2 (cadr A-TGA))) (nth 2 (cadr A-TGA)) "")
        TPX-LIS  (ty-vx-lis CDX1 RP (car TY-VX))
        T-S-M    (tga-vx CDX1 TPX-LIS M1-L M2-L)
        TPX      (nth 0 T-S-M)
        SZX      (nth 1 T-S-M)
	COD4     (if (nth LN-2(cadr A-TGA))
		   (nth LN-2 (cadr A-TGA)) "")
	COD5     (if (and (>= LN 4)(nth (1+ LN-2) (cadr A-TGA)))
		   (nth (1+ LN-2)(cadr A-TGA)) "")
	COD6     (if (and (>= LN 6)(nth (+ LN-2 2) (cadr A-TGA)))
		   (nth (+ LN-2 2)(cadr A-TGA)) "")
        TYP-LIS  (ty-vx-lis COD4 RP (cadr TY-VX))
        T-S-M    (tga-vx COD4 TYP-LIS M1-L M2-L)
        TYP      (nth 0 T-S-M)
        SIZ      (nth 1 T-S-M)
        MAT1     (nth 2 T-S-M)
        MAT2     (nth 3 T-S-M)
	RT       (caadr (nth 3 USER-DATA))
	TGA2-LIS (nth 5 USER-DATA)
	TGA3-LIS (nth 6 USER-DATA)
	TGA4-LIS (nth 7 USER-DATA)
	DIS-A    (itoa (mem-a-nr (nth 0 (car A-TGA)) (car DIST))) )
  (if (new_dialog (nth 6 (assoc NR U-KOMBI)) DCL-ID)
    (progn
      (st-li "dist-a" (car DIST) 1 DIS-A)
      (st-li "mat1" M1-L 1 MAT1)
      (st-li "mat2" M2-L 1 MAT2)
      (setq IMA     (cadr (assoc NR U-KOMBI))
            TPX-LIS (mat-ty-vs 1 CDX1 RP (car TY-VX)  M1-L (car SIZE))
            TPX-LIS (mat-ty-vs 2 CDX2 RP (car TY-VX)  M1-L (car SIZE))
            TPX-LIS (mat-ty-vs 3 CDX3 RP (car TY-VX)  M1-L (car SIZE))
            TYP-LIS (mat-ty-vs 4 COD4 RP (cadr TY-VX) M1-L (cadr SIZE))
            TYP-LIS (mat-ty-vs 5 COD5 RP (cadr TY-VX) M1-L (cadr SIZE))
            TYP-LIS (mat-ty-vs 6 COD6 RP (cadr TY-VX) M1-L (cadr SIZE))
	    LN      (kombi)
            COD4    (si-co-vx 4 COD4 TYP-LIS M1-L M2-L)
            COD5    (si-co-vx 5 COD5 TYP-LIS M1-L M2-L)
            COD6    (si-co-vx 6 COD6 TYP-LIS M1-L M2-L)
            CDX1    (si-co-vx 1 CDX1 TPX-LIS M1-L M2-L)
            CDX2    (si-co-vx 2 CDX2 TPX-LIS M1-L M2-L)
            CDX3    (si-co-vx 3 CDX3 TPX-LIS M1-L M2-L)
	    COD4    (type-tile 4 COD4 TYP-LIS 1 CDX1 TPX-LIS M1-L M2-L)
            CDX1    (si-co-vx 1 CDX1 TPX-LIS M1-L M2-L)
            CD      COD4)
      ;(ima-sld "ima1" (strcat IMA "-x"))
      (ima-78 CDX1 CDX2 CDX3 COD4 COD5 COD6)
      (action_tile "dist-a" "(setq DIS-A $value)")
      (action_tile "mat1"   "(mat1-tile LN)")
      (action_tile "type4" (strcat
	"(setq LN (kombi)"
	" COD4 (type-tile 4 COD4 TYP-LIS 1 CDX1 TPX-LIS M1-L M2-L)"
	" CD COD4 CDX1 (si-co-vx 1 CDX1 TPX-LIS M1-L M2-L))"
	"(setq TGA2-LIS '(\"\") TGA3-LIS '(\"\") TGA4-LIS '(\"\") )"
        "(ima-78 CDX1 CDX2 CDX3 COD4 COD5 COD6)"))
      (action_tile "type5" (strcat
	"(setq LN (kombi)"
	" COD5 (type-tile 5 COD5 TYP-LIS 2 CDX2 TPX-LIS M1-L M2-L)"
	" CD COD5 CDX2 (si-co-vx 2 CDX2 TPX-LIS M1-L M2-L))"
	"(setq TGA2-LIS '(\"\") TGA3-LIS '(\"\") TGA4-LIS '(\"\") )"
        "(ima-78 CDX1 CDX2 CDX3 COD4 COD5 COD6)"))
      (action_tile "type6" (strcat
	"(setq LN (kombi)"
	" COD6 (type-tile 6 COD6 TYP-LIS 3 CDX3 TPX-LIS M1-L M2-L)"
	" CD COD6 CDX3 (si-co-vx 3 CDX3 TPX-LIS M1-L M2-L))"
	"(setq TGA2-LIS '(\"\") TGA3-LIS '(\"\") TGA4-LIS '(\"\") )"
        "(ima-78 CDX1 CDX2 CDX3 COD4 COD5 COD6)"))
      (action_tile "type1" (strcat
	"(setq CDX1 (type-tile 1 CDX1 TPX-LIS 4 COD4 TYP-LIS M1-L M2-L)"
	" LN (kombi)"
	" CD CDX1 COD4 (si-co-vx 4 COD4 TYP-LIS M1-L M2-L))"
	"(setq TGA2-LIS '(\"\") TGA3-LIS '(\"\") TGA4-LIS '(\"\") )"
        "(ima-78 CDX1 CDX2 CDX3 COD4 COD5 COD6)"))
      (action_tile "type2" (strcat
	"(setq CDX2 (type-tile 2 CDX2 TPX-LIS 5 COD5 TYP-LIS M1-L M2-L)"
	" LN (kombi)"
	" CD CDX2 COD5 (si-co-vx 5 COD5 TYP-LIS M1-L M2-L))"
	"(setq TGA2-LIS '(\"\") TGA3-LIS '(\"\") TGA4-LIS '(\"\") )"
        "(ima-78 CDX1 CDX2 CDX3 COD4 COD5 COD6)"))
      (action_tile "type3" (strcat
	"(setq CDX3 (type-tile 3 CDX3 TPX-LIS 6 COD6 TYP-LIS M1-L M2-L)"
	" LN (kombi)"
	" CD CDX3 COD6 (si-co-vx 6 COD6 TYP-LIS M1-L M2-L))"
	"(setq TGA2-LIS '(\"\") TGA3-LIS '(\"\") TGA4-LIS '(\"\") )"
        "(ima-78 CDX1 CDX2 CDX3 COD4 COD5 COD6)"))
      (action_tile "mat2"   "(mat2-tile LN)")
      (action_tile "fla_lin" (strcat
	"(setq TGA (ok-78 NR LN TPX-LIS TYP-LIS M1-L M2-L))"
	"(setq RES (vx-fla-lin NR DCL-ID TGA2-LIS TGA3-LIS TGA"
	"   (list (car (nth (atoi DIS-A)(car DIST))) 0 (/ LN 2) 1)))"
	"(setq TGA2-LIS (car RES))"
	"(setq TGA3-LIS (cadr RES))"
	"(setq RT (caddr RES))"))
      (action_tile "acc" (strcat
	"(setq TGA (ok-78 NR LN TPX-LIS TYP-LIS M1-L M2-L))"
	"(setq TGA4-LIS (vx-acc NR DCL-ID TGA4-LIS TGA"
	"   (list (car (nth (atoi DIS-A)(car DIST))) 0 (/ LN 2) 1)))"))
      (action_tile "accept" (strcat
	"(if (setq TGA (ok-78 NR LN TPX-LIS TYP-LIS M1-L M2-L))"
	"(done_dialog))"))
      ;(action_tile "cancel" "(setq TGA (cadr A-TGA))(done_dialog)")
      (action_tile "cancel" "(setq TGA nil)(done_dialog)")
      (start_dialog)))
  (if TGA
    (setq USER-DATA (append (list NR)
			  (list (nth 1 USER-DATA-TEMP))
			  (list RP)
			  (list (list (list
					(car (nth (atoi DIS-A)(car DIST))) 0 (/ LN 2) 1)
				      (list RT 0 0)))
			  (list TGA)
			  (list TGA2-LIS)
			  (list TGA3-LIS)
			  (list TGA4-LIS)
			  (list  '(""))  )) )
  (if paucheck (princ USER-DATA))
  USER-DATA)
;==============================================================================
;******************************************************************************
;==============================================================================
; FUNCTIONS FOR WINDOWTYPE
;==============================================================================
;******************************************************************************
;------------------------------------------------------------------------------
(Defun tga-vx (CD TL M1-L M2-L / TY SL SI MA1 MA2)
  (if paucheck (princ "\ntga-vx"))
  (setq TY  (itoa (mem-a-nr (get-typ CD) TL))
        SL  (if (eq "" (get-typ CD))
	      '()
	      (cadr (cdddr (assoc (get-typ CD) TL))))
        SI  (itoa (mem-nr (get-siz CD) SL))
        MA1 (itoa (mem-a-nr (substr (get-mat CD) 1 1) M1-L))
        MA2 (itoa (mem-a-nr (substr (get-mat CD) 2 1) M2-L)) )
  (list TY SI MA1 MA2))
;============================================================================
(Defun ty-ma-li (M R TL / T-L TY OK MA)
  (if paucheck (princ "\nty-ma-li\n"))
  (setq T-L '())
  (foreach TY TL
    (setq OK nil)
    (if (assoc TY USER-TYP-LIS)
      (progn
	(foreach MA (caddr(cdddr(assoc TY USER-TYP-LIS)))
	  (if (and (or (eq M (substr MA 1 1))
		       (eq M " ")
		       (eq MA ""))
		   (<= R (cadddr (assoc TY USER-TYP-LIS)))
		   (>= R (caddr (assoc TY USER-TYP-LIS))) )
	    (setq OK t)))
	(if OK
          (setq T-L (append T-L (list (assoc TY USER-TYP-LIS))))))))
  T-L)
;============================================================================
(Defun ty-vx-lis (CD R TL / MA1 T-L)
  (if paucheck (princ "\nty-vx-lis"))
  (setq MA1  (cond ((eq (substr CD 5 1) "-")
	               (substr CD 10 1))
                   ((eq (substr CD 4 1) "-")
	               (substr CD 9 1))
                   (t   " "))
	T-L  (ty-ma-li MA1 R TL))
  T-L)
;============================================================================
(Defun mat-ty-vs (N CD R TL M1-L OK-SL / T-L M L TY)
  (if paucheck (princ "\nmat-ty-vs"))
  (setq T-L  '()
        M    (car (nth (atoi (get_tile "mat1")) M1-L))
        TL   (ty-ma-li M R TL))
  (foreach L TL
    (setq T-L (append T-L (list (list
      (car L)(cadr L)(caddr L)(cadddr L)
      (get-s (nth 4 L) OK-SL)
      (nth 5 L)(nth 6 L) )))))
  (setq TY
    (if (assoc (get-typ CD) T-L)
      (itoa (mem-a-nr (get-typ CD) T-L))
       "0"))
  (st-li (strcat "type" (itoa N)) T-L 1 TY)
  T-L)
;------------------------------------------------------------------------------
(Defun get-s (SL OK-SL / SL-W S)
  (if paucheck (princ "\nget-s"))
  (setq SL-W '())
  (foreach S SL
    (if (or (member S OK-SL) (eq S ""))
      (setq SL-W (append SL-W (list S)))))
  SL-W)
;============================================================================
(Defun mat-ty-vx (N CD R TL OK-SL M1-L / T-L M TY)
  (if paucheck (princ "\nmat-ty-vx"))
  (setq T-L  '()
        M    (car (nth (atoi (get_tile "mat1")) M1-L))
        TL   (ty-ma-li M R TL))
  (foreach L TL
    (setq T-L (append T-L (list (list
      (car L)(cadr L)(caddr L)(cadddr L)
      (get-s-ok (nth 4 L) OK-SL)
      (nth 5 L)(nth 6 L) )))))
  (setq TY
    (cond ((assoc (get-typ CD) T-L)
             (itoa (mem-a-nr (get-typ CD) T-L)))
          ((assoc (strcat (substr (get-typ CD) 1 2) "U") T-L)
             (itoa (mem-a-nr (strcat (substr (get-typ CD) 1 2) "U") T-L)))
          ((assoc (strcat (substr (get-typ CD) 1 2) "L") T-L)
             (itoa (mem-a-nr (strcat (substr (get-typ CD) 1 2) "L") T-L)))
          (t "0")))
  (st-li (strcat "type" (itoa N)) T-L 1 TY)
  T-L)
;------------------------------------------------------------------------------
(Defun get-s-ok (SL OK-SL / OK-W SL-W W L)
  (if paucheck (princ "\nget-s-ok"))
  (setq OK-W '()
       	SL-W '())
  (foreach L (cadr(car OK-SL))
    (setq W (mapcar '(lambda (S) (substr S 1 1)) (nth 4 L))
          OK-W (append OK-W W)))
  (if OK-W
    (foreach S SL
      (if (member (substr S 1 1) OK-W)
        (setq SL-W (append SL-W (list S)))))
    (setq SL-W SL))
  SL-W)
;============================================================================
(Defun mat1-vx (OK-TL / M-L M OK L TY mm)
  (if paucheck (princ "\nmat1-vx"))
  (setq M-L '())
  (foreach M U-WIN-MAT1
    (setq OK nil)
    (foreach L OK-TL
      (foreach TY L
	(foreach mm (nth 5 (assoc TY USER-TYP-LIS))
	  (if (eq (car M)(substr mm 1 1))
	    (setq OK t)))))
    (if OK (setq M-L (append M-L (list M)))))
  M-L)
;============================================================================
(Defun mat2-vx (OK-TL / M-L M OK L TY mm)
  (if paucheck (princ "\nmat2-vx"))
  (setq M-L  '())
  (foreach M U-WIN-MAT2
    (setq OK nil)
    (foreach L OK-TL
      (foreach TY L
	(foreach mm (nth 5 (assoc TY USER-TYP-LIS))
	  (if (eq (car M)(substr mm 2 1))
	    (setq OK t)))))
    (if OK (setq M-L (append M-L (list M)))))
  M-L)
;============================================================================
(Defun mat34-vx (TY / M-L M OK L  mm)
  (if paucheck (princ "\nmat34-vx"))
  (setq M-L  '())
  (foreach M U-WIN-MAT34
    (setq OK nil)
    (foreach mm (nth 5 (assoc TY USER-TYP-LIS))
      (if (eq (car M)(substr mm 3))
	(setq OK t)))
    (if OK (setq M-L (append M-L (list M)))))
  M-L)
;------------------------------------------------------------------------------
(Defun si-co-vx (N CD TL M1-L M2-L / TY SZ SL SI TT)
  (if paucheck (princ "\nsi-co-vx"))
  (setq TY  (get_tile (strcat "type" (itoa N)))
	SZ  (get-siz CD)
	SL  (cadr (cdddr (nth (atoi TY) TL)))
        SI  (if (member SZ SL)
	      (itoa (mem-nr SZ SL))
	      "0")
	TT  (cadddr (cdddr (nth (atoi TY) TL))))
  (if (member (car(nth (atoi TY) TL)) '("GIL" "GIU" "GEL"))
    (setq SL (mapcar '(lambda (L) (strcat L "-")) SL)))
  (if (member (car(nth (atoi TY) TL)) '("VIU"))
    (setq SL (mapcar '(lambda (L) (strcat L "_")) SL)))
  (set_tile "txt-lin-1"  (car TT))
  (set_tile "txt-lin-2"  (cadr TT))
  (start_list (strcat "size" (itoa N)))
    (mapcar 'add_list (mapcar '(lambda (L) (cadr (assoc L USER-SIZ-LIS))) SL))
  (end_list)
  (set_tile (strcat "size" (itoa N)) SI)
  (code-vx N TL M1-L M2-L))
;------------------------------------------------------------------------------
(Defun code-vx (N TL M1-L M2-L / LI TY SI MA VA V)
  (if paucheck (princ "\ncode-vx"))
  (setq LI (nth (atoi (get_tile (strcat "type" (itoa N)))) TL)
	TY (car LI)
	SI (nth (atoi (get_tile (strcat "size" (itoa N)))) (cadr (cdddr LI)))
	MA (if (and M1-L M2-L)
             (strcat (car (nth (atoi (get_tile "mat1")) M1-L))
		     (car (nth (atoi (get_tile "mat2")) M2-L)))
             "00")
        VA "xxxx")
  (foreach V (caddr (cdddr LI))
    (if (eq MA (substr V 1 2))
      (setq VA V)))
  (set_tile (strcat "code" (itoa N))
	    (if paucheck
	      (strcat (substr TY (- (strlen TY) 2)) "   " SI "   "  VA)
	      (strcat (substr TY (- (strlen TY) 2)) "   " SI) ))
  (strcat TY "-" SI "-" VA))
;------------------------------------------------------------------------------
(defun size-ok (N-C-TL / NX CX TX SX L N C TL SN NS LI SI S SZ SIZ SL)
  (if paucheck (princ "\nsize-ok"))
  (setq NX (itoa (car (car N-C-TL)))
	CX (cadr (car N-C-TL))
	TX (caddr (car N-C-TL))
        SX (substr (get-siz CX) 1 1))
  (foreach L (cdr N-C-TL)
    (setq N  (itoa (car L))
	  C  (cadr L)
	  TL (caddr L))
    (if (not (eq SX (substr (get-siz C) 1 1)))
      (progn
	(setq SN  nil
	      NS  "1"
	      LI  (assoc (get-typ C) TL)
              SI  (cadr (cdddr LI)))
	(foreach S SI
	  (if (eq SX (substr S 1 1))
	    (setq SZ S
	          SN (itoa (mem-nr S SI))) ))
	(if SN
	  (progn
	    (setq SIZ SN)
	    (set_tile (strcat "size" N) SIZ))
	  (progn
 	    (alert (strcat "   "(get-typ CX) "  -  " (get-siz CX)
			   "\n    \n    "
			   (get-typ C)
			   "\n       !" ))
	    (setq NS "-1"
	          SL (cadr (cdddr (assoc (get-typ CX) TX))) )
 	    (foreach S SL
	      (if (eq (substr (get-siz C) 1 1) (substr S 1 1))
	        (setq NS (itoa (mem-nr S SL))) ))
	    (set_tile (strcat "size" NX) NS) ))))))
;------------------------------------------------------------------------------
(Defun ok-vx (L-TL M1-L M2-L / TGA TL TY MA VA GG GA V TG)
  (if paucheck (princ "\nok-vx"))
  (setq TGA '())
  (foreach TL L-TL
    (setq TY (nth (atoi (get_tile (strcat "type" (itoa (car TL))))) (cadr TL))
          MA (if (and M1-L M2-L)
               (strcat (car (nth (atoi (get_tile "mat1")) M1-L))
		       (car (nth (atoi (get_tile "mat2")) M2-L)))
               "00")
          VA  (if (eq (car TY) "CLI") "" "xxxx"))
    (foreach V (caddr (cdddr TY))
      (if (eq MA (substr V 1 2))
        (setq VA V)))
    (setq TG  (if (member (car TY) '("" "..." "   "))
               '("   ")
	        (list (strcat
                        (car TY)  "-"
                        (nth (atoi (get_tile (strcat "size" (itoa (car TL)))))
	                     (cadr(cdddr TY)))  "-" VA)))
          TGA  (append TGA TG)))
  TGA)
;------------------------------------------------------------------------------
(Defun count-tga (NR A B TG TPY-LIS / TGA L-A L-B SIZ MAT)
  (if paucheck (princ "\ncount-tga"))
  (setq TGA '()
	L-A '()
	L-B '())
  (repeat (1+ (atoi A))
    (setq L-A (append L-A (list (car TG))))
    (setq L-B (append L-B (list (cadr TG)))) )
  (setq TGA L-A)
  (repeat (atoi B)
    (setq TGA (append TGA L-B)))
  TGA)
;------------------------------------------------------------------------------
(Defun count-set-b ()
  (if paucheck (princ "\ncount-set-b"))
  (if (eq (get_tile "count-b") "0")
    (progn
      (mode_tile "dist-b" 1)
      (mode_tile "type2" 1)
      (mode_tile "size2" 1)
      (mode_tile "glas2" 1) )
    (progn
      (mode_tile "dist-b" 0)
      (mode_tile "type2" 0)
      (mode_tile "size2" 0)
      (mode_tile "glas2" 0) ))
  (get_tile "count-b"))
;------------------------------------------------------------------------------
(Defun ima-ab-slide (A B LA LB / NA NB IMA)
  (if paucheck (princ "\nima-ab-slide"))
  (setq NA (nth (atoi A) (cdr LA))
	NB (nth (atoi B) LB) )
  (if (and (<= (atoi NA) 3)
           (>= (atoi NB) 0)(<= (atoi NB) 1))
    (setq IMA (strcat "blk-" NA "x" NB))
    (setq IMA "blk-xxx"))
  (ima-sld "ima1" IMA))
;------------------------------------------------------------------------------
(Defun ima-code-slide (CL / IMA C)
  (if paucheck (progn (princ "\nima-code-slide")(princ CL)))
  (setq IMA (get-typ (car CL)))
  (foreach C (cdr CL)
    (setq IMA (strcat IMA "_" (get-typ C))))
  (if IMA (ima-sld "ima1" IMA)))
;------------------------------------------------------------------------------
;==============================================================================
;==============================================================================
;******************************************************************************
;    V E L U X         FLASHING  &  LININGS
;******************************************************************************
;==============================================================================
(Defun vx-fla-lin ( NR DCL-ID TGA2 TGA3 TGA1 DIST
	          / PRO FLA PLA NON XX1 XX2 XX3 BFX LGI BBX LSC RT TG)
;------------------------------------------------------------------------------
  (Defun ok-fla ( NR TGA1 DIST
		/ TGA DA DB NA NB PRO FLA N M2 M5 M6 TG FTY XTY SIZ M1 M3 M4)
    (if (eq "1" (get_tile "non"))
      (setq TGA '())
      (progn
        (setq DA  (car DIST)
	      DB  (cadr DIST)
	      NA  (caddr DIST)
	      NB  (cadddr DIST)
              TGA '()
              PRO (if (eq "1" (get_tile "pro")) t nil)
              FLA (if (eq "1" (get_tile "fla")) t nil)
              PLA (if (eq "1" (get_tile "pla")) t nil)
	      N   1
	      M2  (cond ((eq (car TGA1) "   ")
                           (substr (get-mat (last TGA1)) 2 1))
                        (t (substr (get-mat (car TGA1)) 2 1)))
		    
	      M5  (cadr (assoc (car DIST) U-DIS-CODE))
	      M6  (cadr (assoc (cadr DIST) U-DIS-CODE)) )
        (foreach TG TGA1
          (setq FTY (cond ((and (member (car (assoc NR U-KOMBI)) '(6 7 8))(<= N NA))  "")
			  ((and (eq 9 (car (assoc NR U-KOMBI)))(eq N 2))              "EK")
			  ((and (eq 8 (car (assoc NR U-KOMBI)))(> N NA))              "EE")
			  ((and (eq 7 (car (assoc NR U-KOMBI)))(> N NA)(> NA 1))      "EK")
			  ((and (eq 6 (car (assoc NR U-KOMBI)))(eq N 2))              "EF")
			  ((and (eq 5 (car (assoc NR U-KOMBI)))(eq N 1))              "ET")
			  ((and (eq 2 (car (assoc NR U-KOMBI)))
                                (eq NB 0)(eq NA 2)(eq N 1))     "EB")
			  ((and (eq 2 (car (assoc NR U-KOMBI)))
                                (eq NB 0)(eq NA 2)(> N 1))      "")
			  ((and (eq 2 (car (assoc NR U-KOMBI)))
				(not (and (eq N 1)(eq NA 1))))  "EK")
			  ((and (eq 4 (car (assoc NR U-KOMBI)))
				(not (and (eq N 1)(eq NA 1))))  "EK")
			  (t "ED"))
	        XTY (cond ((and (eq 4 (car (assoc NR U-KOMBI)))(> N NA)(> NA 2)
				(middle? N NA) )                "X")
			  ;((and PRO (eq (car (assoc NR U-KOMBI)) 4)(> NA 1)(eq NB 0)
			;	    (> N 1))                    "K")
			  ((and PRO
			        (or (member (car (assoc NR U-KOMBI)) '(8 6))
				    (and (eq (car (assoc NR U-KOMBI)) 9)(eq N 2))
				    (eq (car (assoc NR U-KOMBI)) 7)
				    (and (eq (car (assoc NR U-KOMBI)) 5)(eq N 1))
				    (and (member (car (assoc NR U-KOMBI)) '(2 4))
					 (>= NB 1)(> N NA)) ))  "W")
			  (PRO "W"); H 
			  (PLA "E"); new
		          (FLA
                            (if (assoc "EDL" USER-TYP-LIS)
                              "L"
                              "S"))
			  (t "?"))
		SIZ (cond ((eq (car (assoc NR U-KOMBI)) 7) "P19")
			  ((and (eq 5 (car (assoc NR U-KOMBI)))(eq N 1))
			     (strcat "0" (substr (get-siz TG) 2 2)))
			  (t (get-siz TG)))
	        M1  (cond ((or (and (member NR '(0 2 4 9))(<= N NA))
			       (and (member NR '(5 6 7))(> N NA)) )
		             "1")
                          ((and (member NR '(9))(> N NA))
                             "R")
		          (t "0"))
	        M3  "0"
	        M4  (cond ((and (member (car (assoc NR U-KOMBI)) '(2 4 9))(> N 1)(eq NA 1)(>= NB 1))
			     (strcat "7" M6))
			  ((eq NA 1)  "0")
                          ((and (eq 2 (car (assoc NR U-KOMBI)))(eq NB 0)(eq NA 2)) "0")
			  ((or (eq N 1)
			       (and (member (car (assoc NR U-KOMBI)) '(7 8)) (first? N NA)))
			     (strcat "1" M5))
			  ((or (eq N NA)
			       (and (member (car (assoc NR U-KOMBI)) '(7 8))(last? N NA)))
			            "3")
		          ((or (and (> N 1)(< N NA))
			       (and (member (car (assoc NR U-KOMBI)) '(7 8))(> N NA)))
			     (strcat "2" M5))
			  ((first? N NA) (strcat "4" M5 M6))
			  ((last? N NA)  (strcat "6" M6))
			  ((> N NA) (strcat "5" M5 M6))             
		          (t "0"))
		TGA (if (not (eq FTY ""))
		      (append TGA (list
		        (strcat FTY XTY "-" SIZ "-" M1 M2 M3 M4)))
		      TGA)
	        N   (1+ N)))
	(if (eq (car (assoc NR U-KOMBI)) 8)
          (setq TGA (append TGA (list (strcat "EEX-" (get-siz (car TGA1))
					      "-0000"))))) ))
    (if (eq "1" (get_tile "bfx"))
      (foreach TG TGA1
        (if (member (get-typ TG)(car(cddddr(assoc "BFX" USER-TYP-LIS))))
          (setq TGA (append TGA (list (strcat "BFX-" (get-siz TG) "-1000")))) )))
    (if (eq TGA '()) (setq TGA '("")))
    TGA)
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
  (Defun ok-lin (NR TGA1 DIST / DA DB NA NB TGA N M TG AC AC-)
  (if paucheck (princ "\nok-lin"))
     (setq DA  (car DIST)
	   DB  (cadr DIST)
	   NA  (caddr DIST)
	   NB  (cadddr DIST)
	   TGA  '()
	   N     0
	   M     (if (> (car (assoc NR U-KOMBI)) 4)
		   (/ (length TGA1) (1+ NB))
		   (length TGA1))
           M     (length TGA1))
    (while (< N M)
      (setq TG (nth N TGA1)
	    N  (1+ N))
      (foreach AC- '("lgi" "lsc" "bbx")
        (setq AC (cond (t (strcase AC-))))
        (if (eq "1" (get_tile AC-))
	  (if (and (not (and (eq (get-siz TG) "")(member AC '("LGI"))))
		(member (get-typ TG)
	              (car(cddddr(assoc AC USER-TYP-LIS)))))
 	    (setq TGA (append TGA (list (strcat 
		        AC "-"
		        (cond ((and (eq AC "BBX")
                                    (member (car (assoc NR U-KOMBI)) '(6 5 7))
                                    (member (substr (get-siz TG) 2 2) '("31" "34")))
                                 "W34")
                              ((and (eq AC "BBX")
                                    (member (car (assoc NR U-KOMBI)) '(6 5 7))
                                    (member (substr (get-siz TG) 2 2) '("36" "38")))
                                 "W38")
                              ((and (eq AC "BBX")
                                    (member (car (assoc NR U-KOMBI)) '(7))
                                    (member (substr (get-siz TG) 2 2) '("")))
                                 "W34")
                              ((and (eq AC "BBX")
                                    (member (car (assoc NR U-KOMBI)) '(7))
                                    (member (get-siz TG) '("P19")))
                                 "P10")
                              ((and (eq AC "LSC")
                                    (member (car (assoc NR U-KOMBI)) '(7))
                                    (member (get-siz TG) '("P19")))
                                 "P10")
                              (t (get-siz TG)))
		  	"-" (lin-var TG AC)
			))))
	    ))))
    (if (eq TGA '()) (setq TGA '("")))
    TGA)
;------------------------------------------------------------------------------
  (Defun lin-var ( TG AC / MA mm M)
    (if paucheck (princ "\nlin-var"))
    (setq MA (if (eq "0000" (caadr(cddddr(assoc(strcase AC) USER-TYP-LIS))))
	       "0000"
	       "9999")
	  mm (get-mat TG))
    (foreach M (cadr(cddddr(assoc AC USER-TYP-LIS)))
      (if (or (eq (substr mm 1 1) (substr M 1 1))
	      (and (or (eq (substr mm 1 1) "0")
		       (and (not (eq (get-typ AC) "LGI"))
			    (eq (substr mm 1 1) "3")))
		   (eq (substr M 1 1)  "2")) )
	(setq MA M)))
    MA)
;------------------------------------------------------------------------------
  (Defun fla-ima ()
    (ima-sld "ima" (cond ((eq "1" (get_tile "pro")) "pro")
			 ((eq "1" (get_tile "fla")) "fla")
			 ((eq "1" (get_tile "pla")) "pla")
			 ((eq "1" (get_tile "non")) "non")
			 (t "non"))) )
;------------------------------------------------------------------------------
(Defun lin-rt (RT / CD MI MX)
  (setq	CD "LSC"
	MI (caddr (assoc (strcase CD) USER-TYP-LIS))
	MX (cadddr (assoc (strcase CD) USER-TYP-LIS)) )
  (if (or (< (atof (get_tile "rooftik")) MI)
	  (> (atof (get_tile "rooftik")) MX) )
    (progn
      (if (< (atof (get_tile "rooftik")) 10)
	(alert "      !")
	(progn
	  (alert (strcat "     "
			 (itoa MI) " - " (itoa MX)
			 "      VELUX" CD "." ))
	  (if (or (< RT MI) (> RT MX))
	    (setq RT MX) )))
      (set_tile "rooftik" (rtos RT 2 0))
      (mode_tile "rooftik" 2) )
    (setq RT (atof (get_tile "rooftik"))) )
  RT)
;------------------------------------------------------------------------------
  (Defun profi-set ()
    (cond ((and (eq $key "xx1")(eq "1" $value))
             (set_tile "bfx" "1")
             (set_tile "lgi" "1")
             (set_tile "bbx" "1"))
	  ((and (eq $key "xx2")(eq "1" $value))
             (set_tile "bfx" "1")
             (set_tile "lgi" "1")
             (set_tile "bbx" "0"))
	  ((eq (get_tile "xx1") "1")
             (set_tile "bfx" "1")
             (set_tile "lgi" "1")
             (set_tile "bbx" "1"))
	  ((eq (get_tile "xx2") "1")
             (set_tile "bfx" "1")
             (set_tile "lgi" "1")
             (set_tile "bbx" "0"))
	  )
    (if (eq (get_tile "xx3") "1")
      (progn
        (mode_tile "bfx" 0)
        (mode_tile "lgi" 0)
        (mode_tile "bbx" 0))
      (progn
        (mode_tile "bfx" 1)
        (mode_tile "lgi" 1)
        (mode_tile "bbx" 1))) )
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
  (if paucheck (princ "\nvx-fla-lin"))
  (setq RT    (caadr (nth 3 USER-DATA)))
  (foreach TG TGA3
    (cond ((eq (get-typ TG) "LGI") (setq LGI "1"))
          ((eq (get-typ TG) "BBX") (setq BBX "1"))
          ((eq (get-typ TG) "LSC") (setq LSC "1")) ))
  (setq LGI (if (not LGI) "0" LGI)
        BBX (if (not BBX) "0" BBX)
        LSC (if (not LSC) "0" LSC))
  (if (and (eq (length TGA3) 1)(eq TG ""))
    (setq LGI   (get-default "LGI" "0")
          BBX   (get-default "BBX" "0")
          LSC   (get-default "LSC" "0") ))
  (if (or (not (member (get-ma2 (car TGA1)) '("1" "3")))
	  (and (member (car (assoc NR U-KOMBI)) '(2)) (> (car DIST) 18))
	  (not (member (car (assoc NR U-KOMBI)) '(0 2))) )
    (setq PLA "0"))
  (cond ((member (substr (get-typ (car TGA2)) 3 1) '("Z" "H" "W" "J"))
	 (setq PRO "1" FLA "0" PLA "0" NON "0"))
	((member (substr (get-typ (car TGA2)) 3 1) '("L" "S" "N"))
	 (setq PRO "0" FLA "1" PLA "0" NON "0"))
	((member (substr (get-typ (car TGA2)) 3 1) '("E"))
	 (setq PRO "0" FLA "0" PLA "1" NON "0"))
	(t (setq PRO "0" FLA "0" PLA "0" NON "1")))
  (if (eq (get-typ (last TGA2)) "BFX")(setq BFX "1")(setq BFX "0"))
  (setq FLA (if (not FLA) "0" FLA)
        PLA (if (not PLA) "0" PLA)
        PRO (if (not PRO) "0" PRO)
        NON (if (not NON) "0" NON)
        BFX (if (not BFX) "0" BFX))
  (if (and (eq (length TGA2) 1)(eq (get-typ (car TGA2)) ""))
    (setq PRO   (get-default "PRO" "0")
          FLA   (get-default "FLA" "0")
          PLA   (get-default "PLA" "0")
          NON   (get-default "NON" "0")
          BFX   (get-default "BFX" "0") ))
  (if (eq PRO "1")(setq NON "0" FLA "0" PLA "0"))
  (if (eq FLA "1")(setq PLA "0" PRO "0" NON "0"))
  (if (eq PLA "1")(setq FLA "0" PRO "0" NON "0"))
  (if (eq NON "1")(setq PRO "0" FLA "0" PLA "0"))
  (cond ((and (eq BFX "1")(eq LGI "1")(eq BBX "1"))
	 (setq XX1 "1"))
	((and (eq BFX "1")(eq LGI "1")(eq BBX "0"))
	 (setq XX2 "1"))
	(t (setq XX3 "1")))
  (setq XX1 (if (not XX1) "0" XX1)
        XX2 (if (not XX2) "0" XX2)
        XX3 (if (not XX3) "0" XX3))
  (if (and (eq (length TGA3) 1)(eq (get-typ (car TGA3)) ""))
    (setq XX1   (get-default "XX1" "0")
          XX2   (get-default "XX2" "0")
          XX3   (get-default "XX3" "0") ))
  (if (new_dialog "vx_fla_lin_a" DCL-ID)
    (progn
      (set_tile "pro" PRO)
      (set_tile "fla" FLA)
      (set_tile "pla" PLA)
      (set_tile "non" NON)
      (set_tile "xx1" XX1)
      (set_tile "xx2" XX2)
      (set_tile "xx3" XX3)
      (set_tile "bfx" BFX)
      (set_tile "lgi" LGI)
      (set_tile "bbx" BBX)
      (set_tile "lsc" LSC)
      (set_tile "rooftik" (if (eq RT 0) "" (rtos RT 2 0)))
      (if (or (not (member (get-ma2 (car TGA1)) '("1" "3")))
	      (and (member (car (assoc NR U-KOMBI)) '(2)) (> (car DIST) 18))
	      (not (member (car (assoc NR U-KOMBI)) '(0 2 4))) )
	(mode_tile "pla" 1))
      (if (not (member (car (assoc NR U-KOMBI)) '(0)))
	(progn (mode_tile "lsc" 1) (mode_tile "rooftik" 1)))
      (fla-ima)
      (ima-sld "ima-lsc" "lsc")
      (profi-set)
      (action_tile "pro"    "(fla-ima)")
      (action_tile "fla"    "(fla-ima)")
      (action_tile "pla"    "(fla-ima)")
      (action_tile "non"    "(fla-ima)")
      (action_tile "xx1"    "(profi-set)")
      (action_tile "xx2"    "(profi-set)")
      (action_tile "xx3"    "(profi-set)")
      (action_tile "bfx"    "(prin1)")
      (action_tile "lgi"    "(prin1)")
      (action_tile "bbx"    "(prin1)")
      (action_tile "lsc"     "(mode_tile \"rooftik\" 2)")
      (action_tile "rooftik" "(setq RT (lin-rt RT))")
      (action_tile "accept" (strcat
        "(setq TGA-2 (ok-fla NR TGA1 DIST))"
	"(setq TGA-3 (ok-lin NR TGA1 DIST))"
	"(done_dialog)"))
      (action_tile "cancel" "(setq TGA-2 TGA2 TGA-3 TGA3)(done_dialog)")
      (start_dialog) ))
  (list TGA-2 TGA-3 RT))
;==============================================================================
;******************************************************************************
;    V E L U X         ACCESSORIES
;******************************************************************************
;==============================================================================
(Defun vx-acc ( NR DCL-ID TGA4 TGA1 DIST
	      / COD TG ACC D-A D-M D-S L-A L-M L-S)
;============================================================================
  (Defun acc-lis ( / AC COD L-I L-O N-L N TT)
    (setq AC   (substr $key 5)
 	  COD  (car(nth(atoi $value)(eval(read(strcat "L-" (strcase AC))))))
	  L-I  '("a")
	  L-O  '("m" "s"))
    (set (read (strcat "D-" (strcase AC))) COD)
    (set_tile (strcat "cod-" AC) COD)
    (cond ((member AC L-I)
	     (setq N-L (append (cdr (member AC L-I))
			       (cdr (member AC (reverse L-I))))))
	  ((member AC L-O)
	     (setq N-L (append (cdr (member AC L-O))
			       (cdr (member AC (reverse L-O)))))) )
    (foreach N N-L
      (set_tile (strcat "lis-" N) "0")
      (set (read (strcat "D-" (strcase N))) "")
      (set_tile (strcat "cod-" N) "") )
    (setq TT (if (eq COD "")
               (list "" "")
               (cadr (cdddr (assoc COD USER-TYP-LIS)))))
    (set_tile "txt-lin-1"  (car TT))
    COD)
;------------------------------------------------------------------------------
  (Defun ok-acc (TGA1 / LIS-SIZ LIS-BOT TGA TG AC)
    (if paucheck (progn (princ "\nok-acc")(princ TGA1)(princ "\n")))
    (setq LIS-SIZ '("RHL" "RFL" "RNL" "RFU" "RLL" "MHL" "MAL")
	  LIS-BOT '("MHL" "MAL" "SCL") ; motor
          TGA  '())
    (foreach TG TGA1
     (if (not (member (get-typ TG) '("EBY")))
      (foreach AC '(D-A D-M D-S)
        (if (not (eq "" (eval AC)))
	  (if (member (get-typ TG) (caddr (assoc (eval AC) USER-TYP-LIS)))
	    (cond ((eq "   " (get-typ TG)) ; GDL bottom
 	             (setq TGA (if (or (eq "M" (substr (eval AC) 2 1))
			               (member (eval AC) LIS-BOT))
		                 (append TGA '(""))
		                 (append TGA (list
		                   (strcat (eval AC) "-"
			  	           (if (member (eval AC) LIS-SIZ) "P00-" "P04-")
				           (car(cadddr(assoc (eval AC) USER-TYP-LIS)))
	          ))))))
 	          ((eq "GDL" (get-typ TG))
 	             (setq TGA (append TGA (list
		                 (strcat (eval AC) "-"
			  	         (if (member (eval AC) LIS-SIZ) "P00-" "P10-")
				         (car(cadddr(assoc (eval AC) USER-TYP-LIS)))
	          )))))
	          (t
 	             (setq TGA (append TGA (list
		                 (strcat (eval AC) "-"
			  	         (if (member (eval AC) LIS-SIZ)
				           (strcat (substr (get-siz TG) 1 1) "00")
				           (get-siz TG))
				         "-"
				         (car(cadddr(assoc (eval AC) USER-TYP-LIS)))
	    ))))))
	    (progn
 	      (setq TGA (append TGA (list "   ")))
	      (alert (strcat " "
                             (cadr (assoc (eval AC) USER-TYP-LIS))
		  	     " \n   "
			     (if (eq "   " (get-typ TG))                                               
			       (strcat (cadr (assoc "GDL" USER-TYP-LIS))
                                       "   .")
			       (cadr (assoc (get-typ TG) USER-TYP-LIS)))
			     "!") )))))) )
    (if (eq TGA '()) (setq TGA '("")))
    TGA)
;------------------------------------------------------------------------------
  (Defun get-acc (ACC TYP / AC T-L TY)
    (if paucheck (progn (princ "\nget-acc")(princ (list ACC TYP))))
    (setq AC  (strcase ACC t)
          T-L (list (assoc "" USER-TYP-LIS)))
    (foreach TY USER-TYP-LIS
      (cond ((eq ACC (substr (car TY) 1 3))
               (setq T-L (append T-L (list TY))) )
            ((and (eq AC "a")
		  (member (substr (car TY) 1 1) '("F" "P" "R" "D")))
               (setq T-L (append T-L (list TY))) )
            ((and (eq ACC (substr (car TY) 1 1))
                  (not (member (substr (car TY) 1 3) '("MIE"))))
               (setq T-L (append T-L (list TY))) )))
    (start_list (strcat "lis-" AC))
      (mapcar 'add_list (mapcar '(lambda (TY) (cadr TY)) T-L))
    (end_list)
    (set_tile (strcat "lis-" AC) (itoa (mem-a-nr TYP T-L)))
    (set_tile (strcat "cod-" AC) TYP)
    (ima-sld (strcat "ima-" AC) (strcat "acc_" AC))
    T-L)
;------------------------------------------------------------------------------
  (if paucheck (progn (princ "\nvx-acc")(princ a-tga1)))
  (setq COD "acc")
  (foreach TG TGA4
    (cond ((member (substr TG 1 1) '("M" "S"))
             (set (read (strcat "D-" (substr TG 1 1))) (get-typ TG) ))
	  ((member (substr TG 1 1) '("F" "P" "R" "D"))
             (set (read "D-A") (get-typ TG) ))
	  ))
  (if (not D-A)
    (setq D-A   (get-default "D-A" "")))
  (if (not (or D-M D-S))
    (setq D-M   (get-default "D-M" "")
          D-S   (get-default "D-S" "")))
  (setq D-A (if (not D-A) "" D-A)
        D-M (if (not D-M) "" D-M)
        D-S (if (not D-S) "" D-S))
  (if (and (not (eq (cadr DIST) 0))
	   (< (cadr DIST) 160))
    (setq D-S ""))
  (if (and (not (eq (cadddr DIST) 0))
        (or (member (car (assoc NR U-KOMBI)) '(2 5 7 8))
            (and (not (eq (car DIST) 0))(< (car DIST) 100))
            (and (not (eq (car DIST) 0))(< (cadr DIST) 220))) )
    (setq D-S ""))
  (if (and (eq "CLI" (get-typ (car TGA1)))
           (eq "CLI" (get-typ (car (reverse TGA1)))))
    (foreach ACC '("a" "m" "s")
      (set (read (strcat "D-" ACC)) "")))
  (if (new_dialog "vx_acc_a" DCL-ID)
    (progn
      (set_tile "txt-lin-1" "")
      (setq L-A (get-acc "A" D-A)
	    L-M (get-acc "M" D-M)
            L-S (get-acc "S" D-S))
      (if (and (member (car (assoc NR U-KOMBI)) '(0))
	       (member (get-typ (car TGA1)) '("GXL")))
	(mode_tile "lis-m" 1))
      (if (or
	    (and (member (car (assoc NR U-KOMBI)) '(0))
		 (member (get-typ (car TGA1)) '("GTL" "GXL")))
	    (and (not (eq (cadddr DIST) 0))
		 (or (member (car (assoc NR U-KOMBI)) '(2 5 7 8))
		     (and (not (eq (car DIST) 0))(< (car DIST) 100))
		     (and (not (eq (car DIST) 0))(< (cadr DIST) 220))) ))
	(mode_tile "lis-s" 1))
      (foreach ACC '("a" "m" "s")
        (action_tile (strcat "lis-" ACC) "(setq COD (acc-lis))"))
      (action_tile "accept" "(setq TGA (ok-acc TGA1))(done_dialog)")
      (action_tile "cancel" "(setq TGA TGA4)(done_dialog)")
      (start_dialog)))
  TGA)
;==============================================================================
;*************************************************************************
;*************************************************************************
;    V E L U X         PIECELIST
;*************************************************************************
;==============================================================================
;==============================================================================
(Defun velux-pla (DCL-ID / STY DC)
  (if paucheck (princ "\nvelux-pla"))
  (setq STY nil
	DC  45)
  (if (new_dialog "vx_pic_a" DCL-ID)
    (progn
      (action_tile "sty-ty" "(setq STY 1)(done_dialog)")
      (action_tile "sty-sz" "(setq STY 2)(done_dialog)")
      (action_tile "accept" "(done_dialog)")
      (start_dialog)))
  STY)
;==============================================================================
(defun velux-p ( SZ DCL-ID
               / LIN-LIST LIN-WS)
;------------------------------------------------------------------------------
  (defun split-cod (VAR COD / NR N)
    (setq NR 1
          N  (if (eq "_" (substr COD 1 1)) 2 1))
    (while (< NR 15)
      (set (read (strcat VAR "-" (itoa NR))) (substr COD N 1))
      (setq N  (1+ N)
            NR (1+ NR)) ))
;------------------------------------------------------------------------------
  (defun sort-s (DATA / DT DD TY D D0 D0-5-3 DL-5-3 D0-5 DL-5 DL D1 D2)
    (setq DT '()
          DD DATA)
    (repeat (length DATA)
      (setq TY "zzzzzzzzzzzzzzz")
      (foreach D DD
	(split-cod "TY" TY)
	(split-cod "D" (car D))
        (if (or (< D-5 TY-5)
              (and (= D-5 TY-5)(< D-6 TY-6) )
              (and (= D-5 TY-5)(= D-6 TY-6)(< D-7 TY-7) )
              (and (= D-5 TY-5)(= D-6 TY-6)(= D-7 TY-7)(< D-8 TY-8) )
              (and
                (= D-5 TY-5)(= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)
		(< D-1 TY-1) )
              (and
                (= D-5 TY-5)(= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)
		(= D-1 TY-1) (< D-2 TY-2) )
              (and
                (= D-5 TY-5)(= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)
		(= D-1 TY-1)(= D-2 TY-2)(< D-3 TY-3) )
              (and
                (= D-5 TY-5)(= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(< D-4 TY-4) )
              (and
                (= D-5 TY-5)(= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)
		(< D-9 TY-9) )
              (and
                (= D-5 TY-5)(= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)
		(= D-9 TY-9)(< D-10 TY-10) )
              (and
                (= D-5 TY-5)(= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)
		(= D-9 TY-9)(= D-10 TY-10)(< D-11 TY-11) )
              (and
                (= D-5 TY-5)(= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)
		(= D-9 TY-9)(= D-10 TY-10)(= D-11 TY-11)(< D-12 TY-12) )
              (and
                (= D-5 TY-5)(= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)
		(= D-9 TY-9)(= D-10 TY-10)(= D-11 TY-11)(= D-12 TY-12)(< D-13 TY-13) )
              (and
                (= D-5 TY-5)(= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)
                (= D-9 TY-9)(= D-10 TY-10)(= D-11 TY-11)(= D-12 TY-12)(= D-13 TY-13)
                (< D-14 TY-14) )
              (and
                (= D-5 TY-5)(= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)
                (= D-9 TY-9)(= D-10 TY-10)(= D-11 TY-11)(= D-12 TY-12)(= D-13 TY-13)
                (= D-14 TY-14)(< D-15 TY-15) ))
          (setq D0  D
                TY (car D)) ))
      (setq D0-5-3 (get-siz-real (car D0)))
      (if DL
        (setq DL-5-3 (get-siz-real (car DL))) )
      (if (and DL (not (eq D0-5 DL-5)))
        (setq DT (append DT  '(("" . 0)))))
      (setq DT (append DT (list D0))
            DL D0
            D1 (cdr (member D0 DD))
            D2 (cdr (member D0 (reverse DD))) )
      (cond ((and D1 D2)
              (setq DD (append D1 D2)) )
            (D1
              (setq DD D1) )
            (D2
              (setq DD D2) ) ) )
  DT)
;------------------------------------------------------------------------------
  (defun sort-t (DATA / DT DD TY D D0 D1 D2)
    (setq DT '()
          DD DATA)
    (repeat (length DATA)
      (setq TY "zzzzzzzzzzzzzzz")
      (foreach D DD
	(split-cod "TY" TY)
	(split-cod "D" (car D))
        (if (or (< D-1 TY-1)
              (and
		(= D-1 TY-1)(< D-2 TY-2) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(< D-3 TY-3) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(< D-4 TY-4) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)(< D-5 TY-5) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)(= D-5 TY-5)
                (< D-6 TY-6) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)(= D-5 TY-5)
                (= D-6 TY-6)(< D-7 TY-7) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)(= D-5 TY-5)
                (= D-6 TY-6)(= D-7 TY-7)(< D-8 TY-8) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)(= D-5 TY-5)
                (= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)(< D-9 TY-9) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)(= D-5 TY-5)
                (= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)(= D-9 TY-9)(< D-10 TY-10) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)(= D-5 TY-5)
                (= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)(= D-9 TY-9)(= D-10 TY-10)
                (< D-11 TY-11) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)(= D-5 TY-5)
                (= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)(= D-9 TY-9)(= D-10 TY-10)
                (= D-11 TY-11)(< D-12 TY-12) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)(= D-5 TY-5)
                (= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)(= D-9 TY-9)(= D-10 TY-10)
                (= D-11 TY-11)(= D-12 TY-12)(< D-13 TY-13) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)(= D-5 TY-5)
                (= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)(= D-9 TY-9)(= D-10 TY-10)
                (= D-11 TY-11)(= D-12 TY-12)(= D-13 TY-13)(< D-14 TY-14) )
              (and
		(= D-1 TY-1)(= D-2 TY-2)(= D-3 TY-3)(= D-4 TY-4)(= D-5 TY-5)
                (= D-6 TY-6)(= D-7 TY-7)(= D-8 TY-8)(= D-9 TY-9)(= D-10 TY-10)
                (= D-11 TY-11)(= D-12 TY-12)(= D-13 TY-13)(= D-14 TY-14)(< D-15 TY-15) ))
          (setq D0 D
                TY (car D)) ))
      (setq DT (append DT (list D0))
            D1 (cdr (member D0 DD))
            D2 (cdr (member D0 (reverse DD))) )
      (cond ((and D1 D2)
              (setq DD (append D1 D2)) )
            (D1
              (setq DD D1) )
            (D2
              (setq DD D2) ) ) )
  DT)
;------------------------------------------------------------------------------
  (defun lin-p (N A D BEM SIZ MAT / LIN)
    (setq LIN (strcat
                (if (> N 9) " " "  ")
                (itoa N)
                (if (> A 9) "  " "   ")
                (itoa A)
                "   "
                (get-typ D)
                " "
                (get-siz-real D)
                " "
                (get-mat D) ))
    (repeat (- 8 (strlen (substr D 9 6)))
      (setq LIN (strcat LIN " ")))
    (setq LIN (strcat LIN BEM))
    (repeat (- 19 (strlen BEM))
      (setq LIN (strcat LIN " ")))
    (repeat (- 7 (strlen SIZ))
      (setq LIN (strcat LIN " ")))
    (setq LIN (strcat LIN SIZ "   " MAT))
    LIN)
;------------------------------------------------------------------------------
(defun get-pic-top (/ LL)
  (setq LL '()
	L  ""
        N  1)
  (repeat 50 (setq L (strcat L " "))) ; 50 space
  ; drawing name
  (setq LL (append LL (list (strcat L (getvar "dwgname")))))
  ; blanc lines
  (repeat 1 (setq LL (append LL '(""))))
  ; company text
  (setq LL (append LL '("VELUX sterreich GmbH"
			"A-2120 Wolkersdorf"
			"Tel: 02245/32350"
			"Fax: 02245/3235 655"
			"Internet: www.VELUX.at"
			"E-mail: office.V-A@VELUX.com")))
  ; date
  (setq D  (substr (rtos (getvar "CDATE")) 1 8)
        LL (append LL (list
           (strcat L L (substr D 7 2)  " " (substr D 5 2) " " (substr D 1 4)))))
  ; blanc lines
  (repeat 3 (setq LL (append LL '(""))))
  ; heading text
  (setq LL (append LL '("STCKLISTE" "Pos. Stk.  Produktbezeichnung")))
  LL)
;------------------------------------------------------------------------------
  (defun get-pic ( SZ
                 / SS N M NN DATA DATA1 DATA2 DATA3 DATA4 DATA5
                   EL-TXT BLK-LIS BLK-NAM IP TBL-BLK TBL-B
                   NR SEC PIT DIS
		   TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS TGA5-LIS
                   DATE F D DD LIN-LIST LIN A BEM SIZ MAT
                   D-TY D-SI D-MA)
    (setq SS       (ssget)
          N        0
          M        (sslength SS)
          DATA1    '()
          DATA2    '()
          DATA3    '()
          DATA4    '()
          DATA5    '()
	  PIC-GLAS  t
	  PIC-EL-WIN  nil
	  PIC-FIRE-WIN  nil
	  PIC-EL-ACC  nil
	  PIC-SOL-ACC  nil)
    (while (< N M)
      (setq NN      0
            BLK-LIS (entget (ssname SS N))
            N       (1+ N))
      (if (and (eq "INSERT" (cdr (assoc 0 BLK-LIS)))
	       (or 
                 (eq "VELUX-" (substr (cdr (assoc 2 BLK-LIS)) 1 6))
                 (eq "velux-" (substr (cdr (assoc 2 BLK-LIS)) 1 6))))
        (progn
          (setq BLK-NAM (cdr (assoc 2 BLK-LIS))
                IP      (cdr (assoc 10 BLK-LIS))
                TBL-BLK (tblsearch "BLOCK" BLK-NAM)
                TBL-B   (entget (cdr (assoc -2 TBL-BLK))) )
          (if (and (eq "INSERT" (cdr (assoc 0 TBL-B)))
		   (or
                     (eq "VELUX"  (cdr (assoc 2 TBL-B)))
                     (eq "velux"  (cdr (assoc 2 TBL-B))) ))
            (progn
	      (setq DATA     (get-attrib TBL-B)
                    ;NR       (nth 0 DATA)
                    ;SEC      (nth 1 DATA)
                    ;PIT      (nth 2 DATA)
                    ;DIS      (nth 3 DATA)
                    TGA1-LIS (nth 4 DATA)
                    TGA2-LIS (nth 5 DATA)
                    TGA3-LIS (nth 6 DATA)
                    TGA4-LIS (nth 7 DATA)
                    TGA5-LIS (nth 8 DATA))
              (foreach D TGA1-LIS
                (if (eq "CLI" (get-typ D))
                  (setq D (strcat D "0000")))
                (if (not (eq D ""))
                  (if (eq "EBY" (get-typ D))
                    (if (setq DD (assoc D DATA3))
                      (setq DATA3 (subst (cons (car DD) (1+ (cdr DD))) DD DATA3))
                      (setq DATA3 (append DATA3 (list (cons D 1)))) )
                    (if (setq DD (assoc D DATA1))
                      (setq DATA1 (subst (cons (car DD) (1+ (cdr DD))) DD DATA1))
                      (setq DATA1 (append DATA1 (list (cons D 1)))) ) )))
              (foreach D TGA2-LIS
                (if (not (eq D ""))
                  (if (setq DD (assoc D DATA2))
                    (setq DATA2 (subst (cons (car DD) (1+ (cdr DD))) DD DATA2))
                    (setq DATA2 (append DATA2 (list (cons D 1)))) )))
              (foreach D TGA3-LIS
                (if (not (eq D ""))
                  (if (setq DD (assoc D DATA3))
                    (setq DATA3 (subst (cons (car DD) (1+ (cdr DD))) DD DATA3))
                    (setq DATA3 (append DATA3 (list (cons D 1)))) )))
              (foreach D TGA4-LIS
                (if (not (eq D ""))
                  (if (setq DD (assoc D DATA4))
                    (setq DATA4 (subst (cons (car DD) (1+ (cdr DD))) DD DATA4))
                    (setq DATA4 (append DATA4 (list (cons D 1)))) )))
              (foreach D TGA5-LIS
                (if (not (eq D ""))
                  (if (setq DD (assoc D DATA5))
                    (setq DATA5 (subst (cons (car DD) (1+ (cdr DD))) DD DATA5))
                    (setq DATA5 (append DATA5 (list (cons D 1)))) ))) )) )) )
    (if SZ
      (setq DATA  (append DATA1 DATA2 DATA3 DATA4 DATA5)
            DATA  (sort-s DATA) )
      (setq DATA1 (sort-t DATA1)
            DATA2 (sort-t DATA2)
            DATA3 (sort-t DATA3)
            DATA4 (sort-t DATA4)
            DATA5 (sort-t DATA5)
            DATA  (append DATA1 '(("" . 0 )) DATA2 '(("" . 0 ))
	                  DATA3 '(("" . 0 )) DATA4 '(("" . 0 )) DATA5) ) )
    (setq USER-LIN-LIST '()
	  LIN-LIST (get-pic-top)
          N 0)
    (foreach DD DATA
      (setq N   (1+ N)
            D   (car DD)
            A   (cdr DD))
      (if (or (not D)(eq D ""))
        (setq N (1- N)
              LIN-LIST (append LIN-LIST '("")))
        (progn
          (setq D-TY (get-typ D)
                D-SI (get-siz-real D)
                D-MA (get-mat D))
          (if (setq T-L (assoc D-TY USER-TYP-LIS))
            (setq SIZ (if (and (member D-TY U-WIN)
			       (assoc D-SI USER-SIZ-LIS))
	                (cadr (assoc D-SI USER-SIZ-LIS))
                        "---")
                  MAT (cond ((member D-TY U-WIN)
			       (if (eq "e" (substr D 1 1)) (setq PIC-EL-WIN t))
                               (if (eq "b" (substr D 1 1)) (setq PIC-FIRE-WIN t))
                               (strcat (cadr (assoc (substr D-MA 1 1) U-WIN-MAT1))
				       ","
				       (cadr (assoc (substr D-MA 2 1) U-WIN-MAT2))))
                            ((member D-TY U-FLA)
                               (strcat (cadr (assoc (substr D-MA 1 1) U-FLA-MAT1))
				       ","
				       (cadr (assoc (substr D-MA 2 1) U-FLA-MAT2))))
                            ((member D-TY U-LIN)
                               (strcat (cadr (assoc (substr D-MA 1 1) U-LIN-MAT1))
				       ","
				       (cadr (assoc (substr D-MA 2 1) U-LIN-MAT2))))
                            (t
			       (if (eq "M" (substr D-TY 2 1))
				 (setq PIC-EL-ACC t))
			       (if (and (eq "S" (substr D-TY 2 1))
					(not (member D-TY '("LSC" "LSD" "LST"))))
				 (setq PIC-SOL-ACC t))
			       "----"))
                  BEM (if (cadr T-L)
                        (cadr T-L)
                        "") )
            (setq SIZ ""
                  MAT ""
                  BEM "") )
          (if (not (member D-TY '("" "   ")))
            (setq USER-LIN-LIST (append USER-LIN-LIST
                                        (list (strcat (itoa (cdr DD)) "  " (car DD))))
                  LIN (lin-p N A D SIZ BEM MAT)
                  LIN-LIST (append LIN-LIST (list LIN))) ) )) )
    (if PIC-GLAS (setq LIN-LIST (append LIN-LIST '(""
      "Verglasung:"
      "4 mm ESG auen, 2 x 3 mm VSG innen"
      "warm edge - Abstandsprofil aus rostfreiem Stahl"))))
    (if PIC-EL-WIN (setq LIN-LIST (append LIN-LIST '(""
      "Komponenten INTEGRA:" 
      "Schwingflgelfenster, Fensterffnermotor verdeckt eingebaut," 
      "elektronisches Steuersystem, Infrarot-Empfnger" 
      "Regensensor und Fernbedieung"))))
    (if PIC-FIRE-WIN (setq LIN-LIST (append LIN-LIST '(""
      "Komponenten Brandrauch:" 
      "Schwingflgelfenster, Fensterffnermotor verdeckt eingebaut," 
      "1,5 m lange silikonisierte Versorgungsleitung"))))
    (if PIC-EL-ACC (setq LIN-LIST (append LIN-LIST '(""
      "Bei elektrisch bettigten Dekorations- bzw. Hitzeschutzprodukten" 
      "ist zustzlich ein Steuerungssystem notwendig" 
      "Ausgenommen Fenstertyp Schwingflgel INTEGRA, Steuerung bereits vorhanden"))))
    (if PIC-SOL-ACC (setq LIN-LIST (append LIN-LIST '(""
      "Solar-Rollladen mit Speicherbatterie und Radiofrequenz-Technologie" 
      "keine Verkabelung und kein zustzliches Steuersystem notwendig"))))
  LIN-LIST)
;------------------------------------------------------------------------------
  (if paucheck (princ "\nvelux-p"))
  (setq LIN-LIST (get-pic SZ))
  (if (new_dialog "vx_pic2_a" DCL-ID)
    (progn
      (start_list "lin-list")
        (mapcar 'add_list LIN-LIST)
      (end_list)
      (action_tile "wri"    "(setq LIN-WS t)(done_dialog)")
      (action_tile "sav"    "(setq LIN-WS nil)(lin-sav LIN-LIST)")
      (action_tile "cancel" "(setq LIN-WS nil)(done_dialog)")
      (start_dialog)))
  (if LIN-WS (lin-wri LIN-LIST)) )
;==============================================================================
;==============================================================================
;*************************************************************************
;    V E L U X         C O N F I G U R A T I O N
;*************************************************************************
;==============================================================================
(Defun velux-cfg ( DCL-ID
		 / LAY-LIS LAY L N COL COL-LIS SC-LIS NR S SC-NR TOG OK FIL
                   C1-NR C2-NR C3-NR C4-NR C5-NR C6-NR C7-NR C8-NR C9-NR C10-NR
                   L1-NR L2-NR L3-NR L4-NR L5-NR L6-NR L7-NR L8-NR L9-NR L10-NR)
;..............................................................................
  (defun ip-set ()
    (if (eq $KEY "bot")
      (set_tile "top" "0")
      (set_tile "bot" "0"))
    $KEY)
;..............................................................................
  (defun tog-set ()
    (set (read (strcat "USER-T" (substr $key 5)))
      (if (eq "0" $value) "off" "on")))
;..............................................................................
  (defun col-set ( / N)
    (setq N (substr $key 5))
    (if (eq "0" $value)
      (progn
        (set_tile (strcat "col-cfg" N) "-")
        (mode_tile (strcat "col-cfg" N) 1))
      (progn
        (set_tile (strcat "col-cfg" N)
		  (eval (read (strcat "C" N "-NR"))))
        (mode_tile (strcat "col-cfg" N) 0))))
;..............................................................................
(defun done-cfg	(LAG-LIS SC-LIS / NN)
  (setq N 1)
  (repeat 10
    (if	(not (eq N 5))
      (progn
	(if (eq "0" (get_tile (strcat "col-" (itoa N))))
	  (set (read (strcat "USER-C" (itoa N))) "256")
	  (if (eq "-" (get_tile (strcat "col-cfg" (itoa N))))
	    (set (read (strcat "USER-C" (itoa N))) "256")
	    (set (read (strcat "USER-C" (itoa N)))
		 (get_tile (strcat "col-cfg" (itoa N))) )))
	(set (read (strcat "USER-L" (itoa N)))
	     (nth (atoi (get_tile (strcat "lay-cfg" (itoa N)))) LAY-LIS))))
    (setq N (1+ N)))
  (setq	USER-SC-TXT (atof (get_tile "sc-txt"))
	USER-SCALE  (car (nth (atoi (get_tile "scale")) SC-LIS)))
)
;..............................................................................
  (if paucheck (princ "\nvelux-cfg"))
  (setq LAY-LIS '()
	N       1)
  (repeat 10
    (if (not (eq N 5))
      (progn
        (setq L (eval (read (strcat "USER-L" (itoa N)))))
        (if (not (member L LAY-LIS))
	  (setq LAY-LIS (append LAY-LIS (list L))) )))
    (setq N (1+ N)))
  (setq LAY (cdr (assoc 2 (tblnext "layer" t))))
  (if (not (member LAY LAY-LIS))
    (setq LAY-LIS (append LAY-LIS (list LAY))) )
  (while (setq L (tblnext "layer"))
    (setq LAY (cdr (assoc 2 L)))
    (if (not (member LAY LAY-LIS))
      (setq LAY-LIS (append LAY-LIS (list LAY))) ) )
  (setq N 1)
  (repeat 10
    (if (not (eq N 5))
      (progn
        (setq COL (eval (read (strcat "USER-C" (itoa N))))
              LAY (eval (read (strcat "USER-L" (itoa N)))) )
        (set (read (strcat "C" (itoa N) "-NR")) (if (/= "256" COL) COL "0"))
        (set (read (strcat "L" (itoa N) "-NR"))
	     (itoa (- (length LAY-LIS) (length (member LAY LAY-LIS))))) ))
    (setq N (1+ N)))
  (setq COL-LIS (list "" "")
        SC-LIS  '((1     "")
                  (0.1   "")
                  (0.001 ""))
        NR      0
	N       1)
    
  (foreach S SC-LIS
     (if (< (abs (- (car S) USER-SCALE)) 0.0001)
       (setq SC-NR (itoa NR)))
     (setq NR (1+ NR)))
    
  (if (new_dialog "vx_cfg_a" DCL-ID)
    (progn
      (repeat 10
        (if (not (eq N 5))
          (progn
            (start_list (strcat "col-" (itoa N)))
              (mapcar 'add_list COL-LIS)
            (end_list)
            (start_list (strcat "lay-cfg" (itoa N)))
              (mapcar 'add_list LAY-LIS)
            (end_list)
            (set_tile (strcat "lay-cfg" (itoa N))
		      (eval (read (strcat "L" (itoa N) "-NR"))))
            (if (eq "0" (eval (read (strcat "C" (itoa N) "-NR"))))
              (progn
                (set_tile (strcat "col-" (itoa N)) "0")
                (set_tile (strcat "col-cfg" (itoa N)) "-")
                (mode_tile (strcat "col-cfg" (itoa N)) 1))
              (progn
                (set_tile (strcat "col-" (itoa N)) "1")
                (set_tile (strcat "col-cfg" (itoa N))
		          (eval (read (strcat "C" (itoa N) "-NR"))))
                (mode_tile (strcat "col-cfg" (itoa N)) 0))) ))
	(setq N (1+ N)))
      (ima-sld "ima" "config")

      (foreach TOG '("8" "9" "10") 
        (if (eq "on" (eval (read (strcat "USER-T" TOG))))
          (set_tile (strcat "tog-" TOG) "1")
          (set_tile (strcat "tog-" TOG) "0")))
	
      (set_tile "sc-txt" (rtos USER-SC-TXT 2 2))

      (start_list "scale")
        (mapcar 'add_list (mapcar '(lambda (L) (cadr L)) SC-LIS))
      (end_list)
      (set_tile "scale" SC-NR)

      (if (eq "top" USER-IP)
        (progn
          (set_tile "top" "1")
          (set_tile "bot" "0"))
        (progn
          (set_tile "top" "0")
          (set_tile "bot" "1")))
      
      (setq N 1)
      (repeat 10
	(if (not (eq N 5))
          (action_tile (strcat "col-" (itoa N)) "(col-set)"))
	(setq N (1+ N)))
      (foreach TOG '("8" "9" "10")
        (action_tile (strcat "tog-" TOG) "(tog-set)"))
      (action_tile "bot" "(setq USER-IP (ip-set))")
      (action_tile "top" "(setq USER-IP (ip-set))")
      (action_tile "accept" "(setq OK t)(done-cfg LAY-LIS SC-LIS)(done_dialog)")
      (action_tile "cancel" "(setq OK nil)(done_dialog)")
      (start_dialog)
      
      (if (not VELUX-DIR)
        (setq VELUX-DIR VELUX-DIR))
      (if OK
        (if (setq FIL (open (strcat VELUX-DIR "velux.cfg") "w"))
          (progn
	    (princ "\n; Konfiguration von VELUXCAD\n\n" FIL)
	    (princ "\n; Scheibe" FIL)
	    (princ "\n; Flgel/Rahmen" FIL)
	    (princ "\n; Blechteile" FIL)
	    (princ "\n; 4. Dach- u. Raumanschluss" FIL)
	    (princ "\n; 5. Hitzeschutz/Dekoration" FIL)
	    (princ "\n; 6. Rote Linie" FIL)
	    (princ "\n; 7. Schraffur" FIL)
	    (princ "\n; 8. 3D Dummysolid" FIL)
	    (princ "\n;    9. Typenbezeichnung" FIL)
	    (princ "\n;    10. Einfgepunkt" FIL)
	    (princ "\n\n(setq\n" FIL)
	    (setq N 1)
	    (repeat 10
	      (if (not (eq N 5))
		(progn
                  (princ (strcat "\n\nUSER-C" (itoa N) " " (chr 34)) FIL)
                  (princ (eval (read (strcat "USER-C" (itoa N)))) FIL)
	          (princ (chr 34) FIL)
                  (princ (strcat "\nUSER-L" (itoa N) " " (chr 34)) FIL)
                  (princ (eval (read (strcat "USER-L" (itoa N)))) FIL)
	          (princ (chr 34) FIL))
		(progn
                  (princ (strcat "\n\nUSER-C5 " (chr 34)) FIL)
                  (princ (eval (read "USER-C4")) FIL)
	          (princ (chr 34) FIL)
                  (princ (strcat "\nUSER-L5 " (chr 34)) FIL)
                  (princ (eval (read "USER-L4")) FIL)
	          (princ (chr 34) FIL) ))
	      (setq N (1+ N)))
	    (foreach TOG '("8" "9" "10")
              (princ (strcat "\nUSER-T" TOG " " (chr 34)) FIL)
              (princ (eval (read (strcat "USER-T" TOG))) FIL)
	      (princ (chr 34) FIL))
            (princ "\n\nUSER-SC-TXT " FIL)(princ USER-SC-TXT FIL)
            (princ "\nUSER-SCALE " FIL)(princ USER-SCALE FIL)
            (princ "\nUSER-IP " FIL)
            (princ (chr 34) FIL)(princ USER-IP FIL)(princ (chr 34) FIL)
            (princ "\n\n)" FIL)
            (close FIL) )
          ((alert (strcat "!"
            "\n        ."
            "\n :    .  "
            "\n       ."))
	  ) ))))
;==============================================================================
;******************************************************************************
;    V E L U X   helpfunktions
;******************************************************************************
;==============================================================================
(defun get-default (TILEKEY NOTHING / DEFAUL)
  (setq U-DEFAULT '(
  ("PRO" "1")
  ("FLA" "0")
  ("PLA" "0")
  ("NON" "0")
  ("XX1" "1")
  ("XX2" "0")
  ("XX3" "0")
  ("D-A" "")
  ("D-M" "")
  ("D-S" "")
  ))
  (if (setq DEFAUL (assoc TILEKEY U-DEFAULT))
    (cadr DEFAUL)
    NOTHING))
;==============================================================================
(defun get-attrib (TBL-B)
  (setq TBL-B (entget (entnext (cdr (assoc -1 TBL-B))))
        NR    (read (cdr (assoc 1 TBL-B)))
        TBL-B (entget (entnext (cdr (assoc -1 TBL-B))))
        SEC   (read (cdr (assoc 1 TBL-B)))
        TBL-B (entget (entnext (cdr (assoc -1 TBL-B))))
        PIT   (read (cdr (assoc 1 TBL-B)))
        TBL-B (entget (entnext (cdr (assoc -1 TBL-B))))
        DIS   (read (cdr (assoc 1 TBL-B)))
        TBL-B (entget (entnext (cdr (assoc -1 TBL-B))))
        TGA1  (read (cdr (assoc 1 TBL-B)))
        TBL-B (entget (entnext (cdr (assoc -1 TBL-B))))
        TGA2  (read (cdr (assoc 1 TBL-B)))
        TBL-B (entget (entnext (cdr (assoc -1 TBL-B))))
        TGA3  (read (cdr (assoc 1 TBL-B)))
        TBL-B (entget (entnext (cdr (assoc -1 TBL-B))))
        TGA4  (read (cdr (assoc 1 TBL-B)))
	TBL-B (entget (entnext (cdr (assoc -1 TBL-B))))
        TGA5  (read (cdr (assoc 1 TBL-B)))
	TBL-B (entget (entnext (cdr (assoc -1 TBL-B)))) )
  (list NR SEC PIT DIS TGA1 TGA2 TGA3 TGA4 TGA5))
;==============================================================================
(Defun lin-wri (LIN-LIST / STY FIL FIL1 FIL2 FIL3 IP H LIN)
  (setq STY  (getvar "textstyle")
	FIL3 "monotxt.shx")
  (if (tblsearch "style" "velux-mono")
    (setvar "textstyle" "velux-mono")
    (progn
      (if (setq FIL (findfile FIL3))
        (command "_.style" "velux-mono" FIL3 "0" "0.8" "" "" "" "") ) ))
  (setq IP (getpoint "Einfgepunkt fr Text: "))
  (if (eq 0 (cdr (assoc 40 (tblsearch "style" (getvar "textstyle")))))
    (setq H (getdist IP "Texthhe:")))
  (command "_mtext" IP "_s" "VELUX-MONO" "_h" H "_w" (* H 1000))
  (mapcar '(lambda (LIN)
	     (if (eq "" LIN)
	       (command " ")
	       (command LIN)))
	  (cdr LIN-LIST))
  (command "")
  (setvar "textstyle" STY) )
;==============================================================================
(Defun lin-sav (LIN-LIST / FF FIL LIN)
  (setq FF (getfiled "Dateiname: " "" "" 11))
  (if (setq FIL (open FF "w"))
    (progn
      (mapcar '(lambda (LIN)
                  (write-line LIN FIL))
      LIN-LIST)
      (close FIL))
    (princ (strcat "Dateiname: " FF
		   "\n" "Die Datei kann nicht geffnet werden!"))))
;==============================================================================
;------------------------------------------------------------------------------
(defun first? (N NA)
  (and (> N 1)(eq (gcd (1- N) NA) NA)) )
;------------------------------------------------------------------------------
(defun middle? (N NA)
  (and (not (first? N NA))
       (not (last? N NA))) )
;------------------------------------------------------------------------------
(defun last? (N NA)
  (eq (gcd N NA) NA) )
;------------------------------------------------------------------------------
;==============================================================================
(defun v-text (NO)
  (if (assoc NO U-TEXT) 
    (cadr (assoc NO U-TEXT)) 
    (strcat (itoa NO) 
      ".. No text! . . . . . . . . . . . . . . . . . . . . . . . . . . ."
      ". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .")))
;==============================================================================
(Defun ima-sld (I S / X Y)
  (if PAUCHECK (set_tile "error" (strcat "Slidename is : " S)))
  (if PAUSLIDE (alert (strcat "Slidename is : " S)))
  (if PAUCHECK (progn (princ "\n")(princ (list i s))(princ "\n")))
  (setq X (- (dimx_tile I) 1)
        Y (- (dimy_tile I) 1))
  (start_image I)
    (fill_image 0 0 X Y -2)
    (slide_image 0 0 X Y (strcat VELUX-DIR "velux(" S ")"))
  (end_image) )
;------------------------------------------------------------------------------
(Defun st-lis (TILE LIS VAL)
  (start_list TILE)
  (mapcar 'add_list LIS)
  (end_list)
  (set_tile TILE VAL))
;------------------------------------------------------------------------------
(Defun st-li (TILE LIS N VAL / L)
  (start_list TILE)
  (mapcar 'add_list (mapcar '(lambda (L) (nth N L)) LIS))
  (end_list)
  (set_tile TILE VAL))
;------------------------------------------------------------------------------
(Defun mem-a-nr (ELE LIS)
  (if (assoc ELE LIS)
    (1- (length (member (assoc ELE LIS) (reverse LIS))))
    0))
;------------------------------------------------------------------------------
(Defun mem-nr (ELE LIS)
  (if (member ELE LIS)
    (1- (length (member ELE (reverse LIS))))
    0))
;==============================================================================
(DeFun get-typ (CD)
  (cond ((not CD)            "")
        ((<= (strlen CD) 3)  CD)
	((eq "-" (substr CD 4 1))  (substr CD 1 3))
	((eq "-" (substr CD 5 1))  (substr CD 1 4));old VES
	(t                         "")))
;==============================================================================
(DeFun get-siz (CD)
  (cond ((not CD)            "")
        ((eq "-" (substr CD 4 1)) (substr CD 5 3))
	((eq "-" (substr CD 5 1)) (substr CD 6 3));old VES
	(t                         "")))
;==============================================================================
(DeFun get-siz-real (CD)
  (cond ((not CD)            "")
        ((and (eq "-" (substr CD 4 1))
	      (member (substr CD 1 3) '("GIL" "GIU" "GEL")))
	   (strcat (substr CD 5 3) "-"))
        ((and (eq "-" (substr CD 4 1))
	      (member (substr CD 1 3) '("VIU")))
	   (strcat (substr CD 5 3) "_"))
        ((eq "-" (substr CD 4 1)) (substr CD 5 3))
	((eq "-" (substr CD 5 1)) (substr CD 6 3));old VES
	(t                         "")))
;==============================================================================
(DeFun get-mat (CD)
  (cond ((not CD)            "")
        ((eq "-" (substr CD 4 1))  (substr CD 9))
	((eq "-" (substr CD 5 1))  (substr CD 10));old VES
	(t                         "")))
;==============================================================================
(DeFun get-ma123 (CD)
  (substr (get-mat CD) 1 3))
;==============================================================================
(DeFun get-ma2 (CD)
  (substr (get-mat CD) 2 1))
;==============================================================================
(DeFun get-ma34 (CD)
  (substr (get-mat CD) 3 2))
;==============================================================================
(defun dtr (DD)
  (/ (* pi DD) 180.0))
;==============================================================================
(defun rtd (RR)
  (/ (* 180.0 RR) pi))
;==============================================================================
;------------------------------------------------------------------------------
;==============================================================================

;******************************************************************************
;                   Diverse systemfunktioner
;******************************************************************************
(defun pauerror (ET)
; Error function to handle all error situations.
; Variables:
;  Global: USER-VAR
;  Input : ET : The error text.
;==============================================================================
  (if USER-VAR (sys-var nil))
  (cond ((member ET '("Function cancelled" "console break"))
          (alert ET) )
        (t
          (alert (strcat
	    "\nIm Programm ist ein Fehler aufgetreten!\n"
	    ET
	    "\nBitte setzen Sie sich mit VELUX in Verbindung.\n"
            "VELUX Osterreich GmbH\n"
	    "A-2120 Wolkersdorf      : 02245/32350\n"
	    ": www.VELUX.at  . : office.V-A@VELUX.com"
	     ))))
  (prin1))
;==============================================================================
(defun sys-var (ST / I)
; Sets and resets some system variables.
; Variables:
;  Global: USER-VAR
;          USER-LAG
;  Input : ST : which is T for setting and nil for resetting.
;  Local : I  : Loop variable.
;==============================================================================
  (if ST
    (progn
      (command "_.undo" "_begin")
      (foreach I '( ("cmdecho" 0)    ("menuecho" 3)  ("blipmode" 1)
                    ("attdia" 0)     ("attmode" 1)
		    ("aunits" 3)     ("lunits" 2)
                    ;("auprec" 1)     ("luprec" 0)
                    ("osmode" 0)     ("regenmode" 1) ("highlight" 1)
                    ("snapmode" 0)   ("angdir" 0)    ("angbase"  0.0)
                    ("snapang"  0.0) ("texteval" 1)  ("mirrtext" 0)
                  )
        (setq USER-VAR (cons (list (car I) (getvar (car I))) USER-VAR))
        (setvar (car I) (cadr I)) )
      (setq USER-VAR (cons (list "*error*" *error*) USER-VAR)
            USER-LAG (getvar "clayer")
            *error* pauerror))
    (progn
      (command "_.LAYER" "_th" USER-LAG "_s" USER-LAG "")
      (command "_.undo" "_end")
      (foreach I (cdr USER-VAR) (setvar (car I) (cadr I)) )
      (setq *error*  (cadar USER-VAR)
            USER-VAR nil
            USER-LAG nil) )) )
;******************************************************************************
;==============================================================================
;(setfunhelp "c:velux-1" "velux.ahp" "velux-1")
;(help "velux.ahp" "velux-1")
  (C:velux-menu)
;******************************************************************************
; www.pausoft.dk
;==============================================================================
(defun c:v () (c:velux-1))
(defun c:vv () (c:pau)(c:velux-1))
(defun c:no-rot ()
  (setq USER-ROT-VENT nil
	USER-ROT-SASH nil
	USER-ROT      nil)
  (princ "no rotation"))
(defun c:no-txt ()
  (setq U-TEXT nil)
  (princ "no text"))
(defun c:pau ()
  (setq user-rot t)
  (princ "rotation on")
  (setq pauerror nil)
  (setq paucheck t)
  (setvar "attmode" 2)
  (setvar "globcheck" 3))
(prin1)
;******************************************************************************
;==============================================================================
