; ***************************************************************************
;  (prompt (strcat (v-text 9010)(v-text 9020)))
  (prompt "Programm wird geladen.    Bitte warten!    Danke!")
  (if (not get-3d-l)(load (strcat VELUX-DIR "velux_3d.lsp")))
;==============================================================================
;;;
;;; VELUX-3.LSP
;;; PAUsoft (+45 46 18 59 85)
;;;
;==============================================================================
; ***************************************************************************
; *                                                                         *
; *  VELUX-3.LSP                                    User   VELUX            *
; *                                                                         *
; *  Version   1.00 for R2000                       Author  PAU-SOFT        *
; *                                                                         *
; *                                                                         *
; *  Functions defined and used by this program:                            *
; *                                                                         *
; *                                                                         *
; *     rot-3d-prep                                                         *
; *     rot-3d-do                                                           *
; *     do-bl-3                                                             *
; *     do-block-3                                                          *
; *                                                                         *
; *     boks                                                                *
; *     k-tegn                                                              *
; *     flas                                                                *
; *     pss-boks                                                            *
; *     ptb-tegn                                                            *
; *     psx-tegn                                                            *
; *     psl-tegn                                                            *
; *     psr-tegn                                                            *
; *     red-lix                                                             *
; *     red-lin                                                             *
; *     b-tegn                                                              *
; *     m-tegn                                                              *
; *     f-tegn                                                              *
; *     gvo-glass                                                           *
; *                                                                         *
; *     i-3d-0                                                              *
; *     i-3d-1                                                              *
; *     i-3d-2                                                              *
; *     i-3d-3                                                              *
; *     i-3d-4                                                              *
; *                                                                         *
; *     get-data                                                            *
; *     ins-3d                                                              *
; *                                                                         *
; *                                                                         *
; *                                                                         *
; *  Files using by this program                                            *
; *                                                                         *
; *     velux-3d.lsp                                                        *
; *                                                                         *
; *  Revision :                                                             *
; *                                                                         *
; ***************************************************************************

;*************************************************************************
;*************************************************************************
;    V E L U X         DANNELSE AF 3D VINDUE
;*************************************************************************
;============================================================================
;*************************************************************************
;    rotering og blokning
;*************************************************************************
;============================================================================
(defun rot-3d-prep ()
  (if paucheck (princ "\nrot-3d-prep"))
  (command "_.ucs" "_D" "VELUX"
           "_.ucs" "_S" "VELUX"
           "_.ucs" "_W"))
;============================================================================
(defun rot-3d-do (SS IP DCH YY)
  (if paucheck (princ "\nrot-3d-do"))
  (if SS 
    (progn
      (command "_.ucs" "_W"
               "_.ucs" "_X" (/ pi 2.0))
      (if YY (command "_.UCS" "_Y" (/ pi 2.0)))
      (command "_.rotate" SS "" (trans IP 0 1) (dtr DCH)
               "_.ucs" "_W")) ))
;============================================================================
(defun do-bl-3 (BN I-P SS-B ROT Y / BNN)
  (if paucheck (princ "\ndo-bl-3"))
  (if (and SS-B (> (sslength SS-B) 0))
    (progn
      (setq BNN (strcat BN (substr (rtos (getvar "date") 2 10) 1 7)
                        "-" (substr (rtos (getvar "date") 2 10) 9 9)))
      (while (tblsearch "BLOCK" BNN)
	(setq BNN (strcat BNN "-")))
      (command "_.block" BNN I-P SS-B ""
               "_.insert" BNN I-P 1 1 0)
      (if (or (eq BN "extra")
              (and (eq BN "vent") USER-ROT-VENT)
              (and (eq BN "sash") USER-ROT-SASH))
        (rot-3d-do (entlast) I-P ROT Y)) )) )
;============================================================================
(defun do-block-3 ( SS INS-P SS-F SS-S SS-V TYP STR ROLLER DCH
                / 3D-LIS SASH RT-S RP-S VENT RT-V RP-V)
  (if paucheck (princ "\ndo-block-3"))
;*** blok frame,sash and ventilation - rotate sash and ventilation ***
  (if (setq 3D-LIS (get-3d-l TYP STR))
    (progn
      (setq SASH   (assoc "sash" (cdr 3D-LIS))
            RT-S   (if (eq TYP "GDL-b")
                     (- 90 DCH)
                     (cadr (assoc "rot-p"  (cdr SASH))))
            RP-S   (caddr (assoc "rot-p"  (cdr SASH)))
            RP-S   (list (+ (car INS-P)
                            (if (member TYP '("VFA" "VEB"))
                              (- BRE (car RP-S))
                              (car RP-S)))
                         (+ (cadr INS-P) (cadr RP-S)
                            (cond ((member TYP '("GHL" "dGHL" "GPU" "dGPU" "GPL" "dGPL" "GTL" "GTU"
                                                 "GIL" "GIU" "GEL" "GDL-t"
						 "_GHL"))
                                     HOJ)
                                  ((member TYP '("VFE" "VFA" "VFB" "VIU" "GDL-b"
                                                 "VEC" "VEA" "VEB" "GXL"
						 "GVT" "_GVT" "_GVO" "GVO"
						 "GVA" "_GVA" "VLT" "_VLT"))
                                     0)
                                  (t (/ HOJ 2.0))))
                         (+ (caddr INS-P) (caddr RP-S))) )
      (if (setq VENT (assoc "ventil" (cdr 3D-LIS)))
        (setq RT-V   (cadr (assoc "rot-p"  (cdr VENT)))
              RP-V   (caddr (assoc "rot-p"  (cdr VENT)))
              RP-V   (list (+ (car INS-P)(car RP-V))
                           (+ (cadr INS-P) (cadr RP-V) HOJ)
                           (+ (caddr INS-P) (caddr RP-V))) )
        (setq RT-V 0
              RP-V '(0 0 0)) )
      (do-bl-3 "vent" RP-V SS-V RT-V t)
      (setq SS-S (ssadd (entlast) SS-S))
      (cond ((and ROLLER (member TYP '("GHL" "dGHL" "GPU" "dGPU" "GPL" "dGPL" "GTL" "GTU" "GEL" "GDL-t"
				       "_GHL")))
              (do-bl-3 "sash" RP-S SS-S (* -1(rtd(atan(/ 250.0 HOJ)))) t))
            ((member TYP '("VFB" "VEA" "GXL" "GVT"
			   "_GVT" "_GVO" "GVO" "GVA" "_GVA" "VLT" "_VLT"))
              (do-bl-3 "sash" RP-S SS-S RT-S nil))
            ((member TYP '("VFA" "VEB"))
              (do-bl-3 "sash" RP-S SS-S (* -1 RT-S) nil))
            (t
              (do-bl-3 "sash" RP-S SS-S RT-S t)))
      (setq SS (ssadd (entlast) SS))
      (do-bl-3 "frame" INS-P SS-F 0 t)
      (setq SS (ssadd (entlast) SS)) ))
  SS)
;============================================================================
;*************************************************************************
;    diverse tegnefunktioner
;*************************************************************************
;==============================================================================
(defun boks (SS IP BRE HOJ TYK LAY COL / P2 P3 P4 P5 P6 P7 P8)
  (if paucheck (princ "\nboks"))
  (setq P2 (list (+ (car IP) BRE) (cadr IP) (caddr IP))
        P3 (list (car IP) (+ (cadr IP) HOJ) (caddr IP))
        P4 (list (+ (car P3) BRE) (cadr P3) (caddr P3))
        P5 (list (car P3) (cadr P3) (+ (caddr P3) TYK))
        P6 (list (car P4) (cadr P4) (+ (caddr P4) TYK))
        P7 (list (car IP) (cadr IP) (+ (caddr IP) TYK))
        P8 (list (car P2) (cadr P2) (+ (caddr P2) TYK))
        SS (b-tegn SS IP P2 P3 P4 P5 P6 P7 P8 LAY COL) )
  SS)
;============================================================================
(defun k-tegn (SS IP BRE HOJ TYK LAY COL DB DT
              / P1 P2 P3 P4 P5 P6 P7 P8 ML)
  (if paucheck (princ "\nk-tegn"))
  (setq P1  IP
        P2  (list (car IP)(cadr IP)(+ (caddr IP) TYK))
        P3  (list (car IP)(+ (cadr IP) HOJ)(caddr IP))
        P4  (list (car IP)(+ (cadr IP) HOJ)(+ (caddr IP) TYK))
        P5  (list (+ (car IP) BRE)(+ (cadr IP) HOJ)(caddr IP))
        P6  (list (+ (car IP) BRE)(+ (cadr IP) HOJ)(+ (caddr IP) TYK))
        P7  (list (+ (car IP) BRE)(cadr IP)(caddr IP))
        P8  (list (+ (car IP) BRE)(cadr IP)(+ (caddr IP) TYK)) )
  (cond ((eq DB 0)
           (setq ML (list P1 P2 P3 P4 P5 P6 P7 P8)))
        ((eq DT 0)
           (setq ML (list P5 P6 P7 P8 P1 P2 P3 P4)))
        (t
           (setq ML (list P1 P2 P3 P4 P5 P6 P7 P8 P1 P2))))
  (setq SS (m-tegn SS ML LAY COL))
  SS)
;==============================================================================
(defun flas (SS IP BRE HOJ DB DT DS1 DS2 LAY COL
            / P1 P2 P3 P4 P5 P6 P7 P8 P9 P10 P11 P12 ML)
  (if paucheck (princ "\nflas"))
  (setq P1  (list (- (car IP) DS1) (- (cadr IP) DB) (caddr IP))
        P2  (list (- (car IP) DS1) (cadr IP) (caddr IP))
        P3  (list (+ (car IP) BRE DS2) (- (cadr IP) DB) (caddr IP))
        P4  (list (+ (car IP) BRE DS2) (cadr IP) (caddr IP))
        P5  (list (+ (car IP) BRE) (cadr IP) (caddr IP))
        P6  (list (+ (car IP) BRE DS2) (+ (cadr IP) HOJ) (caddr IP))
        P7  (list (+ (car IP) BRE) (+ (cadr IP) HOJ) (caddr IP))
        P8  (list (+ (car IP) BRE DS2) (+ (cadr IP) HOJ) (caddr IP))
        P9  (list (+ (car IP) BRE DS2) (+ (cadr IP) HOJ DT) (caddr IP))
        P10 (list (- (car IP) DS1) (+ (cadr IP) HOJ) (caddr IP))
        P11 (list (- (car IP) DS1) (+ (cadr IP) HOJ DT) (caddr IP))
        P12 (list (car IP) (+ (cadr IP) HOJ) (caddr IP)) )
  (cond ((eq DB 0)
           (setq ML (list P4 P5 P8 P7 P7 P8 P8 P9
                          P10 P11 P11 P10 P10 P12 P2 IP)))
        ((eq DT 0)
           (setq ML (list P10 P12 P2 IP P1 P2 P3 P4 P4 P5 P6 P7)))
        (t
           (setq ML (list P1 P2 P3 P4 P4 P5 P6 P7 P7 P8 P8 P9
                          P10 P11 P11 P10 P10 P12 P2 IP))))
  (setq SS (m-tegn SS ML LAY COL) )
  SS)
;==============================================================================
(defun pss-boks (SS IP PB PT TYK LAY COL / P1 P2 P3 P4 P5 P6 P7 P8)
  (if paucheck (princ "\npss-boks"))
  (setq P1 (list (car IP)(+ (cadr IP) (caar PB)    )(+ (caddr IP)(cadar  PB)))
        P2 (list (car IP)(+ (cadr IP) (caar PB)    )(+ (caddr IP)(cadadr PB)))
        P3 (list (car IP)(+ (cadr IP) (caar PT) HOJ)(+ (caddr IP)(cadar  PT)))
        P4 (list (car IP)(+ (cadr IP) (caar PT) HOJ)(+ (caddr IP)(cadadr PT)))
        P5 (list (+ (car P3) TYK) (cadr P3) (caddr P3))
        P6 (list (+ (car P4) TYK) (cadr P4) (caddr P4))
        P7 (list (+ (car P1) TYK) (cadr P1) (caddr P1))
        P8 (list (+ (car P2) TYK) (cadr P2) (caddr P2))
        SS (b-tegn SS P1 P2 P3 P4 P5 P6 P7 P8 LAY COL) )
  SS)
;==============================================================================
(defun ptb-tegn (SS IP PLL LL LAY COL / PL ML PP P0 P1 P2 P3 PS PSS)
  (if paucheck (princ "\nptb-tegn"))
  (foreach PL (cadr PLL)
    (setq P0 (car PL)
          ML '())
    (mapcar '(lambda (PP)
      (setq P1 (list (car IP)(+(cadr IP)(car PP))(+(caddr IP)(cadr PP)))
            P2 (list (+(car IP) LL)(+(cadr IP)(car PP))(+(caddr IP)(cadr PP)))
            ML (append ML (list (trans P1 1 0)(trans P2 1 0))))
    )(cadr PL))
    (setq SS (m-tegn SS ML LAY COL) )
    (if (setq PSS (cdr (cdaadr PLL)))
      (foreach PS PSS
        (setq SS (f-tegn nil t SS IP PS LAY COL)
              P3 (list (+ (car IP) LL)(cadr IP)(caddr IP))
              SS (f-tegn nil t SS P3 PS LAY COL)))))
  SS)
;============================================================================
(defun psx-tegn (SS IP PLL BRE HOJ STR LAY COL
                / STB1 RES RAD DY SPA STA PL PP P0 P1 ENAM1 ENAM2)
  (if paucheck (princ "\npsx-tegn"))
  (setq STB1 (getvar "surftab1")
        RES (get-gir STR)
        RAD (nth 0 RES)
        DY  (nth 1 RES)
        SPA (nth 2 RES)
        STA (nth 3 RES) )
  (setvar "surftab1" 22)
  (command "_line" (list (- (car IP)(/ BRE 2.0))
                   (+ (cadr IP) (- HOJ RAD)) (caddr IP))
                   (list (- (car IP)(/ BRE 2.0))
                   (+ (cadr IP) (- HOJ RAD)) (+ 100 (caddr IP))) "")
  (setq ENAM1 (entlast))
  
  (if (eq STR "...");gvo
    (setq RAD 35.0))
  (foreach PL (cadr PLL)
    (setq P0 (car PL))
    (command "_3dpoly")
    (mapcar '(lambda (PP)
               (command (list (- (car IP)(car PP))
			      (+ (cadr IP) (- HOJ RAD))
                              (+ (caddr IP)(cadr PP))))
             )(cadr PL))
    (command "_c")
    (setq ENAM2 (entlast))
    (if (eq STR "...");gvo
      (command "_rotate" ENAM2 ""
                         (list (car IP)
			       (+ (cadr IP) (- HOJ RAD))
                               (caddr IP))  STA)
      (command "_rotate" ENAM2 ""
                         (list (- (car IP)(/ BRE 2.0))
			       (+ (cadr IP) (- HOJ RAD))
                               (caddr IP))  STA))
    (command "_revsurf" ENAM2 ENAM1 0 SPA)
    (entdel ENAM1)
    (entdel ENAM2)
    (skift (ssadd (entlast)) LAY COL)
    (setq SS (ssadd (entlast) SS)
          SS (psr-tegn SS IP PLL (+ 2 DY) LAY COL)
          P1 (list (- (car IP) BRE) (cadr IP) (caddr IP))
          SS (psl-tegn SS P1 PLL (+ 2 DY) LAY COL)) )
  (setvar "surftab1" STB1)
  SS)
;============================================================================
(defun psl-tegn (SS IP PLL LL LAY COL / PL ML PP P0 P1 P2 P3 PS PSS)
  (if paucheck (princ "\npsl-tegn"))
  (foreach PL (cadr PLL)
    (setq P0 (car PL)
          ML '())
    (mapcar '(lambda (PP)
      (setq P1 (list (+(car IP)(car PP))(cadr IP)(+(caddr IP)(cadr PP)))
            P2 (list (+(car IP)(car PP))(+(cadr IP) LL)(+(caddr IP)(cadr PP)))
            ML (append ML (list (trans P1 1 0)(trans P2 1 0))))
    )(cadr PL))
    (setq SS (m-tegn SS ML LAY COL))
    (if (setq PSS (cdr (cdaadr PLL)))
      (foreach PS PSS
        (setq SS (f-tegn nil nil SS IP PS LAY COL)
              P3 (list (car IP)(+ (cadr IP) LL)(caddr IP))
              SS (f-tegn nil nil SS P3 PS LAY COL)))))
  SS)
;============================================================================
(defun psr-tegn (SS IP PLL LL LAY COL / PL ML PP P0 P1 P2 P3 PS PSS)
  (if paucheck (princ "\npsr-tegn"))
  (foreach PL (cadr PLL)
    (setq P0 (car PL)
          ML '())
    (mapcar '(lambda (PP)
      (setq P1 (list (-(car IP)(car PP))(cadr IP)(+(caddr IP)(cadr PP)))
            P2 (list (-(car IP)(car PP))(+(cadr IP) LL)(+(caddr IP)(cadr PP)))
            ML (append ML (list (trans P1 1 0)(trans P2 1 0))))
    )(cadr PL))
    (setq SS (m-tegn SS ML LAY COL) )
    (if (setq PSS (cdr (cdaadr PLL)))
      (foreach PS PSS
        (setq SS (f-tegn t nil SS IP PS LAY COL)
              P3 (list (car IP)(+ (cadr IP) LL)(caddr IP))
              SS (f-tegn t nil SS P3 PS LAY COL)))))
  SS)
;============================================================================
(defun red-lix (SS IP BRE HOJ STR LAY COL / RES RAD DY SPA STA)
  (if paucheck (princ "\nred-lix"))
  (setq RES (get-gir STR)
        RAD (nth 0 RES)
        DY  (nth 1 RES)
        SPA (nth 2 RES)
        STA (nth 3 RES) )
  (if paucheck (princ res))
  (command "_.pline"
    (list (+ (car IP) BRE)(cadr IP)(caddr IP))
    (list (+ (car IP) BRE)(+ (cadr IP) DY)(caddr IP))
    "_a" "_ce"
    (list (+ (car IP)(/ BRE 2.0))
          (+ (cadr IP) (- HOJ RAD)) )
    (list (car IP)(+ (cadr IP) DY)(caddr IP))
    "_l"
    (list (car IP)(cadr IP)(caddr IP))
    "_close")
  (skift (ssadd (entlast)) LAY COL)
  (setq SS (ssadd (entlast) SS)) )
;============================================================================
(defun red-lin (SS IP BRE HOJ LAY COL BT)
  (if paucheck (princ "\nred-lin"))
  (cond ((eq BT "top")
          (command "_.pline"
            (list (car IP)(+ (cadr IP) HOJ)(caddr IP))
            (list (car IP)(cadr IP)(caddr IP))
            (list (+ (car IP) BRE)(cadr IP)(caddr IP))
            (list (+ (car IP) BRE)(+ (cadr IP) HOJ)(caddr IP))
            "") )
        ((eq BT "bot")
          (command "_.pline"
            (list (car IP)(cadr IP)(caddr IP))
            (list (car IP)(+ (cadr IP) HOJ)(caddr IP))
            (list (+ (car IP) BRE)(+ (cadr IP) HOJ)(caddr IP))
            (list (+ (car IP) BRE)(cadr IP)(caddr IP))
            "") )
        (t
          (command "_.pline"
            (list (car IP)(cadr IP)(caddr IP))
            (list (+ (car IP) BRE)(cadr IP)(caddr IP))
            (list (+ (car IP) BRE)(+ (cadr IP) HOJ)(caddr IP))
            (list (car IP)(+ (cadr IP) HOJ)(caddr IP))
            "_close") ))
  (skift (ssadd (entlast)) LAY COL)
  (setq SS (ssadd (entlast) SS)) )
;============================================================================
(defun b-tegn (SS P1 P2 P3 P4 P5 P6 P7 P8 LAY COL)
  (if paucheck (princ "\nb-tegn"))
  (command "_.3DMESH" "6" "3"
     P5 P3 P3 P7 P1 P1 P8 P2 P1 P6 P4 P3 P6 P6 P5 P8 P8 P7)
  (skift (ssadd (entlast)) LAY COL)
  (setq SS (ssadd (entlast) SS))
  SS)
;============================================================================
(defun m-tegn (SS PL LAY COL / PP)
  (if paucheck (princ "\nm-tegn"))
  (command "_.3Dmesh" (/ (length PL) 2) 2)
  (mapcar '(lambda (PP)
    (command (trans PP 0 1)) ) PL)
  (skift (ssadd (entlast)) LAY COL)
  (setq SS (ssadd (entlast) SS))
  SS)
;============================================================================
(defun f-tegn (MIR ROT SS IP PL LAY COL / L P)
  (if paucheck (princ "\nf-tegn"))
  (foreach L PL
    (command "_.3dFACE")
    (mapcar '(lambda (P)
      (command "_i"
      (cond ((and ROT (not MIR))
              (list (car IP)(+(cadr IP)(car P))(+(caddr IP)(cadr P)) ))
            ((and (not ROT)(not MIR))
              (list (+(car IP)(car P))(cadr IP)(+(caddr IP)(cadr P)) ))
            ((and ROT MIR)
              (list (car IP)(-(cadr IP)(car P))(+(caddr IP)(cadr P)) ))
            ((and (not ROT) MIR)
              (list (-(car IP)(car P))(cadr IP)(+(caddr IP)(cadr P)) )) ) )) L)
    (command "")
    (skift (ssadd (entlast)) LAY COL)
    (setq SS (ssadd (entlast) SS)) )
  SS)
;============================================================================
(defun gir-glass (SS IP DDY BRE HOJ STR GT LAY COL
                 / STB1 RES RAD DY SPA STA ENAM1 ENAM2)
  (if paucheck (princ "\ngir-glass"))
  (setq STB1 (getvar "surftab1")
        RES (get-gir STR)
        RAD (nth 0 RES)
        DY  (nth 1 RES)
        SPA (nth 2 RES)
        STA (nth 3 RES) )
  (setvar "surftab1" 22)
  (command "_.pline"
    (list (+ (car IP) BRE)(cadr IP)(caddr IP))
    (list (+ (car IP) BRE)(- (+ (cadr IP) DY) DDY)(caddr IP))
    "_a" "_ce"
    (list (+ (car IP)(/ BRE 2.0))
          (+ (- (cadr IP) DDY) (- HOJ RAD)) )
    (list (car IP)(- (+ (cadr IP) DY) DDY)(caddr IP))
    "_l"
    (list (car IP)(cadr IP)(caddr IP))
    "")
  (setq ENAM1 (entlast))
  (command "_.pline"
    (list (car IP)(cadr IP)(caddr IP))
    (list (+ (car IP) BRE)(cadr IP)(caddr IP))
    "")
  (setq ENAM2 (entlast))
  (command "_.rulesurf" ENAM1 ENAM2)
  (skift (ssadd (entlast)) LAY COL)
  (setq SS (ssadd (entlast) SS))
  (command "_.copy" (entlast) ""
    IP (list (car IP) (cadr IP) (+ (caddr IP) GT)))
  (setq SS (ssadd (entlast) SS))
 ; (command "_.pedit" ENAM1 "_j" ENAM2 "" "")
 ; (setq ENAM1 (entlast))
 ; (command "_.line"
 ;   IP (list (car IP) (cadr IP) (+ (caddr IP) USER-GT)) "")
 ; (setq ENAM2 (entlast))
 ; (setvar "surftab1" 22)
 ; (command "_.tabsurf" ENAM1 ENAM2)
 ; (setvar "surftab1" STB1)
 ; (skift (ssadd (entlast)) LAY COL)
 ; (setq SS (ssadd (entlast) SS))
  (entdel ENAM1)
  (entdel ENAM2)
  (setvar "surftab1" STB1)
  SS)
;============================================================================
;*************************************************************************
;    tegning af vinduet
;*************************************************************************
;==============================================================================
(defun i-3d-0 ( SS-D INS-P TYP STR BRE HOJ PCO KOMBI DCH INN BT RP
              / DC 3D-LIS SOLID
                DS-BTS DS-TBX DS-WLL DS-BOT DS-TOP DS-SID
                DS-DZ DS-DZ- DS-A1 DS-B2 DS-LAY DS-COL
                IP RES RAD DY SPA STA DS-C1 DS-B1 DS-C2 DS-A2)

  (if paucheck (princ "\ni-3d-0"))

;*** dummy solid ***
  (setq DC     (dtr DCH)
        3D-LIS (get-3d-l TYP STR))
  (if (and (eq USER-T9 "on")
           3D-LIS (setq SOLID (assoc "solid" (cdr 3D-LIS))))
    (progn
      (setq DS-BTS (cadr (assoc "dxy-bts" (cdr SOLID)))
            DS-TBX (cadr (assoc "dz-tbx" (cdr SOLID)))
            DS-WLL (cadr (assoc "dwall" (cdr SOLID)))
            DS-BOT (car DS-BTS)
            DS-TOP (cadr DS-BTS)
            DS-SID (caddr DS-BTS)
            DS-DZ  (car DS-TBX)
            DS-DZ- (cond ((eq INN "LGI")
                            (caddr DS-TBX))
                         ((member INN '("LSC" "LSB" "LSD" "LLC" "LLB" "LLD" "LVI"))
                            (cadddr DS-TBX))
                         (t (cadr DS-TBX)))
            DS-A1  (car DS-WLL)
            DS-B2  (cadr DS-WLL)
            DS-LAY (get-lay "dum-solid")
            DS-COL (get-col "dum-solid" PCO TYP))

      (command "_.layer" "_th" DS-LAY "")
      (cond
        ((member TYP '("GIR" "GVO" "_GVO"))
          (setq IP (trans INS-P 0 1)
                RES (get-gir STR)
                RAD (nth 0 RES)
                DY  (nth 1 RES)
                SPA (nth 2 RES)
                STA (nth 3 RES) )
          (command "_.pline"
            (list (- (+ (car IP) BRE) DS-SID)
                  (cadr IP)
                  (- (caddr IP) DS-DZ- DS-A1) )
            (list (- (+ (car IP) BRE) DS-SID)
                  (+ (cadr IP) DY) )
            "_a" "_ce"
            (list (+ (car IP)(/ BRE 2.0))
                  (+ (cadr IP)(- HOJ RAD)) )
            (list (+ (car IP) DS-SID)(+ (cadr IP) DY) )
            "_l"
            (list (+ (car IP) DS-SID)(cadr IP))
            "_close")
          (command "_.extrude" (entlast) ""
                       (+ DS-DZ DS-DZ- DS-A1) 0
                   "_.ucs" "_w"
                   "_.ucs" "_x" (/ pi 2.0)
                   "_.ucs" "_y" (/ pi 2.0))
          (setq IP (trans INS-P 0 1)
                RP (trans RP 0 1)) )
        (t
          (setq DS-C1 (/ DS-A1 (sin DC))
                DS-B1 (* (cos DC) DS-C1)
                DS-C2 (/ DS-B2 (cos DC))
                DS-A2 (* (sin DC) DS-C2) )
          (command
            "_.ucs" "_w"
            "_.ucs" "_x" (/ pi 2.0)
            "_.ucs" "_y" (/ pi 2.0))
          (setq IP (trans INS-P 0 1)
                RP (trans RP 0 1))
          (cond ((eq BT "top")
                  (setq DS-TOP 0)
                  (command
                    "_.pline"
                    (list (- (+ (car IP) DS-BOT) DS-A2)(- (cadr IP) DS-DZ- DS-B2)
                          (+ (caddr IP) DS-SID) )
                    (list (+ (car IP) DS-BOT)(- (cadr IP) DS-DZ-))
                    (list (+ (car IP) DS-BOT)(+ (cadr IP) DS-DZ))
                    (list (- (+ (car IP) HOJ) DS-TOP)(+ (cadr IP) DS-DZ))
                    (list (- (+ (car IP) HOJ) DS-TOP)(- (cadr IP) DS-DZ-))
                    (list (- (+ (car IP) HOJ) DS-TOP)(- (cadr IP) DS-DZ- DS-A1))
                    "_close") )
                ((eq BT "bot")
                  (setq DS-BOT 0)
                  (command
                    "_.pline"
                    (list (+ (car IP) DS-BOT)(- (cadr IP) DS-DZ- DS-B2)
                          (+ (caddr IP) DS-SID) )
                    (list (+ (car IP) DS-BOT)(- (cadr IP) DS-DZ-))
                    (list (+ (car IP) DS-BOT)(+ (cadr IP) DS-DZ))
                    (list (- (+ (car IP) HOJ) DS-TOP)(+ (cadr IP) DS-DZ))
                    (list (- (+ (car IP) HOJ) DS-TOP)(- (cadr IP) DS-DZ-))
                    (list (- (+ (car IP) HOJ DS-B1) DS-TOP)(- (cadr IP) DS-DZ- DS-A1))
                    "_close") )
                ((eq BT "topbot")
                  (command
                    "_.pline"
                    (list (+ (car IP) DS-BOT)(- (cadr IP) DS-DZ- DS-B2)
                          (+ (caddr IP) DS-SID) )
                    (list (+ (car IP) DS-BOT)(- (cadr IP) DS-DZ-))
                    (list (+ (car IP) DS-BOT)(+ (cadr IP) DS-DZ))
                    (list (- (+ (car IP) HOJ) DS-TOP)(+ (cadr IP) DS-DZ))
                    (list (- (+ (car IP) HOJ) DS-TOP)(- (cadr IP) DS-DZ-))
                    (list (- (+ (car IP) HOJ) DS-TOP)(- (cadr IP) DS-DZ- DS-A1))
                    "_close") )
                (t
                  (command
                    "_.pline"
                    (list (- (+ (car IP) DS-BOT) DS-A2)(- (cadr IP) DS-DZ- DS-B2)
                          (+ (caddr IP) DS-SID) )
                    (list (+ (car IP) DS-BOT)(- (cadr IP) DS-DZ-))
                    (list (+ (car IP) DS-BOT)(+ (cadr IP) DS-DZ))
                    (list (- (+ (car IP) HOJ) DS-TOP)(+ (cadr IP) DS-DZ))
                    (list (- (+ (car IP) HOJ) DS-TOP)(- (cadr IP) DS-DZ-))
                    (list (- (+ (car IP) HOJ DS-B1) DS-TOP)(- (cadr IP) DS-DZ- DS-A1))
                    "_close") ))
          (command "_.extrude" (entlast) "" (- BRE DS-SID DS-SID) 0) ))
      
      (if USER-ROT
        (if (member TYP '("VEA" "VEB" "VEC" "VFA" "VFB" "VFE" "VIU"))
          (command "_.rotate" (entlast) "" RP (/ pi 2.0))
          (command "_.rotate" (entlast) "" RP DC)))
      (skift (ssadd (entlast)) DS-LAY DS-COL)
      (setq SS-D (ssadd (entlast) SS-D))
      (if (setq SOLID (assoc "solid-o" (cdr 3D-LIS)))
        (progn
          (setq DS-WLL (cadr (assoc "dwall" (cdr SOLID)))
                DS-A1  (car DS-WLL)
                DS-B2  (cadr DS-WLL))
          (command
             "_.pline"
             (list (car IP)(+ (cadr IP) DS-B2)(caddr IP))
             (list (car IP)(cadr IP))
             (list (car IP)(cadr IP))
             (list (+ (car IP) HOJ)(cadr IP))
             (list (+ (car IP) HOJ)(cadr IP))
             (list (+ (car IP) HOJ)(+ (cadr IP) DS-A1))
             "_close"
	 "_.extrude" (entlast) "" BRE 0)
          (if USER-ROT
            (command "_.rotate" (entlast) "" RP (/ pi 2.0)))
          (skift (ssadd (entlast)) DS-LAY DS-COL)
          (setq SS-D (ssadd (entlast) SS-D)) ))
      (if (not DUMMY-ON) (command "_.layer" "_fr" DS-LAY ""))
      (command "_.ucs" "_W")) )
  SS-D)

;==============================================================================
(defun i-3d-1 ( SS-F SS-S SS-V INS-P TYP STR BRE HOJ PCO KOMBI
              / 3D-LIS RL-LAY RL-COL
                FRAME FR-BOT FR-TOP FR-SID FR-LAY FR-COL
                HH BB IP
                FMETAL FM-BOT FM-TOP FM-SID FM-LAY FM-COL FM-SIT
                TC DP DX SZ TT
                SASH SR-BOT SR-TOP SR-SID SR-LAY SR-COL
                DT SR-TTP SR-SIT BT
                SMETAL SM-BOT SM-TOP SM-SID SM-SCO SM-LAY SM-COL
                SM-TTP SM-SIT SM-BBT
                RMETAL RM-SID RM-SIS RM-SSS RM-LAY RM-COL HZ N LL RP
                GRIP GR-GRB GR-LAY GR-COL
                GLASS GL-LAY GL-COL PG DG GT
                VENT VT-TOP VT-GRP VT-BOX VT-BTX VT-BXT VT-BXX
                VT-LAY-TOP VT-COL-TOP VT-LAY-GRP VT-COL-GRP
                VT-LAY-BOX VT-COL-BOX BBT BBG
                GR-BX1 GR-BT1 GR-BX2 GR-BT2 GR-BX3 GR-BT3
                GR-BXT GR-BXX GR-LAY-GRP GR-COL-GRP
	        SS3
              )
  (if paucheck (princ "\ni-3d-1"))
  (if (setq 3D-LIS (get-3d-l TYP STR) )
    (progn
;******* red-line ***
      (setq RL-LAY (get-lay "red-line")
            RL-COL (get-col "red-line" PCO TYP)
            SS-F   (cond ((member TYP '("GIR" "GVO" "_GVO"))
                            (red-lix SS-F INS-P BRE HOJ STR RL-LAY RL-COL))
                         ((member TYP '("GEL" "GDL-t"))
                            (red-lin SS-F INS-P BRE HOJ RL-LAY RL-COL "bot"))
                         ((member TYP '("VEA" "VEB" "VEC" "GDL-b"))
                            (red-lin SS-F INS-P BRE HOJ RL-LAY RL-COL "top"))
                         (t
                            (red-lin SS-F INS-P BRE HOJ RL-LAY RL-COL nil))) )
;******* frame ***
      (setq FRAME  (assoc "frame" (cdr 3D-LIS))
            FR-BOT (cdr (assoc "bottom" (cdr FRAME)))
            FR-TOP (cdr (assoc "top"    (cdr FRAME)))
            FR-SID (cdr (assoc "side"   (cdr FRAME)))
            FR-LAY (get-lay "frame")
            FR-COL (get-col "frame" PCO TYP)
            HH     (cond ((member TYP '("VFE" "VFA" "VFB"))
                           (- HOJ 25 45))
                         ((member TYP '("VIU"))
                           (- HOJ 100))
                         ((member TYP '("VEC" "VEA" "VEB"))
                           (- HOJ 14))
                         (t
                           HOJ))
            BB     (- BRE (* 2 (car FR-SID)))
            IP     (list (+ (car INS-P)(car FR-SID))
                         (cadr INS-P)
                         (caddr INS-P))
            SS-F   (ptb-tegn SS-F IP FR-BOT BB FR-LAY FR-COL)
            IP     (list (+ (car INS-P)(car FR-SID))
                         (+ (cadr INS-P) HOJ)
                         (caddr INS-P))
            SS-F   (ptb-tegn SS-F IP FR-TOP BB FR-LAY FR-COL)
            IP     (cond ((member TYP '("VFE" "VFA" "VFB"))
                           (list (car INS-P)
                                 (+ 25 (cadr INS-P))
                                 (caddr INS-P)))
                         ((member TYP '("VIU"))
                           (list (car INS-P)
                                 (+ 50 (cadr INS-P))
                                 (caddr INS-P)))
                         ((member TYP '("VEC" "VEA" "VEB"))
                           (list (car INS-P)
                                 (+ 14 (cadr INS-P))
                                 (caddr INS-P)))
                         (t
                           (list (car INS-P)
                                 (cadr INS-P)
                                 (caddr INS-P))) )
            SS-F   (if (not (member TYP '("GIR" "GVO" "_GVO")))
                     (psl-tegn SS-F IP FR-SID HH FR-LAY FR-COL)
                     SS-F)
            IP     (cond ((member TYP '("VFE" "VFA" "VFB"))
                           (list (+ (car INS-P) BRE)
                                 (+ 25 (cadr INS-P))
                                 (caddr INS-P)))
                         ((member TYP '("VIU"))
                           (list (+ (car INS-P) BRE)
                                 (+ 50 (cadr INS-P))
                                 (caddr INS-P)))
                         ((member TYP '("VEC" "VEA" "VEB"))
                           (list (+ (car INS-P) BRE)
                                 (+ 14 (cadr INS-P))
                                 (caddr INS-P)))
                         (t
                           (list (+ (car INS-P) BRE)
                                 (cadr INS-P)
                                 (caddr INS-P))) )
            SS-F   (if (not (member TYP '("GIR" "GVO" "_GVO")))
                     (psr-tegn SS-F IP FR-SID HH FR-LAY FR-COL)
                     (psx-tegn SS-F IP FR-SID BRE HOJ STR FR-LAY FR-COL))
      )
;******* frame-metal ***
      (if (setq FMETAL (assoc "frame-metal" (cdr 3D-LIS)))
        (progn
          (setq FM-BBT (cdr (assoc "botbot" (cdr FMETAL)))
                FM-BOT (cdr (assoc "bottom" (cdr FMETAL)))
                FM-TOP (cdr (assoc "top"    (cdr FMETAL)))
                FM-SID (cdr (assoc "side"   (cdr FMETAL)))
                FM-LAY (get-lay "frame-metal")
                FM-COL (get-col "frame-metal" PCO TYP)
                BB     (- BRE (* 2 (car FM-SID)))
                HH     (cond ((member TYP '("VFE" "VFA" "VFB"))
                               (- HOJ 25 45))
                             ((member TYP '("VIU"))
                               (- HOJ 100))
                             ((member TYP '("VEC" "VEA" "VEB"))
                               (+ HOJ 20))
                             (t
                               HOJ))
                IP     (list (+ (car INS-P)(car FM-SID))
                             (cadr INS-P)
                             (caddr INS-P))
                SS-F   (ptb-tegn SS-F IP FM-BOT BB FM-LAY FM-COL)
                ;SS-F   (ptb-tegn SS-F INS-P FM-BOT BRE FM-LAY FM-COL);test
                SS-F   (if (or (eq KOMBI 6)(eq KOMBI 8))
                         (ptb-tegn SS-F IP FM-BBT BB FM-LAY FM-COL)
                         SS-F)
                IP     (list (+ (car INS-P)(car FM-SID))
                             (+ (cadr INS-P) HOJ)
                             (caddr INS-P))
                SS-F   (ptb-tegn SS-F IP FM-TOP BB FM-LAY FM-COL)
                IP     (list (car INS-P)
                             (cadr INS-P)
                             (caddr INS-P))
                SS-F   (if (not (member TYP '("GIR" "GVO" "_GVO")))
                         (psl-tegn SS-F IP FM-SID HH FM-LAY FM-COL)
                         SS-F)
                IP     (list (+ (car INS-P) BRE)
                             (cadr INS-P)
                             (caddr INS-P))
                SS-F   (if (not (member TYP '("GIR" "GVO" "_GVO")))
                         (psr-tegn SS-F IP FM-SID HH FM-LAY FM-COL)
                         (psx-tegn SS-F IP FM-SID BRE HOJ STR FM-LAY FM-COL)) ) ))
;******* frame-metal ***
      (if (setq FM-SIT (cdr (assoc "sside"  (cdr FMETAL))))
        (progn
          (setq HH (/ (- HOJ (car FR-TOP)) 2.0)
                IP (list (car INS-P)(+ (cadr INS-P)(/ HOJ 2.0))(caddr INS-P)))
          (if (member TYP '("GHL" "dGHL" "GPU" "dGPU" "GPL" "dGPL" "GTL" "GTU" "GEL" "GDL-t"
			    "_GHL" "GXL"))
            (setq SS-S (psl-tegn SS-S IP FM-SIT HH FM-LAY FM-COL))
            (setq SS-F (psl-tegn SS-F IP FM-SIT HH FM-LAY FM-COL)) )
          (setq IP (list (+ (car INS-P) BRE)(+ (cadr INS-P)(/ HOJ 2.0))(caddr INS-P)))
          (if (member TYP '("GHL" "dGHL" "GPU" "dGPU" "GPL" "dGPL" "GTL" "GTU" "GEL" "GDL-t"
			    "_GHL" "GXL"))
            (setq SS-S (psr-tegn SS-S IP FM-SIT HH FM-LAY FM-COL))
            (setq SS-F (psr-tegn SS-F IP FM-SIT HH FM-LAY FM-COL)) ) ))
;******* top-case ***
      (if (setq TC (cadr (assoc "topcase-" (cdr 3D-LIS))))
        (progn
          (setq DP (car TC)
                DX (car (cadr TC))
                SZ (cadr (cadr TC))
                TT (caddr TC)
                IP (list (+ (car INS-P) (car DP))
                         (+ (cadr INS-P) HOJ (cadr DP))
                         (+ (caddr INS-P) (caddr DP))) )
          (if (member TYP '("GHL" "dGHL" "GPU" "dGPU" "GPL" "dGPL" "GTL" "GTU" "GEL" "GDL-t"
			    "_GHL" "GXL"))
            (setq SS-S (boks SS-S IP (- BB DX) SZ TT FM-LAY FM-COL))
            (setq SS-F (boks SS-F IP (- BB DX) SZ TT FM-LAY FM-COL)) ) ))
          
      (if (setq TC (assoc "topcase" (cdr 3D-LIS)))
        (progn
          (setq TC-TOP (cdr TC)
            BB     (- BRE (* 2 (car TC-TOP)))
            IP     (list (+ (car INS-P)(car TC-TOP))
                         (+ (cadr INS-P) HOJ)
                         (caddr INS-P))
                )
          (if (member TYP '("GHL" "dGHL" "GPU" "dGPU" "GPL" "dGPL" "GTL" "GTU" "GEL" "GDL-t"
			    "_GHL" "GXL"))
            (setq SS-S (ptb-tegn SS-S IP TC-TOP BB FM-LAY FM-COL))
            (setq SS-F- (ptb-tegn SS-F IP TC-TOP BB FM-LAY FM-COL)) ) ))
;******* sash ***
      (setq SASH   (assoc "sash" (cdr 3D-LIS))
            SR-BOT (cdr (assoc "bottom" (cdr SASH)))
            SR-TOP (cdr (assoc "top"    (cdr SASH)))
            SR-SID (cdr (assoc "side"   (cdr SASH)))
            SR-LAY (get-lay "sash")
            SR-COL (get-col "sash" PCO TYP)
            BB     (- BRE (* 2 (car SR-SID)))
            HH     (- HOJ (car FR-BOT) (car SR-TOP))
            DT     (- (car SR-TOP) (car FR-TOP))
            IP     (list (+ (car INS-P)(car SR-SID))
                         (cadr INS-P)
                         (caddr INS-P))
            SS-S   (ptb-tegn SS-S IP SR-BOT BB SR-LAY SR-COL)
            IP     (list (+ (car INS-P)(car SR-SID))
                         (+ (cadr INS-P) HOJ)
                         (caddr INS-P))
            SS-S   (ptb-tegn SS-S IP SR-TOP BB SR-LAY SR-COL)
            IP     (list (car INS-P)
                         (+ (cadr INS-P)(car FR-BOT))
                         (caddr INS-P))
            SS-S   (psl-tegn SS-S IP SR-SID HH SR-LAY SR-COL)
            IP     (list (+ (car INS-P) BRE)
                         (+ (cadr INS-P)(car FR-BOT))
                         (caddr INS-P))
            SS-S   (psr-tegn SS-S IP SR-SID HH SR-LAY SR-COL) )
;******* sash ***
      (if (setq SR-TTP (cdr (assoc "toptop" (cdr SASH))))
        (setq SR-SIT (cdr (assoc "sidtop" (cdr SASH)))
              BT     (- BRE (* 2 (car SR-SIT)))
              IP     (list (+ (car INS-P)(car SR-SIT))
                           (+ (cadr INS-P) HOJ)
                           (caddr INS-P))
              SS-S   (ptb-tegn SS-S IP SR-TTP BT SR-LAY SR-COL)
              IP     (list (car INS-P)
                           (+ (cadr INS-P)(- HOJ (car SR-TOP)))
                           (caddr INS-P))
              SS-S   (psl-tegn SS-S IP SR-SIT DT SR-LAY SR-COL)
              IP     (list (+ (car INS-P) BRE)
                           (+ (cadr INS-P)(- HOJ (car SR-TOP)))
                           (caddr INS-P))
              SS-S   (psr-tegn SS-S IP SR-SIT DT SR-LAY SR-COL) ))
;******* sash-metal ***
      (if (setq SMETAL (assoc "sash-metal"  (cdr 3D-LIS)))
        (progn
          (setq SM-BOT (cdr (assoc "bottom" (cdr SMETAL)))
                SM-TOP (cdr (assoc "top"    (cdr SMETAL)))
                SM-SID (cdr (assoc "side"   (cdr SMETAL)))
                SM-LAY (get-lay "sash-metal")
                SM-COL (get-col "sash-metal" PCO TYP)
                SM-SCO (get-col "silver" PCO TYP)
                BB     (- BRE (* 2 (car FR-SID)))
                BT     (- BRE (* 2 (car SM-SID)))
                HH     (- HOJ (car SR-TOP)(car SM-BOT)(car SM-TOP))
                IP     (list (+ (car INS-P)(car FR-SID))
                             (cadr INS-P)
                             (caddr INS-P))
                SS-S   (ptb-tegn SS-S IP SM-BOT BB SM-LAY SM-COL)
                ;SS-S   (ptb-tegn SS-S INS-P SM-BOT BRE SM-LAY SM-COL);test
                IP     (list (+ (car INS-P)(car FR-SID))
                             (+ (cadr INS-P) HOJ)
                             (caddr INS-P))
                SS-S   (ptb-tegn SS-S IP SM-TOP BB SM-LAY SM-SCO)
                IP     (list (car INS-P)
                             (+ (cadr INS-P) (car SM-BOT))
                             (caddr INS-P))
                SS-S   (if (not (member TYP '("GIR" "GVO" "_GVO")))
                         (psl-tegn SS-S IP SM-SID HH SM-LAY SM-SCO)
                         SS-S)
                IP     (list (+ (car INS-P) BRE)
                             (+ (cadr INS-P) (car SM-BOT))
                             (caddr INS-P))
                SS-S   (if (not (member TYP '("GIR" "GVO" "_GVO")))
                         (psr-tegn SS-S IP SM-SID HH SM-LAY SM-SCO)
                         (psx-tegn SS-S IP SM-SID BRE HOJ STR SM-LAY SM-SCO)) ) ))
;******* sash-metal ***
      (if (setq SM-TTP (cdr (assoc "toptop" (cdr SMETAL))))
        (setq IP     (list (+ (car INS-P)(car SM-SID))
                           (+ (cadr INS-P) HOJ)
                           (caddr INS-P))
              SS-S   (ptb-tegn SS-S IP SM-TTP BT SM-LAY SM-COL) ))
;******* sash-metal ***
      (if (setq SM-SIT (cdr (assoc "sside"  (cdr SMETAL))))
        (setq HH     (if (member TYP '("GIL" "GIU" "VIU" "GDL-b"
                                       "VEC" "VEA" "VEB"))
                       (- HOJ (car SR-TOP)(car SM-BOT))
                       (/ (- HOJ (car SM-BOT)) 2.0))
              IP     (list (car INS-P)
                           (+ (cadr INS-P) (car SM-BOT))
                           (caddr INS-P))
              SS-S   (psl-tegn SS-S IP SM-SIT HH SM-LAY SM-COL)
              IP     (list (+ (car INS-P) BRE)
                           (+ (cadr INS-P) (car SM-BOT))
                           (caddr INS-P))
              SS-S   (psr-tegn SS-S IP SM-SIT HH SM-LAY SM-COL)
        ))
;******* sash-metal ***
      (if (setq SM-BBT (cdr (assoc "botbot" (cdr SMETAL))))
        (setq BB     (- BRE (car SM-SIT) (car SM-SIT))
              IP     (list (+ (car INS-P) (car SM-SIT))
                           (+ (cadr INS-P))
                           (caddr INS-P))
              SS-S   (ptb-tegn SS-S IP SM-BBT BB SM-LAY SM-COL) ))
;******* railing-metal ***
      (if (eq TYP "GDL-b")
        (progn
          (setq RMETAL (assoc "railing"  (cdr 3D-LIS))
                RM-SID (cdr (assoc "side"   (cdr RMETAL)))
                RM-SIS (cdr (assoc "sside"  (cdr RMETAL)))
                RM-SSS (cdr (assoc "ssside"  (cdr RMETAL)))
                RM-LAY (get-lay "rail-metal")
                RM-COL (get-col "rail-metal" PCO TYP)
                HH     (/ (* (- (cadddr (assoc STR USER-SIZ-LIS)) 100)
                             (cos (dtr DCH)))
                          (sin (dtr DCH)))
                IP     (list (car INS-P)
                             (+ (cadr INS-P)(- HOJ 60 (car SR-TOP)))
                             (caddr INS-P))
                SS-S   (psl-tegn SS-S IP RM-SID HH RM-LAY RM-COL)
                RP     (list (car IP)(cadr IP)(+ 125 (caddr INS-P))) )
          (if USER-ROT-SASH (rot-3d-do (entlast) RP -90 t))
          (setq IP     (list (+ (car IP) BRE)(cadr IP)(caddr IP))
                SS-S   (psr-tegn SS-S IP RM-SID HH RM-LAY RM-COL) )
          (if USER-ROT-SASH (rot-3d-do (entlast) RP -90 t))
          (if USER-ROT-SASH
            (progn
              (setq IP   (list (car IP)(cadr IP)(+ (caddr IP) 60))
                    HZ   (/ (- HH 60) 8.0)
                    N    1)
              (repeat 7
                (setq LL   (/ (* -1 (- HH 60 (* N HZ))
                                 (cos (dtr (- 90 DCH))))
                              (sin (dtr (- 90 DCH))))
                      N    (1+ N)
                      IP   (list (car IP)(cadr IP)(- (caddr IP) HZ))
                      SS-S (psr-tegn SS-S IP RM-SSS LL RM-LAY RM-COL)
                      RP   (list (- (car IP) BRE)(cadr IP)(caddr IP))
                      SS-S (psl-tegn SS-S RP RM-SSS LL RM-LAY RM-COL))) )
            (setq HH     -600
                  SS-S   (psr-tegn SS-S IP RM-SIS HH RM-LAY RM-COL)
                  IP     (list (car INS-P)
                               (+ (cadr INS-P)(- HOJ 60 (car SR-TOP)))
                               (caddr INS-P))
                  SS-S   (psl-tegn SS-S IP RM-SIS HH RM-LAY RM-COL) ))
          ;*** protections glass ***
          (if (eq USER-LG "x")
            (progn
              (setq GRIP   (assoc "prot-grip" (cdr 3D-LIS))
                    GR-GRB (cdr (assoc "gbox" (cdr GRIP)))
                    GR-LAY (get-lay "prot-grip")
                    GR-COL (get-col "prot-grip" PCO TYP)
                    IP     (list (+ (car INS-P) -35 (car SR-SID))
                                 (+ (cadr INS-P) 550)
                                 (caddr INS-P))
                    SS-S   (ptb-tegn SS-S IP GR-GRB 10 GR-LAY GR-COL)
                    IP     (list (- (+ (car INS-P) BRE 25) (car SR-SID))
                                 (+ (cadr INS-P) 550)
                                 (caddr INS-P))
                    SS-S   (ptb-tegn SS-S IP GR-GRB 10 GR-LAY GR-COL)
              )
              (setq GLASS  (assoc "prot-glass" (cdr 3D-LIS))
                    GL-LAY (get-lay "prot-glass")
                    GL-COL (get-col "prot-glass" PCO TYP))
              (foreach PL (cdr GLASS)
                (setq PG   (car PL)
                      DG   (cadr PL)
                      GT   5
                      BB   (- BRE (car DG))
                      HH   (- HOJ (cadr DG))
                      IP   (list (+ (car INS-P) (car PG))
                                 (+ (cadr INS-P) (cadr PG))
                                 (+ (caddr INS-P) (caddr PG))) )
                (setq SS-F (boks SS-F IP BB HH GT GL-LAY GL-COL)) )
              (if USER-ROT-SASH
                (rot-3d-do (entlast) IP (+ (* 0.467 (- 90 DCH))(- 90 DCH)) t)) )) ))
;******* glass ***
      (setq GLASS  (assoc "glass" (cdr 3D-LIS))
            GL-LAY (get-lay "glass")
            GL-COL (get-col "glass" PCO TYP))
      (foreach PL (cdr GLASS)
        (setq PG   (car PL)
              DG   (cadr PL)
              GT   (if (caddr PL)
                     (caddr PL)
                     (cadr (assoc (substr PCO 3 2) U-GLASS-TIK)))
              BB   (- BRE (car DG))
              HH   (- HOJ (cadr DG))
              IP   (list (+ (car INS-P) (car PG))
                         (+ (cadr INS-P) (cadr PG))
                         (+ (caddr INS-P) (caddr PG))) )
        (if (not (member TYP '("GIR" "GVO" "_GVO")))
          (setq SS-S (boks SS-S IP BB HH GT GL-LAY GL-COL))
          (setq SS-S (gir-glass SS-S IP (cadr PG) BB HOJ STR GT GL-LAY GL-COL))
        )
      )
;******* ventilationsflap ***
      (if (setq VENT (cond ((member TYP '("GGL" "cGGL" "sGGL" "eGGL" "bGGL"
					  "G62" "G64" "GHL" "dGHL" "GPL" "dGPL"
                                          "GTL" "GTU" "GEL" "GDL-t" "GZL" "GXL"
					  "_GGL" "_GGL_" "_GZL" "_GZL_" "_GHL"))
                              (assoc "ventil" (cdr 3D-LIS)) )
                           ((member TYP '("GGU" "eGGU" "bGGU" "GPU" "dGPU"))
                              (assoc "vent" (cdr 3D-LIS)) )
                           (t nil) ))
        (progn
          (setq VT-TOP (cdr (assoc "top"  (cdr VENT)))
                VT-GRP (cdr (assoc "grip" (cdr VENT)))
                VT-BOX (cdr (assoc "gbox" (cdr VENT)))
                VT-BTX (cadr (assoc "gbox" (cdr VENT)))
                VT-BXT (cadr (assoc "gbx" (cdr VENT)))
                VT-BXX (cdr (assoc "gbx" (cdr VENT)))
                VT-LAY-TOP (get-lay "ventil-top")
                VT-COL-TOP (get-col "ventil-top" PCO TYP)
                VT-LAY-GRP (get-lay "ventil-grip")
                VT-COL-GRP (get-col "ventil-grip" PCO TYP)
                VT-LAY-BOX (get-lay "ventil-gbox")
                VT-COL-BOX (get-col "ventil-gbox" PCO TYP)
                BBT    (- BRE (* 2 (- (car SR-SIT) VT-BTX)))
                BBG    (cond ((member TYP '("GTL" "GTU"))
                                160)
                             ((member TYP '("GGU" "GPU" "dGPU"))
                                (- BBT (* 2  VT-BTX)))
                             (t
                                BBT)))
          (cond ((member TYP '("GGU" "GPU" "dGPU"))
		 (setq IP (list (+ (car INS-P)(car SR-SIT) VT-BXT)
				(+ (cadr INS-P) HOJ)
				(caddr INS-P))
		       SS-V   (ptb-tegn SS-V IP VT-TOP (+ BBG (* -2 VT-BXT)) VT-LAY-TOP VT-COL-TOP)))
		(t
		 (setq IP (list (+ (car INS-P)(- (car SR-SIT) VT-BTX))
				(+ (cadr INS-P) HOJ)
				(caddr INS-P))
		       SS-V   (ptb-tegn SS-V IP VT-TOP BBT VT-LAY-TOP VT-COL-TOP))) )
          (cond ((member TYP '("GGU" "GPU" "dGPU"))
		 (setq IP (list (+ (car INS-P)(car SR-SIT))
				(+ (cadr INS-P) HOJ)
				(caddr INS-P))) )
		((member TYP '("G62" "G64"))
		 (setq IP (list (+ (car INS-P)(- (car SR-SIT) VT-BTX))
				(+ (cadr INS-P) HOJ)
				(- (caddr INS-P) 56))) ) )
          (setq SS-V   (ptb-tegn SS-V IP VT-GRP BBG VT-LAY-GRP VT-COL-GRP) )
          (if (member TYP '("GTL" "GTU"))
            (setq IP     (list (- (+ (car INS-P) BRE) BBG (- (car SR-SIT) VT-BTX))
                               (+ (cadr INS-P) HOJ)
                               (caddr INS-P))
                  SS-V   (ptb-tegn SS-V IP VT-GRP BBG VT-LAY-GRP VT-COL-GRP) ))
          (setq N      (cond ((member TYP '("GGL" "cGGL" "sGGL" "eGGL" "bGGL"
					    "G62" "G64" "GHL" "dGHL" "GPL" "dGPL" "GEL" "GDL-t"
					    "_GGL" "_GGL_" "_GHL" "GXL"))
                                (cond ((eq (substr STR 1 1) "8")
                                         5)
                                      ((member (substr STR 1 1) '("4" "6"))
                                         4)
                                      (t 3)) )
                             ((member TYP '("GGU" "eGGU" "bGGU" "GPU" "dGPU"))
                                (cond ((eq (substr STR 1 1) "6")
                                         5)
                                      ((eq (substr STR 1 1) "4")
                                         4)
                                      (t 3)) )
                             ((member TYP '("GTL" "GTU"))
                                2)
                             ((member TYP '("GZL" "_GZL" "_GZL_"))
                                2)
                       )
                DX     (cond ((member TYP '("GTL" "GTU"))
                                130)
			 ((member TYP '("GZL" "_GZL" "_GZL_"))
                                (/ (- BRE (* 2 (+ 24 (car SR-SIT))) VT-BTX) (- N 1.0)))
			 (t
                                (/ (- BRE (* 2 (car SR-SIT)) VT-BTX) (- N 1.0)) ))
                IP     (cond ((member TYP '("GZL" "_GZL" "_GZL_"))
			      (list (+ (car INS-P)(car SR-SIT) 24)
				    (+ (cadr INS-P) HOJ)
				    (caddr INS-P)) )
			     ((member TYP '("G62" "G64"))
			      (list (+ (car INS-P)(car SR-SIT))
				    (+ (cadr INS-P) HOJ)
				    (- (caddr INS-P) 56)) )
			     (t
			      (list (+ (car INS-P)(car SR-SIT))
				    (+ (cadr INS-P) HOJ)
				    (caddr INS-P)) ))
                I      1)
          (repeat N
            (setq SS-V (cond ((and (eq I 1)(member TYP '("GGU" "eGGU" "bGGU" "GPU" "dGPU")))
                                (ptb-tegn SS-V IP VT-BXX VT-BXT VT-LAY-BOX VT-COL-BOX))
                             ((and (eq I N)(member TYP '("GGU" "eGGU" "bGGU" "GPU" "dGPU")))
                                (setq IP (list (+ (car IP) VT-BTX (* -1 VT-BXT))(cadr IP)(caddr IP)))
                                (ptb-tegn SS-V IP VT-BXX VT-BXT VT-LAY-BOX VT-COL-BOX))
                             (t
                                (ptb-tegn SS-V IP VT-BOX VT-BTX VT-LAY-BOX VT-COL-BOX) ))
                  I    (1+ I)
                  IP   (list (+ (car IP) DX)(cadr IP)(caddr IP))) )

          (if (member TYP '("GTL" "GTU"))
            (progn
              (setq IP   (list (- (+ (car INS-P) BRE VT-BTX VT-BTX) BBG (car SR-SIT))
                               (+ (cadr INS-P) HOJ)
                               (caddr INS-P)))
              (repeat N
                (setq SS-V (ptb-tegn SS-V IP VT-BOX VT-BTX VT-LAY-BOX VT-COL-BOX)
                      IP   (list (+ (car IP) DX)(cadr IP)(caddr IP))) ) ))
      ))
;******* grip ***
      (cond ((member TYP '("GHL" "dGHL" "GPU" "dGPU" "GPL" "dGPL" "GEL" "GDL-t"
			   "_GHL"))
              (setq GRIP   (assoc "grip" (cdr 3D-LIS))
                    GR-BX1 (cdr (assoc "gbox1" (cdr GRIP)))
                    GR-BT1 (cadr (assoc "gbox1" (cdr GRIP)))
                    GR-BX2 (cdr (assoc "gbox2" (cdr GRIP)))
                    GR-BT2 (cadr (assoc "gbox2" (cdr GRIP)))
                    GR-BX3 (cdr (assoc "gbox3" (cdr GRIP)))
                    GR-BT3 (cadr (assoc "gbox3" (cdr GRIP)))
                    GR-LAY-GRP (get-lay "ventil-grip")
                    GR-COL-GRP (get-col "ventil-grip" PCO TYP)
                    IP     (list (+ (car INS-P)(/ (- BRE GR-BT1) 2.0))
                                 (+ (cadr INS-P)(car FR-BOT) 30)
                               (caddr INS-P))
                    SS-S (ptb-tegn SS-S IP GR-BX1 GR-BT1 GR-LAY-GRP GR-COL-GRP)
                    IP     (list (+ (car INS-P)(/ (- BRE GR-BT2) 2.0))
                                 (+ (cadr INS-P)(car FR-BOT) 30)
                               (caddr INS-P))
                    SS-S (ptb-tegn SS-S IP GR-BX2 GR-BT2 GR-LAY-GRP GR-COL-GRP)
                    SS-S (ptb-tegn SS-S IP GR-BX3 GR-BT3 GR-LAY-GRP GR-COL-GRP) ))
            ((member TYP '("GTL" "GTU"))
              (setq GRIP   (assoc "grip" (cdr 3D-LIS))
                    GR-GRP (cdr (assoc "grip" (cdr GRIP)))
                    GR-BXT (cadr (assoc "gbx" (cdr GRIP)))
                    GR-BXX (cdr (assoc "gbx" (cdr GRIP)))
                    GR-LAY-GRP (get-lay "ventil-grip")
                    GR-COL-GRP (get-col "ventil-grip" PCO TYP)
                    IP   (list (+ (car INS-P)(car SR-SIT))
                               (+ (cadr INS-P)(car FR-BOT) 530)
                               (caddr INS-P))
                    SS-S (ptb-tegn SS-S IP GR-GRP (- BRE (* 2 (car SR-SIT))) GR-LAY-GRP GR-COL-GRP)
                    SS-S (ptb-tegn SS-S IP GR-BXX GR-BXT GR-LAY-GRP GR-COL-GRP)
                    IP   (list (- (+ (car INS-P) BRE)(car SR-SIT))
                               (+ (cadr INS-P)(car FR-BOT) 530)
                               (caddr INS-P))
                    SS-S (ptb-tegn SS-S IP GR-BXX (* -1 GR-BXT) GR-LAY-GRP GR-COL-GRP) ))
            ((member TYP '("VFE"))
              (setq GRIP   (assoc "grip" (cdr 3D-LIS))
                    GR-GRP (cdr (assoc "grip" (cdr GRIP)))
                    GR-LAY-GRP (get-lay "ventil-grip")
                    GR-COL-GRP (get-col "ventil-grip" PCO TYP)
                    IP   (list (+ (car INS-P)(/ BRE 2.0) -60)
                               (- (+ (cadr INS-P) HOJ) (car FR-TOP))
                               (caddr INS-P) )
                    SS-S (ptb-tegn SS-S IP GR-GRP 120 GR-LAY-GRP GR-COL-GRP) ))
            ((member TYP '("VFA" "VFB" "VEA" "VEB" "GXL"))
              (setq GRIP   (assoc "grip" (cdr 3D-LIS))
                    GR-BX1 (cdr  (assoc "gbox1" (cdr GRIP)))
                    GR-BT1 (cadr (assoc "gbox1" (cdr GRIP)))
                    GR-BX2 (cdr  (assoc "gbox2" (cdr GRIP)))
                    GR-BT2 (cadr (assoc "gbox2" (cdr GRIP)))
                    GR-BX3 (cdr  (assoc "gbox3" (cdr GRIP)))
                    GR-BT3 (cadr (assoc "gbox3" (cdr GRIP)))
                    GR-LAY-GRP (get-lay "ventil-grip")
                    GR-COL-GRP (get-col "ventil-grip" PCO TYP)
                    IP (list (+ (car INS-P)
                                (cond ((member TYP '("VFB" "GXL"))
                                        (- BRE (car FR-SID)
                                           30))
                                      ((member TYP '("VEB"))
                                        (- BRE (car FR-SID)
                                           45))
                                      ((member TYP '("VFA" "VEA"))
                                        (+ (car FR-SID) 20))
                                      (t
                                        (car FR-SID))))
                             (+ (cadr INS-P)
                                (cond ((member TYP '("VEA" "VEB"))
                                        (+ HOJ -280 -55))
                                      (t
                                        (+ (/ HOJ 2.0) 50))))
                             (caddr INS-P))
                    SS-S (ptb-tegn SS-S IP GR-BX1 GR-BT1 GR-LAY-GRP GR-COL-GRP)
                    SS-S (ptb-tegn SS-S IP GR-BX2 GR-BT2 GR-LAY-GRP GR-COL-GRP)
                    SS-S (ptb-tegn SS-S IP GR-BX3 GR-BT3 GR-LAY-GRP GR-COL-GRP) ))
            ((member TYP '("GVT" "_GVT"))
              (setq GRIP   (assoc "grip" (cdr 3D-LIS))
                    GR-BX1 (cdr  (assoc "gbox1" (cdr GRIP)))
                    GR-BT1 (cadr (assoc "gbox1" (cdr GRIP)))
                    GR-LAY-GRP (get-lay "grip")
                    GR-COL-GRP (get-col "grip" PCO TYP)
                    IP (list (+ (car INS-P) BRE)
                             (+ (cadr INS-P) (* 0.5 HOJ) (* 0.5 GR-BT1))
                             (caddr INS-P))
                    SS3 (ptb-tegn (ssadd) IP GR-BX1 GR-BT1 GR-LAY-GRP GR-COL-GRP)
		IP  (list (car IP)(cadr IP)(+ 89 (caddr IP))))
              (rot-3d-do SS3 IP 90 nil)
	  (if USER-ROT-SASH
	    (rot-3d-do SS3 IP 90 t))
	  (setq SS-S (ss-add SS-S SS3))
            )
            ((member TYP '("GDL-b"))
              (setq GRIP   (assoc "grip" (cdr 3D-LIS))
                    GR-GRP (cdr (assoc "grip" (cdr GRIP)))
                    GR-GRB (cdr (assoc "gbox" (cdr GRIP)))
                    GR-LAY-GRP (get-lay "ventil-grip")
                    GR-COL-GRP (get-col "ventil-grip" PCO TYP)
                    IP   (list (+ (car INS-P) 15 (car SR-SID))
                               (- (+ (cadr INS-P) HOJ) (car FR-TOP))
                               (caddr INS-P))
                    SS-S (ptb-tegn SS-S IP GR-GRP 130 GR-LAY-GRP GR-COL-GRP)
                    SS-S (ptb-tegn SS-S IP GR-GRB  10 GR-LAY-GRP GR-COL-GRP)
                    IP   (list (+ (car INS-P) 145 (car SR-SID))
                               (- (+ (cadr INS-P) HOJ) (car FR-TOP))
                               (caddr INS-P))
                    SS-S (ptb-tegn SS-S IP GR-GRB -10 GR-LAY-GRP GR-COL-GRP)
                    IP   (list (- (+ (car INS-P) BRE) 15 (car SR-SID))
                               (- (+ (cadr INS-P) HOJ) (car FR-TOP))
                               (caddr INS-P))
                    SS-S (ptb-tegn SS-S IP GR-GRP -130 GR-LAY-GRP GR-COL-GRP)
                    SS-S (ptb-tegn SS-S IP GR-GRB  -10 GR-LAY-GRP GR-COL-GRP)
                    IP   (list (- (+ (car INS-P) BRE) 145 (car SR-SID))
                               (- (+ (cadr INS-P) HOJ) (car FR-TOP))
                               (caddr INS-P))
                    SS-S (ptb-tegn SS-S IP GR-GRB   10 GR-LAY-GRP GR-COL-GRP)
            ))
      ) ))

;******* end ***

  (list SS-F SS-S SS-V))
;==============================================================================
;*************************************************************************
;    tegning af indkning
;*************************************************************************
;==============================================================================
(defun i-3d-2 ( SS INS-P TYP STR BRE HOJ FLA PCO N A-X A-Y D-X D-Y
              / FLASH DB DT DS DZ FL-LAY FL-COL IP PLL
              )
  (if paucheck (progn (princ "\ni-3d-2")
		 (princ (list SS INS-P TYP STR BRE HOJ FLA PCO N A-X A-Y D-X D-Y))))
  (if (setq FLASH  (car (get-3d-l FLA nil)))
    (progn
      (setq DB     (cond ((>= N A-X) D-Y)
		         (t (caadr FLASH)))
            DT     (cond ((< N (* A-X A-Y)) 0)
		         (t (cadadr FLASH)))
            DS1    (cond ((not (or (eq N 0)
				   (eq (gcd N A-X) A-X))) D-X)
		         (t (caddr (cadr FLASH))))
            DS2    (cond ((not (eq (gcd (1+ N) A-X) A-X)) D-X)
		         (t (caddr (cadr FLASH))))
            DZ     (caddr FLASH)
            FL-LAY (get-lay "flashing")
            FL-COL (get-col "flashing" PCO TYP))
;******* flashing ***
      (if (not (member TYP '("GIR"))); "GVO" "_GVO"
        (setq IP (list (+ (car INS-P) (car (car FLASH)))
                       (+ (cadr INS-P) (cadr (car FLASH)))
                       (+ (caddr INS-P) (caddr (car FLASH))))
              SS (flas SS IP BRE HOJ DB DT DS1 DS2 FL-LAY FL-COL)
              IP (list (+ -1 (car INS-P) (car (car FLASH)))
                       (+ -1 (cadr INS-P) (cadr (car FLASH)))
                       (+ (caddr INS-P) (caddr (car FLASH))))
              SS (k-tegn SS IP (+ 2 BRE) (+ 2 HOJ) DZ FL-LAY FL-COL DB DT))
        (setq PLL (list 0 (list (list '(0 0)
                    (list (list -70 0) '(0 0) (list 0 118) '(0 0))
                  )))
              IP (list (+ (car INS-P) BRE)(cadr INS-P)(caddr INS-P))
              SS (psx-tegn SS IP PLL BRE HOJ STR FL-LAY FL-COL)) ) ))
  SS)
;==============================================================================
;*************************************************************************
;    tegning af lysningspanel
;*************************************************************************
;==============================================================================
(defun i-3d-3 ( SS INS-P TYP STR BRE HOJ DCH TGA3-L TB AFS
              / IN1 IN2 IN3 DC 3D-LIS IP
                SOLID DS-BTS DS-TBX DS-BOT DS-TOP DS-SID
                EXTENS EX-BOT EX-TOP EX-SID EX-SDD EX-LAY EX-COL
                DZ- DZZ DXB DXT DZ DB DH BBB BB HHH HH DH TT DD BD DB BH HC
                P1 P2 P3 P4 PLL)
  (if paucheck (progn (princ "\ni-3d-3")
		 (princ (list SS INS-P TYP STR BRE HOJ DCH TGA3-L TB AFS))))
;*** frame-extension ***
  (if (setq 3D-LIS (get-3d-l TYP STR))
    (progn
      (setq IN1    (get-typ (car TGA3-L))
            IN2    (get-typ (cadr TGA3-L))
            IN3    (get-typ (caddr TGA3-L))
            DC     (dtr DCH)
            SOLID  (assoc "solid" (cdr 3D-LIS))
            DS-BTS (cadr (assoc "dxy-bts" (cdr SOLID)))
            DS-TBX (cadr (assoc "dz-tbx" (cdr SOLID)))
            DS-BOT (car DS-BTS)
            DS-TOP (cadr DS-BTS)
            DS-SID (caddr DS-BTS))
      (cond ((or (member IN1 '("LGI"))
		 (member IN2 '("LGI")))
              (setq EXTENS (if (member IN2 '("LGI"))
			     (get-3d-l IN2 STR)
			     (get-3d-l IN1 STR))
                    EX-BOT (cdr (assoc "bottom" (cdr EXTENS))) ; 40
                    EX-TOP (cdr (assoc "top"    (cdr EXTENS))) ; 40
                    EX-SID (cdr (assoc "side"   (cdr EXTENS))) ; 40
		    EX-LGI 60
                    ;EX-SDD (cadr (assoc "sid"   (cdr EXTENS))) ;  5
                    EX-LAY (get-lay "extension")
                    EX-COL (if (member IN2 '("LGI"))
			     (get-col "lining" (get-mat (cadr TGA3-L)) IN2)
			     (get-col "lining" (get-mat (car TGA3-L)) IN1))
                    BB (- BRE (* 2 (car EX-SID)))
                    IP (list (+ (car INS-P)(car EX-SID))
                             (cadr INS-P)
                             (caddr INS-P))
                    SS (if (member TB '("-bot" "-topbot"))
                         SS
                         (ptb-tegn SS IP EX-BOT BB EX-LAY EX-COL) )
                    IP (list (+ (car INS-P)(car EX-SID))
                             (+ (cadr INS-P) HOJ)
                             (caddr INS-P))
                    SS (if (member TB '("-top" "-topbot"))
                         SS
                         (ptb-tegn SS IP EX-TOP BB EX-LAY EX-COL) )
                    IP (list (car INS-P)
                             (cadr INS-P)
                             (caddr INS-P))
                    SS (psl-tegn SS IP EX-SID HOJ EX-LAY EX-COL)
                    IP (list (+ (car INS-P) BRE)
                             (cadr INS-P)
                             (caddr INS-P))
                    SS (psr-tegn SS IP EX-SID HOJ EX-LAY EX-COL) ) ))
      (cond ((or (member IN3 '("LSC" "LSB" "LSD"))
		 (member IN2 '("LSC" "LSB" "LSD"))
		 (member IN1 '("LSC" "LSB" "LSD"))) ; "LLC" "LLB" "LLD" "LVI"))
              (setq EXTENS (cond ((member IN3 '("LSC" "LSB" "LSD")) (get-3d-l IN3 STR))
				 ((member IN2 '("LSC" "LSB" "LSD")) (get-3d-l IN2 STR))
				 (t (get-3d-l IN1 STR)))
                    EX-BOT (cdr (assoc "bottom" (cdr EXTENS))) ; 60
                    EX-TOP (cdr (assoc "top"    (cdr EXTENS))) ; 60
                    EX-SID (cdr (assoc "side"   (cdr EXTENS))) ; 60
                    EX-SDD (cadr (assoc "sid"   (cdr EXTENS))) ;  5
                    EX-LAY (get-lay "lining")
                    EX-COL (cond ((member IN3 '("LSC" "LSB" "LSD"))
				    (get-col "lining" (get-mat (cadr TGA3-L)) IN3))
				 ((member IN2 '("LSC" "LSB" "LSD"))
				    (get-col "lining" (get-mat (cadr TGA3-L)) IN2))
				 (t (get-col "lining" (get-mat (car TGA3-L)) IN1)))
                    DZ- (- (cadddr DS-TBX) (cadr DS-TBX))
                    DZZ (if (or (and (member IN1 '("LGI"))(member IN2 '("LSC" "LSB" "LSD")))
				(and (member IN1 '("LGI"))(member IN3 '("LSC" "LSB" "LSD"))))
			  (- (caadr AFS) (cadddr DS-TBX) EX-LGI)
			  (- (caadr AFS) (cadddr DS-TBX)))
                    DXB (get-tri-a DC nil DZZ nil)
                    DXT (get-tri-b DC nil DZZ nil)
                    DZ  (caadr AFS)
                    DB  (cadadr AFS)
                    DH  (caddr (cadr AFS))
                    BBB (+ (- BRE (* 2 DS-SID)) (* 2 EX-SDD))
                    BB  (+ BRE (* 2 (- (car EX-SID) EX-SDD DS-SID)))
                    HHH (+ (- HOJ (* 2 DS-SID)) (* 2 EX-SDD))
                    HH  (- (+ HOJ DXB DXT) (* 2 (+ DS-SID EX-SDD)))
                    DH  (if (or (eq IN1 "LFI") (eq IN2 "LFI")) 100 DH)
                    TT  (if (or (eq IN1 "LFI") (eq IN2 "LFI"))  19 19)
                    DD  (if (or (eq IN1 "LFI") (eq IN2 "LFI"))  12  0)
                    BD  (if (or (eq IN1 "LFI") (eq IN2 "LFI"))   0 18.5)
                    DB  (if (or (eq IN1 "LFI") (eq IN2 "LFI")) 200 DB)
                    BH  (+ DB DD BD)
                    HC  (- DH (get-tri-b DC nil nil DZ-))
                    
                    IP  (list (- (+ (car INS-P) DS-SID EX-SDD)(car EX-SID))
                              (- (+ (cadr INS-P) DS-SID) DXB)
                              (- (caddr INS-P) DZ))
                    SS  (if (or (member IN1 '("LEI")) (member IN2 '("LEI")))
                          (ptb-tegn SS
                          (list (- (+ (car INS-P) DS-SID EX-SDD)(car EX-SID))
                                (- (+ (cadr INS-P) DS-BOT)
                                   (get-tri-a DC nil nil HC))
                                (- (caddr INS-P) (cadddr DS-TBX)
                                   (get-tri-b DC nil nil HC)) )
                          (list 0 (list (list '(0 0) (list
                           (setq P1
                            (list (- (get-tri-b DC nil nil DB)
                                     (get-tri-a DC nil nil TT))
                                  (- (* -1 (get-tri-a DC nil nil DB))
                                     (get-tri-b DC nil nil TT)) )
                           )
                           (setq P2
                            (list (- (get-tri-b DC nil nil DB)
                                     (get-tri-a DC nil nil (+ 60 TT)))
                                  (- (* -1 (get-tri-a DC nil nil DB))
                                     (get-tri-b DC nil nil (+ 60 TT))) )
                           )
                           (setq P3
                            (list (- (get-tri-b DC nil nil (- DB 15))
                                     (get-tri-a DC nil nil (+ 60 TT)))
                                  (- (* -1 (get-tri-a DC nil nil (- DB 15)))
                                     (get-tri-b DC nil nil (+ 60 TT))) )
                           )
                           (setq P4
                            (list (- (get-tri-b DC nil nil (- DB 15))
                                     (get-tri-a DC nil nil TT))
                                  (- (* -1 (get-tri-a DC nil nil (- DB 15)))
                                     (get-tri-b DC nil nil TT)) )
                           )
                            (list (- (get-tri-b DC nil nil DB)
                                     (get-tri-a DC nil nil TT))
                                  (- (* -1 (get-tri-a DC nil nil DB))
                                     (get-tri-b DC nil nil TT)) )
                             ) (list (list P1 P2 P3 P4)) )))
                          BB EX-LAY EX-COL)
                          (ptb-tegn SS IP EX-BOT BB EX-LAY EX-COL) )
                    IP  (list (- (+ (car INS-P) DS-SID) EX-SDD)
                              (- (+ (cadr INS-P) DS-SID) DXB)
                              (- (caddr INS-P) DZ))
                    PLL (list 0 (list (list '(0 0) (list
                          '(0 0)
                          '(-5 0)
                          (list (- DXB 5) DZZ)
                          (list (- DXB 5) (+ DZZ DZ-))
                          (list DXB (+ DZZ DZ-))
                          (list DXB DZZ)
                          '(0 0) ))))
                    SS  (ptb-tegn SS IP PLL BBB EX-LAY EX-COL)
                    IP  (list (- (+ (car INS-P) DS-SID EX-SDD)(car EX-SID))
                              (+ (- (cadr INS-P) DS-SID) HOJ DXT)
                              (- (caddr INS-P) DZ))
                    SS  (ptb-tegn SS IP EX-TOP BB EX-LAY EX-COL)
                    IP  (list (- (+ (car INS-P) DS-SID) EX-SDD)
                              (+ (- (cadr INS-P) DS-SID) HOJ DXT)
                              (- (caddr INS-P) DZ))
                    PLL (list 0 (list (list '(0 0) (list
                          '(0 0)
                          '(5 0)
                          (list (* -1 (- DXT 5)) DZZ)
                          (list (* -1 (- DXT 5)) (+ DZZ DZ-))
                          (list (* -1 DXT) (+ DZZ DZ-))
                          (list (* -1 DXT) DZZ)
                          '(0 0) ))))
                    SS  (ptb-tegn SS IP PLL BBB EX-LAY EX-COL)
                    IP  (if (or (member IN1 '("LEI")) (member IN2 '("LEI")))
                          (list (+ (car INS-P) DS-SID)
                                (+ (cadr INS-P) DS-SID EX-SDD)
                                (- (caddr INS-P) DZ))
                          (list (+ (car INS-P) DS-SID)
                                (+ (- (cadr INS-P) DXB) DS-SID EX-SDD)
                                (- (caddr INS-P) DZ)) )
                    SS  (if (or (member IN1 '("LEI")) (member IN2 '("LEI")))
                          (psl-tegn SS IP EX-SID (- HH DXB) EX-LAY EX-COL)
                          (psl-tegn SS IP EX-SID HH EX-LAY EX-COL) )
                    IP  (if (or (member IN1 '("LEI")) (member IN2 '("LEI")))
                          (list (- (+ (car INS-P) BRE) DS-SID)
                                (+ (cadr INS-P) DS-SID EX-SDD)
                                (- (caddr INS-P) DZ))
                          (list (- (+ (car INS-P) BRE) DS-SID)
                                (+ (- (cadr INS-P) DXB) DS-SID EX-SDD)
                                (- (caddr INS-P) DZ)) )
                    SS  (if (or (member IN1 '("LEI")) (member IN2 '("LEI")))
                          (psr-tegn SS IP EX-SID (- HH DXB) EX-LAY EX-COL)
                          (psr-tegn SS IP EX-SID HH EX-LAY EX-COL) ) )
              (command"_.ucs" "_w"
                      "_.ucs" "_x" (/ pi 2.0)
                      "_.ucs" "_y" (/ pi 2.0))
              (setq IP (list (- (+ (car INS-P) DS-SID) EX-SDD)
                             (- (+ (cadr INS-P) DS-SID) DXB)
                             (- (caddr INS-P) DZ))
                    IP (trans IP 0 1))
              (command "_.pline"
                          (list (- (car IP) 5) (cadr IP) (caddr IP))
                          (list (- (+ (car IP) DXB) 5) (+ (cadr IP) DZZ))
                          (list (- (+ (car IP) DXB) 5) (+ (cadr IP) DZZ DZ-))
                          (list (+ (car IP) (- DXB 5) HHH) (+ (cadr IP) DZZ DZ-))
                          (list (+ (car IP) (- DXB 5) HHH) (+ (cadr IP) DZZ))
                          (list (+ (car IP) (- DXB 5) HHH DXT) (cadr IP))
                           "_close"
                       "_.extrude" (entlast) "" 5 0)
              (skift (ssadd (entlast)) EX-LAY EX-COL)
              (setq SS (ssadd (entlast) SS))
              (command "_.copy" (entlast) "" '(0 0 0) (list 0 0 (- BBB EX-SDD))
                       "_.ucs" "_w")
              (setq SS (ssadd (entlast) SS))
              (if (or (member IN1 '("LFI" "LEI"))(member IN2 '("LFI" "LEI")))
                (setq IP  (list (+ (car INS-P) DS-SID)
                                (- (+ (cadr INS-P) DS-BOT)
                                   (get-tri-a DC nil nil HC))
                                (- (caddr INS-P) (cadddr DS-TBX)
                                   (get-tri-b DC nil nil HC)) )
                      P1  (list (get-tri-b DC nil nil DD)
                                (* -1 (get-tri-a DC nil nil DD)) )
                      P2  (list (get-tri-b DC nil nil BH)
                                (* -1 (get-tri-a DC nil nil BH)) )
                      P3  (list (- (get-tri-b DC nil nil BH)
                                   (get-tri-a DC nil nil TT))
                                (- (* -1 (get-tri-a DC nil nil BH))
                                   (get-tri-b DC nil nil TT)) )
                      P4  (list (- (get-tri-b DC nil nil DD)
                                   (get-tri-a DC nil nil TT))
                                (- (* -1 (get-tri-a DC nil nil DD))
                                   (get-tri-b DC nil nil TT)) )
                      PLL (list 0 (list (list '(0 0) (list
                            P1 P2 P3 P4 P1
                          ) (list (list P1 P2 P3 P4)) )))
                      SS  (ptb-tegn SS IP PLL (- BRE (* 2 DS-SID)) EX-LAY EX-COL)
            )) )) ))
  SS)
;==============================================================================
;*************************************************************************
;    tegning af tilbehr
;*************************************************************************
;==============================================================================
(defun i-3d-4 (SS-F SS-S INS-P TYP STR BRE HOJ ZUB PCO
              / ACCESSOR 3D-LIS SASH RT-S SSA AC-LAY AC-COL
                AC-COZ TC DP DX DY TT IP
                AC-BOT AC-BTT AC-TOP AC-SID BB PB PT VV
                SASH SR-BOT SR-TOP SR-SID FRAME FR-TOP DZ SZ HH
              )
  (if paucheck (progn (princ "\ni-3d-4  ")(princ typ)))
  (if (eq "_" (substr TYP 1 1))
    (setq INS-P (list (car INS-P)(cadr INS-P)(+ 33 (caddr INS-P)))))
  (if (and (setq 3D-LIS (get-3d-l TYP STR))
           (setq ACCESSOR (get-3d-l ZUB STR)))
    (progn
;******* accessories ***
      (setq SASH   (assoc "sash" (cdr 3D-LIS))
            RT-S   (cadr (assoc "rot-p" (cdr SASH)))
            SSA    (ssadd)
            AC-LAY (get-lay "accessories")
            AC-COL (get-col "accessories" PCO TYP))
      (cond ((member ZUB '("MHL" "MAL"))
               (setq AC-COZ (get-col ZUB PCO TYP)
                     TC     (cadr (assoc "case" (cdr ACCESSOR)))
                     DP     (car TC)
                     DX     (car (cadr TC))
                     DY     (cadr (cadr TC))
                     TT     (caddr TC)
                     IP     (list (+ (car INS-P) (car DP))
                                  (+ (cadr INS-P) HOJ (cadr DP))
                                  (+ (caddr INS-P) (caddr DP)))
                     SSA    (boks SSA IP (- BRE DX)
                                  (* -1 (- HOJ DY)) TT AC-LAY AC-COZ) )
               (if (and USER-ROT-SASH
                        (not (member TYP '("GHL" "dGHL" "GPU" "dGPU" "GPL" "dGPL" "GTL" "GTU" "GEL" "GDL-t"
					   "_GHL"))))
                 (rot-3d-do SSA IP (+ -1.5 (/ RT-S 2.0)) t) ))
            ((member ZUB '("SCL" "SML" "SSL" "SMG" "MML"))
               (setq AC-COZ (get-col ZUB PCO TYP)
                     AC-TOP (cdr (assoc "top"   (cdr ACCESSOR)))
                     AC-SID (cdr (assoc "side"  (cdr ACCESSOR))) )
               (setq IP     (list (- (car INS-P)(car AC-SID))(cadr INS-P)(caddr INS-P))
                     PB     (car   (caddr AC-SID))
                     PT     (cadr  (caddr AC-SID))
                     PF     (caddr  (cadr AC-SID))
                     TT     (cadddr (caddr AC-SID))
                     HH     (if (eq ZUB "MML") (+ (/ HOJ 2.0) 55) HOJ)
                     AC-SS  (append PB
                              (mapcar '(lambda (P) (list (+ (car P) HH)(cadr P)) ) PT)
                              (list (car PB)))
                     M      (1- (length AC-SS))
                     PF     (append (list (list (nth (- M 1) AC-SS)(nth (- M 2) AC-SS)
                                                (nth (- M 5) AC-SS)(nth 0 AC-SS))
                                          (list (nth (- M 2) AC-SS)(nth (- M 3) AC-SS)
                                                (nth (- M 4) AC-SS)(nth (- M 5) AC-SS))))
                     AC-SSS (list 0 (list (list '(0 0) AC-SS PF)))
                     SSA    (ptb-tegn SSA IP AC-SSS TT AC-LAY AC-COZ)
                     IP     (list (+ (car INS-P) BRE (car AC-SID))(cadr INS-P)(caddr INS-P))
                     SSA    (ptb-tegn SSA IP AC-SSS (* -1 TT) AC-LAY AC-COZ)
                     VV (cadr (assoc "rot-p" (cdr (assoc "sash" (cdr (get-3d-l TYP STR))))))
                     AA (abs (get-tri-a (dtr VV) nil (/ HOJ 2.0) nil))
                     VV (* -1 (rtd (atan (/ (- AA 25) HH)))) )
               (if (and USER-ROT-SASH (eq ZUB "MML")
                        (not (member TYP '("GHL" "dGHL" "GPU" "dGPU" "GPL" "dGPL" "GTL" "GTU" "GEL" "GDL-t"
					   "GHL"))))
                 (rot-3d-do SSA (list (car IP)(+ (cadr IP) HH)(+ (caddr IP) 150)) VV t) )
               (setq IP     (list (+ (car INS-P)(car AC-TOP))
                                  (+ (cadr INS-P) HOJ)
                                  (caddr INS-P))
                     BB     (- BRE (* 2 (car AC-TOP)))
                     SSA    (ptb-tegn SSA IP AC-TOP BB AC-LAY AC-COZ)
                     IP     (list (- (car INS-P)(car AC-SID))(cadr INS-P)(caddr INS-P))
                     PB     (car   (cadr AC-SID))
                     PT     (cadr  (cadr AC-SID))
                     PF     (caddr  (cadr AC-SID))
                     TT     (cadddr (cadr AC-SID))
                     HH     (if (eq ZUB "MML") (+ (/ HOJ 2.0) 55) 0)
                     AC-SS  (append
                              (mapcar '(lambda (P)(list (+ (car P) HH)(cadr P)) ) PB)
                              (mapcar '(lambda (P)(list (+ (car P) HOJ)(cadr P)) ) PT)
                              (list (car PB)))
                     M      (1- (length AC-SS))
                     PF     (if (eq ZUB "MML")
                              (append PF (list (list (nth (- M 1) AC-SS)(nth (- M 2) AC-SS)
                                                     (nth (- M 3) AC-SS)(nth (- M 4) AC-SS))))
                              (append PF (list (list (nth M AC-SS)(nth (- M 1) AC-SS)
                                                     (nth (- M 2) AC-SS)(nth (- M 3) AC-SS)))))
                     AC-SSS (list 0 (list (list '(0 0) AC-SS PF)))
                     SSA    (ptb-tegn SSA IP AC-SSS TT AC-LAY AC-COZ))
               (setq IP     (list (+ (car INS-P) BRE (car AC-SID))(cadr INS-P)(caddr INS-P))
                     SSA    (ptb-tegn SSA IP AC-SSS (* -1 TT) AC-LAY AC-COZ))
             
            )
            ((member ZUB '("FYL" "FKL" "FPL"
                           "FHL" "FML" "FHU"
                           "PAL" "PBL" "PML" "PAU" "PBU" "PMU"
                           "RHL" "RML" "RNL" "RLL" "RPL" "RFU" "RFL" "RGL" "RLG"
                           "DKL" "DGL" "DML" "DKU"))
               (if (member (substr STR 1 1) '("1" "2"))
                 (cond ((eq TYP "---")
                          (setq AC-TOP-Y  40))
                       (t (setq AC-TOP-Y  40)))
                 (cond ((member TYP '("VFE" "VFA" "VFB"))
                          (setq AC-TOP-Y  50))
                       ((member TYP '("VIU"))
                          (setq AC-TOP-Y  45))
                       ((member TYP '("VEC" "VEA" "VEB"))
                          (setq AC-TOP-Y  46))
                       ((member TYP '("GDL-b"))
                          (setq AC-TOP-Y  59))
                       (t (setq AC-TOP-Y  45))) )
               (cond ((member TYP '("G62" "G64"))
                        (setq AC-TOP-Z -56))
                     ((member TYP '("VFE" "VFA" "VFB"))
                        (setq AC-TOP-Z -39))
                     ((member TYP '("VIU"))
                        (setq AC-TOP-Z -0))
                     ((member TYP '("VEC" "VEA" "VEB"))
                        (setq AC-TOP-Z -22))
                     ((member TYP '("GEL"))
                        (setq AC-TOP-Z 33))
                     ((member TYP '("GDL-t" "GDL-b"))
                        (setq AC-TOP-Z 6))
                     (t (setq AC-TOP-Z   0)))
               (setq SASH   (assoc "sash" (cdr 3D-LIS))
                     SR-BOT (cdr (assoc "bottom" (cdr SASH)))
                     SR-TOP (cdr (assoc "top"    (cdr SASH)))
                     SR-SID (cdr (assoc "side"   (cdr SASH)))
                     FRAME  (assoc "frame" (cdr 3D-LIS))
                     FR-TOP (cdr (assoc "top"    (cdr FRAME)))
                     AC-COZ (get-col ZUB PCO TYP)
                     AC-BOT (cdr (assoc "bottom" (cdr ACCESSOR)))
                     AC-TOP (cdr (assoc "top"    (cdr ACCESSOR)))
                     AC-SID (cdr (assoc "side"   (cdr ACCESSOR)))
                     TC     (cadr (assoc "case" (cdr ACCESSOR)))
                     DZ     (car TC)
                     SZ     (/ HOJ -3.0)
                     TT     (cadr TC)
                     BB     (- BRE (* 2 (+ (car SR-SID)(car AC-SID))))
                     HH     (- HOJ (car SR-TOP)(car SR-BOT) AC-TOP-Y) )
               (if (member ZUB '("FYL" "FKL"))
                 (setq IP  (list (+ (car INS-P)(car SR-SID)(car AC-SID))
                                 (+ (cadr INS-P) (car SR-BOT))
                                 (+ (caddr INS-P) DZ AC-TOP-Z))
                       SSA (boks SSA IP (- BRE (* 2 (+ (car SR-SID)(car AC-SID)))) (* -1 SZ) TT AC-LAY AC-COZ))
                 (setq IP  (list (+ (car INS-P)(car SR-SID)(car AC-SID))
                                 (- (+ (cadr INS-P) HOJ) (car SR-TOP) AC-TOP-Y)
                                 (+ (caddr INS-P) DZ AC-TOP-Z))
                       SSA (boks SSA IP (- BRE (* 2 (+ (car SR-SID)(car AC-SID)))) SZ TT AC-LAY AC-COZ)))
               (if (member ZUB '("FYL" "FKL" "FML" "RML" "DML"))
                 (setq IP  (list (+ (car INS-P)(car SR-SID)(car AC-SID))
                                 (+ (cadr INS-P) (car SR-BOT))
                                 (+ (caddr INS-P) AC-TOP-Z))
                       SSA (ptb-tegn SSA IP AC-BOT BB AC-LAY AC-COL)))
               (if (not (member ZUB '("FYL" "FKL")))
                 (setq IP  (list (+ (car INS-P)(car SR-SID)(car AC-SID))
                                 (- (+ (cadr INS-P) HOJ) (car SR-TOP) AC-TOP-Y)
                                 (+ (caddr INS-P) AC-TOP-Z))
                       SSA (ptb-tegn SSA IP AC-TOP BB AC-LAY AC-COL)))
               (if (not (member ZUB '("RHL" "RLL" "RNL" "FYL" "FKL")))
                 (setq IP  (list (car INS-P)
                                 (+ (cadr INS-P) (car SR-BOT))
                                 (+ (caddr INS-P) AC-TOP-Z))
                       SSA (psl-tegn SSA IP AC-SID HH AC-LAY AC-COL)
                       IP  (list (+ (car INS-P) BRE)
                                 (+ (cadr INS-P) (car SR-BOT))
                                 (+ (caddr INS-P) AC-TOP-Z))
                       SSA (psr-tegn SSA IP AC-SID HH AC-LAY AC-COL) ) ) ))
      (cond ((member ZUB '("SCL" "SML" "SSL" "SMG"))
               (setq SS-F (ss-add SSA SS-F)))
            ((member ZUB '("MHL" "MAL" "MML"))
               (if (member TYP '("GHL" "dGHL" "GPU" "dGPU" "GPL" "dGPL" "GTL" "GTU" "GEL" "GDL-t"
				 "_GHL"))
                 (setq SS-S (ss-add SSA SS-S))
                 (setq SS-F (ss-add SSA SS-F))))
            (t
               (setq SS-S (ss-add SSA SS-S))) )
  ))
  (list SS-F SS-S))
;==============================================================================
;*************************************************************************
;    tegning af alle kombinationerne
;*************************************************************************
;==============================================================================
;==============================================================================
;==============================================================================
(defun get-data (TL)
  (if paucheck (princ "\nget-data"))
  (setq SS1  (ssadd)
	SS2  (ssadd)
        SS-F (ssadd)
        SS-S (ssadd)
        SS-V (ssadd)
	;SS-D (ssadd)
        TYP  (get-typ TL)
        TYP  (cond ((eq TYP "GDL")
                       "GDL-t")
                     ((or (eq TYP "") (eq TYP "   "))
                       "GDL-b")
                     (t TYP))
        STR  (get-siz TL)
        STR  (cond ((eq TYP "GDL-b")
                      "P34-")
                   ((eq TYP "GDL-t")
                      "P10")
                   ((member TYP '("GIL" "GIU" "GEL"))
                      (strcat STR "-"))
                   ((member TYP '("VIU"))
                      (strcat STR "_"))
                   (t STR))
        PCO  (cond ((eq TYP "GDL-b")
                      (get-mat (nth 1 TGA1-LIS)))
                   ((eq TYP "CLI")
                      "0000")
                   (t (get-mat TL)))
        PCO  (cond ((eq PCO "")
                        (get-mat (nth 1 (reverse TGA1-LIS))))
                    (t PCO))
        BRE  (caddr   (assoc STR USER-SIZ-LIS))
        HOJ  (cond ((eq TYP "VIU")
		    (+ 50 (cadddr  (assoc STR USER-SIZ-LIS))))
		   (t (cadddr  (assoc STR USER-SIZ-LIS))))))
;==============================================================================
(DeFun ins-3d (NR INS-P DCH AFS TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS
              / D-X D-Y A-X A-Y Z ZN NL LN IP PP N SS
                ROLLER ST SS-D SSS SS-F SS-S SS-V TY SS1 SS2 IPL)
  (if paucheck (progn (princ "\nins-3d")
                      (princ (list NR INS-P DCH AFS TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS))))
  (setq D-X  (car (car AFS))
	D-Y  (cadr (car AFS))
	A-X  (caddr (car AFS))
	A-Y  (cadddr (car AFS))
        Z    0
        ZN   (/ (length TGA4-LIS)(length TGA1-LIS))
        ;NL   0
        LN   (/ (length TGA3-LIS)(length TGA1-LIS))
	IP   INS-P
        PP   INS-P
	N    0
	SS-D (ssadd)
	SS   (ssadd))
  (repeat (1+ A-Y)
    (repeat A-X
      (get-data (nth N TGA1-LIS))
      (if (and (eq N 0)(member NR '(8)))
        (setq IP (list (car IP)(- (cadr IP) HOJ -42.5)(- (caddr IP) 0))
	      PP IP))
      (if (and (eq N 0)(member NR '(6)))
        (setq IP (list (car IP)(- (cadr IP) HOJ)(caddr IP))
	      PP IP))
      (setq ROLLER nil
	    ST   STR
            BT   (cond ((member TYP '("GIL" "GIU" "GDL-b")) "top")
                       ((member NR '(5 7)) "bot")
                       ((and (eq N 0) (member NR '(6 8))) "topbot")
                       ((and (> N 0) (member NR '(6 8))) "bot")
                       (t ""))
            SS-D (i-3d-0 SS-D IP TYP STR BRE HOJ PCO 0 DCH
                         (get-typ (car TGA3-LIS)) BT INS-P)
            SSS  (i-3d-1 SS-F SS-S SS-V IP TYP STR BRE HOJ PCO 0)
            SS-F (car SSS)
            SS-S (cadr SSS)
            SS-V (caddr SSS) )
;      (if (or (and (not (member NR '(6 8)))
;		   (nth N TGA2-LIS) (not (eq "" (nth N TGA2-LIS))))
;	      (and (member NR '(6 8))(>= N A-X)
;		   (nth (- N A-X) TGA2-LIS) (not (eq "" (nth N TGA2-LIS)))))
      (if (and (or (not (eq "" (car TGA2-LIS)))
		   (member TYP '("GVT" "_GVT" "GVO" "_GVO" "GVA" "_GVA" "VLT" "_VLT")))
	       (not (member TYP '("VFE" "VFA" "VFB" "VIU" "VEA" "VEB" "VEC"))))
	(progn
          (setq TY   (get-typ (car TGA2-LIS))
                TY   (cond ((and (member NR '(5 9))(not (member TYP '("GIL" "GIU" "GIR"))))
                              (strcat TY "-"))
			   ((and (member NR '(7))(member TYP '("GIL" "GIU" "GDL-b")))
                              (strcat TY "-"))
			   ((and (member NR '(7))(not (member TYP '("GIL" "GIU" "GDL-b"))))
                              (strcat TY "+"))
			   ((and (member NR '(10))(member TYP
				'("GVT" "_GVT" "GVO" "_GVO" "GVA" "_GVA" "VLT" "_VLT")))
                              (strcat TYP "+"))
			   (t
                              TY))
                SS-F (i-3d-2 SS-F IP TYP STR BRE HOJ TY PCO N A-X A-Y D-X D-Y))
; exstra flashing for terrasse	  BEGIN
	  (if (member NR '(8))
	    (progn
;*** flashing between ***
              (if (> N A-X)
                (progn
                  (setq EX-LAY (get-lay "flashing")
                        EX-COL (get-col "flashing" PCO TYP))
                  (command "_.3dFACE"
                           IP
                           (list (car IP)
                                 (- (cadr IP)
				    (cadddr (assoc (get-siz (car TGA1-LIS)) USER-SIZ-LIS)))
                                 (caddr IP))
                           (list (- (car IP) D-X)
                                 (- (cadr IP)
				    (cadddr (assoc (get-siz (car TGA1-LIS)) USER-SIZ-LIS)))
                                 (caddr IP))
                           (list (- (car IP) D-X)(cadr IP)(caddr IP))
                           "")
                  (skift (ssadd (entlast)) EX-LAY EX-COL)
                  (do-bl-3 "extra" IP (ssadd (entlast)) 90 t)
                  (setq SS (ssadd (entlast) SS)) ))
;*** flashing on both side ***
	      (if (or (eq N (1- (* A-X (1+ A-Y))))(eq N A-X))
		(progn
                  (setq SS1    (ssadd)
                        EE-    (assoc "EE-" USER-TYP-LIS-3D)
                        EX-SID (cdr (assoc "side" (cdr EE-)))
                        EX-LAY (get-lay "flashing")
                        EX-COL (get-col "flashing" PCO TYP)
			DX     (caddr (assoc (get-siz (car TGA1-LIS)) USER-SIZ-LIS))
                        DY     (/ (* (cadddr (assoc (get-siz (car TGA1-LIS)) USER-SIZ-LIS))
                                     (cos (dtr DCH)))
                                  (sin (dtr DCH)))
		        DZ     (cadddr (assoc (get-siz (car TGA1-LIS)) USER-SIZ-LIS))
                        HH     (+ 1363 (/ (cadddr (assoc (get-siz (car TGA1-LIS)) USER-SIZ-LIS))
                                          (sin (dtr DCH)))) )
		  (if (eq N A-X)
		    (setq P3     (list (car IP)
				       (- (cadr IP) DY 16.26 42.5)
				       (- (caddr IP) DZ -65.67))
                          SS1    (psl-tegn SS1 P3 EX-SID HH EX-LAY EX-COL) ))
		  (if (eq N (1- (* A-X (1+ A-Y))))
                    (setq P3     (list (+ (car IP) DX)
			  	       (- (cadr IP) DY 16.26 42.5)
				       (- (caddr IP) DZ -65.67))
                          SS1    (psr-tegn SS1 P3 EX-SID HH EX-LAY EX-COL) ))
                  (do-bl-3 "extra" P3 SS1 DCH t)
                  (setq SS (ssadd (entlast) SS)) )) )) ))
      
; exstra flashing for terrasse	  END
      (setq TB (cond ((and (>= N A-X)(member NR '(6 7 8)))
		        "-bot")
	             ((member NR '(6 7))
		        "-top")
	             ((member NR '(8))
		        "-topbot")
	             (t ""))
	    IPL (cond ((and (>= N A-X)(member NR '(8)))
		         (list (car IP)(cadr IP)(+ (caddr IP) 27)))
		      ((and (< N A-X)(member NR '(8)))
		         (list (car IP)(cadr IP)(+ (caddr IP) -28)))
		      (t IP)))
      ;(repeat LN
      ;  (if (and (nth NL TGA3-LIS)
;		 (not (eq "" (nth NL TGA3-LIS)))
;		 (not (member (get-typ (nth NL TGA3-LIS)) '("BBX"))))
   ;       (setq SS-F (i-3d-3 SS-F IPL TYP STR BRE HOJ DCH TGA3-LIS TB AFS)))
 ;       (setq NL (1+ NL));)
      
      (if (> (length TGA3-LIS) 0)
        (setq SS-F (i-3d-3 SS-F IPL TYP STR BRE HOJ DCH TGA3-LIS TB AFS)))
      (repeat ZN
        (if (and (nth Z TGA4-LIS) (not (eq "" (nth Z TGA4-LIS))) )
         (progn
           (setq TY (get-typ (nth Z TGA4-LIS))
                 SSS (i-3d-4 SS-F SS-S IP TYP STR BRE HOJ TY PCO)
                 SS-F (car SSS)
                 SS-S (cadr SSS) )
           (if (member TY '("SCL" "SML" "SSL" "SMG")) (setq ROLLER t)) ))
         (setq Z (1+ Z)))
      (if (and (< N A-X)(member NR '(6 8)))
	(progn
	   (setq SS1 (do-block-3 SS1 IP SS-F SS-S SS-V TYP STR ROLLER DCH))
           (if USER-ROT (rot-3d-do SS1 INS-P 90 t))
	   (setq SS  (ss-add SS SS1))	  )
	(progn
	   (setq SS2 (do-block-3 SS2 IP SS-F SS-S SS-V TYP STR ROLLER DCH))
           (if USER-ROT (rot-3d-do SS2 INS-P DCH t))
	   (setq SS  (ss-add SS SS2))	  ))
      
      (setq N  (1+ N)
            IP (list (+ (car IP) (caddr (assoc STR USER-SIZ-LIS)) (caar AFS))
                     (cadr IP) (caddr IP))
      ) )
   (setq PP (list (car PP)
		  (+ (cadr PP) (cadddr (assoc ST USER-SIZ-LIS)) (cadar AFS))
                  (caddr PP))
	 IP PP))
  (if (eq USER-IP "top")
    (progn
      (setq IP (list (car IP)(- (cadr IP) (cadar AFS))(caddr IP)))
      (command "_.point" IP)
      (if USER-ROT (rot-3d-do (entlast) INS-P DCH t))
      (setq IP (cdr (assoc 10 (entget(entlast)))))
      (command "_.move" SS-D "" IP INS-P)
      (setq SS (ssadd (entlast) SS)) ))
  (if (> (sslength SS-D) 0)
    (list SS SS-D)
    (list SS)))
;==============================================================================
;==============================================================================

;==============================================================================
;*************************************************************************
;    E N D
;*************************************************************************
