; ***************************************************************************
;==============================================================================
;;;
;;; VELUX-3d.LSP
;;; PAUsoft (+45 46 18 59 85)
;;;
;==============================================================================
; ***************************************************************************
; *                                                                         *
; *  VELUX-3.LSP                                    User   VELUX            *
; *                                                                         *
; *  Version   1.00 for R2000                       Author  PAU-SOFT        *
; *                                                                         *
; *                                                                         *
; *  Functions defined and used by this program:                            *
; *                                                                         *
; *     get-3d-l                                                            *
; *     get-gir                                                             *
; *                                                                         *
; *     get-lay-x                                                           *
; *     get-lay                                                             *
; *     get-col                                                             *
; *                                                                         *
; *  Global variables:                                                      *
; *                                                                         *
; *     USER-TYP-LIS-3D                                                     *
; *                                                                         *
; *  Call by :                                                              *
; *                                                                         *
; *     velux-3.lsp                                                         *
; *                                                                         *
; *  Revision :                                                             *
; *                                                                         *
; ***************************************************************************

;*************************************************************************
;*************************************************************************
;    V E L U X         DANNELSE AF 3D VINDUE
;*************************************************************************
;============================================================================
(defun get-3d-l (TYP STR / TY 3D-L)
  (if paucheck (progn (princ "\nget-3d-l  ")(princ (list TYP STR))))
  (if USER-TYP-LIS-3D
    (setq TY
      (cond ((member TYP '("_GGL" "_GGL_"))    "_GGL")
            ((member TYP '("_GZL" "_GZL_"))    "_GZL")
            ((member TYP '("_GHL"))            "_GHL")
            ((member TYP '("GVT" "_GVT"))      "GVT")
            ((member TYP '("GVO" "_GVO"))      "GVO")
            ((member TYP '("GVA" "VLT"
			   "_GVA" "_VLT"))     "GVA")
	    
            ((member TYP '("CLI"))             "CLI")
            ((member TYP '("GGL" "GGU" "cGGL"
                           "sGGL" "eGGL" "eGGU"
			   "bGGL" "bGGU"))     "GGL")
            ((member TYP '("G62" "G64"))       "G62")
            ((member TYP '("GZL"))             "GGL")
            ((member TYP '("GHL" "dGHL" ))     "GHL")
            ((member TYP '("GPL" "dGPL" "GPU" "dGPU"
			   "cGPL"))            "GPL")
            ((member TYP '("GXL"))             "GXL")
            ((member TYP '("GTL" "GTU"))       "GTL")
            ((member TYP '("GIL" "GIU"))       "GIL")
            ((member TYP '("VIU"))             "VIU") ; giu variant
            ((member TYP '("VFE"))             "VFE")
            ((member TYP '("VFA" "VFB"))       "VFA")
            ((member TYP '("GEL"))             "GEL")
            ((member TYP '("VEC"))             "VEC")
            ((member TYP '("VEA" "VEB"))       "VEA")
            ((member TYP '("GIR"))             "GIR")
            ((member TYP '("GDL" "GDL-t"))     "GDL-t")
            ((member TYP '("   " "GDL-b"))     "GDL-b")

            ((member TYP '("EDS" "EKS"))             "EDS")
            ((member TYP '("EDL" "EKL"))             "EDL")
            ((member TYP '("EDH" "EKH"))             "EDH")
            ((member TYP '("EDW" "EKW"))             "EDW")
            ((member TYP '("EDE" "EDZ" "EKE" "EKX")) "EDE")
            ((member TYP '("EDJ"))                   "EDJ")
            ((member TYP '("EDN"))                   "EDN")
            ((member TYP '("ETW" "ETS" "ETL" "ETE")) "ETW")
            ((member TYP '("ETW-" "ETS-" "ETL-" "ETE-"))
                                                     "ETW-")
            ((member TYP '("EFS" "EFW" "EFL" "EFE"
                           "EES" "EEW" "EEL"))       "EFS")
            ((member TYP '("EBS" "EBL" "EBE" "EBH" "EBW"))
                                                     "EBY")
            ((member TYP '("EKW-" "EKS-" "EKL-" "EKE-" "EDE-"
                           "EDW-" "EDS-" "EDL-"))    "EKW-")
            ((member TYP '("EKW+" "EKS+" "EKL+" "EKE+" "EDE+"
                           "EDW+" "EDS+" "EDL+"))    "EKW+")
            ((member TYP '("GVT+" "_GVT+"))          "GVT+")
            ((member TYP '("GVO+" "_GVO+"))          "GVO+")
            ((member TYP '("GVA+" "_GVA+" "VLT+" "_VLT+"))
	                                                "GVA+")
	    
            ((member TYP '("LGI"))                   "LGI")
            ((member TYP '("LSC" "LSB" "LSD"))       "LSC")
            ((member TYP '("LLC" "LLB" "LLD" "LVI")) "LLC")
            ((member TYP '("LFI"))                   "LFI")
            ((member TYP '("LEI"))                   "LEI")
            ((member TYP '("LXI"))                   "LXI")
            ((member TYP '("LEX"))                   "LXI")

            ((member TYP '("MHL" "MAL"))       "MAL")
            ((member TYP '("MML"))             "MML")
            ;((member TYP '("SCL"))             "SCL")
            ((member TYP '("SML" "SCL" "SSL"))       "SML")
            ((and (member TYP '("SMG"))
		  (member STR '("M31-" "M34-" "M36-" "M38-" "P31-" "P34-" "P36-" "P38-"
				"S31-" "S34-" "S36-" "S38-" "U31-" "U34-" "U36-" "U38-")))
	                                             "SMG-b")
            ((member TYP '("SMG"))                   "SMG-t")
            ((member TYP '("FYL" "FKL" "FPL")) "FYL")
            ((member TYP '("FHL" "FML" "FHU"))       "FHL")
            ((member TYP '("PAL" "PBL" "PML"
                           "PAU" "PBU" "PMU")) "PAL")
            ((member TYP '("RHL" "RLL" "RML" "RNL" "RPL"
			   "RFU" "RFL" "RGL" "RLG")) "RHL")
            ((member TYP '("DKL" "DGL" "DML" "DKU")) "DKL")
            ((member TYP '("MIE")) "---")
            ((member TYP '("ZIL")) "---")
            ((member TYP '("ZGL")) "---")
            ((member TYP '("SFL")) "---")

            (t nil)) ))

  (cond ((not TY)
          (alert (strcat "error\nNo type:\n " TYP))
          (setq 3D-L nil))
        ((eq TY "---")
          (setq 3D-L nil))
        (t
          (setq 3D-L (assoc TY USER-TYP-LIS-3D)
                3D-L (cond ((not STR)
                              (cdr 3D-L))
                           ((member STR '("---" "___"))
                              (assoc "small" (cdr 3D-L)))
                           ((and (eq "_" (substr TY 1 1))
				 (member (substr STR 1 1) '("1" "2")))
                              (assoc "small" (cdr 3D-L)))
                           ((not (member (substr STR 1 1) '("1" "2")))
                              (assoc "big" (cdr 3D-L)))
                           (t (assoc "big" (cdr 3D-L)))) )))
  (if paucheck (progn (princ "\t") (princ 3d-l)))
  3D-L)
;============================================================================
(defun get-gir (STR)
  (if paucheck (progn (princ "\nget-gir")(princ STR)))
  (cond ((eq STR "...")
          (list 990 721 (dtr 31.3827) (dtr 73.3008) ))
        ((eq STR "M50")
          (list 390.6 201.0 (dtr 173.9) (dtr  3.1) ))
        ((eq STR "P50")
          (list 470.0  95.5 (dtr 181.0) (dtr -0.6) ))
        ((eq STR "S50")
          (list 570.8  30.0 (dtr 173.8) (dtr  3.1) ))
        ((eq STR "U50")
          (list 685.7  30.0 (dtr 155.5) (dtr 12.3) ))
        (t
          (list 100.0   0.0 (dtr 180.0) (dtr  0.0) ))) )
;============================================================================
;============================================================================
(defun get-lay-x (TY)
  (cond ((eq TY "glass")        "GLASS")       ; USER-LF)
        ((eq TY "prot-glass")   "GLASS")       ; USER-LF)
        ((eq TY "frame")        "FRAME")       ; USER-LP)
        ((eq TY "frame-metal")  "FRAME-METAL") ; USER-LM)
        ((eq TY "sash")         "SASH")        ; USER-LP)
        ((eq TY "sash-metal")   "SASH-METAL")  ; USER-LM)
        ((eq TY "rail-metal")   "RAIL-METAL")  ; USER-LM)
        ((eq TY "ventil-top")   "SASH-VENT")   ; USER-LP)
        ((eq TY "ventil-grip")  "VENT-GRIP")   ; USER-LP)
        ((eq TY "ventil-gbox")  "VENT-GRIP")   ; USER-LP)
        ((eq TY "prot-grip")    "VENT-GRIP")   ; USER-LP)
        ((eq TY "grip")         "VENT-GRIP")   ; USER-LP)
        ((eq TY "flashing")     "FLASH")       ; USER-LE)
        ((eq TY "extension")    "EXTENSION")   ; USER-LI)
        ((eq TY "lining")       "LINING")      ; USER-LI)
        ((eq TY "accessories")  "ACCESSOR")    ; USER-LZ)
        ((eq TY "red-line")     "RED-LINE")
        ((eq TY "dum-solid")    "DUMMY-SOLID")
        (t "VELUX")))
;============================================================================
(defun get-lay (TY)
  (cond ((eq TY "glass")        USER-L1)
        ((eq TY "prot-glass")   USER-L1)
        ((eq TY "frame")        USER-L2)
        ((eq TY "frame-metal")  USER-L3)
        ((eq TY "sash")         USER-L2)
        ((eq TY "sash-metal")   USER-L3)
        ((eq TY "rail-metal")   USER-L3)
        ((eq TY "ventil-top")   USER-L2)
        ((eq TY "ventil-grip")  USER-L2)
        ((eq TY "ventil-gbox")  USER-L2)
        ((eq TY "prot-grip")    USER-L2)
        ((eq TY "grip")         USER-L2)
        ((eq TY "flashing")     USER-L3)
	((eq TY "bfx")          USER-L4)
        ((eq TY "extension")    USER-L5)
        ((eq TY "lining")       USER-L5)
        ((eq TY "accessories")  USER-L6)
        ((eq TY "red-line")     USER-L7)
        ((eq TY "dum-solid")    USER-L9)
        (t "VELUX")))
;============================================================================
(defun get-col (TY PC TP / CO)
  (if PAUCHECK (progn (princ "\nget-col")(princ (list ty pc tp))))
  (cond ((eq TY "glass")      "141")
        ((eq TY "prot-glass") "142")
        ((eq TY "silver")
           (setq CO (substr PC 2 1))
           (cond ((eq (substr TP 1 1) "_") "254")
	         ((eq CO "0")  "25")
                 ((eq CO "1")  "32")
                 ((eq CO "3")   "9")
                 ((eq CO "8")   "3")
                 (t           "156")))
        ((eq TY "frame")
           (setq CO (substr PC 1 1))
           (cond ((eq TP "GVT") "250")
	         ((eq TP "GVO") "250")
	         ((eq TP "GVA") "250")
	         ((eq TP "VLT") "250")
	         ((eq CO "0")   "7")
                 ((eq CO "2")   "7")
                 ((eq CO "3")  "31")
                 ((eq CO "1")  "31")
                 (t           "156")))
        ((eq TY "frame-metal")
           (setq CO (substr PC 2 1))
           (cond ((eq CO "0")  "25")
                 ((eq CO "1")  "32")
                 ((eq CO "3")   "9")
                 ((eq CO "8")   "3")
                 (t           "156")))
        ((eq TY "sash")
           (setq CO (substr PC 1 1))
           (cond ((eq TP "GVT") "250")
	         ((eq TP "GVO") "250")
	         ((eq TP "GVA") "250")
	         ((eq TP "VLT") "250")
	         ((eq CO "0")   "7")
                 ((eq CO "2")   "7")
                 ((eq CO "3")  "31")
                 ((eq CO "1")  "31")
                 (t           "156")))
        ((eq TY "sash-metal")
           (setq CO (substr PC 2 1))
           (cond ((eq CO "0")  "25")
                 ((eq CO "1")  "32")
                 ((eq CO "3")   "9")
                 ((eq CO "8")   "3")
                 (t           "156")))
        ((eq TY "rail-metal")
           (setq CO (substr PC 2 1))
           (cond ((eq CO "0")  "25")
                 ((eq CO "1")  "25")
                 ((eq CO "3")   "9")
                 ((eq CO "8")   "3")
                 (t           "156")))
        ((eq TY "ventil-top")
           (setq CO (substr PC 1 1))
           (cond ((eq CO "0")   "7")
                 ((eq CO "2")   "7")
                 ((eq CO "3")  "31")
                 ((eq CO "1")  "31")
                 (t           "156")))
        ((eq TY "ventil-grip")
           (setq CO (substr PC 1 1))
           (cond ((eq CO "0")   "7")
                 ((eq CO "2") "254")
                 ((eq CO "3") "254")
                 ((eq CO "1") "254")
                 (t           "156")))
        ((eq TY "ventil-gbox")
           (setq CO (substr PC 1 1))
           (cond ((eq CO "0")   "7")
                 ((eq CO "2") "254")
                 ((eq CO "3") "254")
                 ((eq CO "1") "254")
                 (t           "156")))
        ((eq TY "prot-grip")
           (setq CO (substr PC 1 1))
           (cond ((eq CO "0")   "7")
                 ((eq CO "2") "254")
                 ((eq CO "3") "254")
                 ((eq CO "1") "254")
                 (t           "156")))
        ((eq TY "grip")
           (setq CO (substr PC 1 1))
           (cond ((eq TP "GVT") "250")
	         ((eq TP "GVO") "250")
	         ((eq TP "GVA") "250")
	         ((eq TP "VLT") "250")
	         ((eq CO "0")   "7")
                 ((eq CO "2") "254")
                 ((eq CO "3") "254")
                 ((eq CO "1") "254")
                 (t           "156")))
        ((eq TY "flashing")
           (setq CO (substr PC 2 1))
           (cond ((eq TP "GVT") "250")
	         ((eq TP "GVO") "250")
	         ((eq TP "GVA") "250")
	         ((eq TP "VLT") "250")
	         ((eq CO "0") "25")
                 ((eq CO "1") "32")
                 ((eq CO "3")  "9")
                 ((eq CO "8")  "3")
                 (t          "156")))
        ((eq TY "bfx")           "7")
        ((eq TY "extension")
           (setq CO (substr PC 1 1))
           (cond ((eq CO "0")   "7")
                 ((eq CO "2")   "7")
                 ((eq CO "3")  "31")
                 ((eq CO "1")  "31")
                 (t           "156")))
        ((eq TY "lining")
           (setq CO (substr PC 1 1))
           (cond ((eq CO "0")   "7")
                 ((eq CO "2")   "7")
                 ((eq CO "3")  "31")
                 ((eq CO "1")  "31")
                 (t           "156")))
        ((eq TY "accessories")                  "254")
        ((member TY '("MHL" "MAL"))       "252")
        ((member TY '("SCL" "SML" "SSL" "SMG" "MML"))
           (setq CO (substr PC 2 1))
           (cond ((eq CO "0")                    "25")
                 ((eq CO "1")                    "25")
                 ((eq CO "3")                     "9")
                 ((eq CO "7")                     "9")
                 ((eq CO "8")                    "25")
                 (t                             "156")))
        ((member TY '("FYL" "FKL"))             "252")
        ((member TY '("FHL" "FML"))             "131")
        ((member TY '("PAL" "PBL" "PML"
                      "PAU" "PBU" "PMU"))       "254")
        ((member TY '("RHL" "RLL" "RML" "RNL")) "121")
        ((member TY '("DKL" "DML" "DKU"))       "150")
        ((eq TY "red-line")  "1")
        ((eq TY "dum-solid") "1")
        (t "156")))
;============================================================================
; ***************************************************************************
;============================================================================
;---------------------------------------------------------------------------
(setq USER-TYP-LIS-3D '(

;---------------------------------------------------------------------------
  ("_GHL"  ; GHL GPL GPU
    ("small"
      ("solid"
        ("dxy-bts" (30 30 30))
        ("dz-tbx"  (113 22 82 62))
        ("dwall"   (500  500)) )
      ("glass" ((65 30 94) (130 155) ))
;      ("topcase" ((5 -150 118) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 118)(-150 143)(-20 143)(-20 118)(-150 118))
                 (((-150 118)(-150 143)(-20 143)(-20 118)) ) ) ))
      ("frame"
        ("bottom" 30 (
          ((0 0) ((0 -22)(30 -22)(30 78)(0 78)(0 -22))) ))
        ("top" 30 (
          ((0 0) ((0 -22)(-30 -22)(-30 113)(0 113)(0 -22))) ))
        ("side" 30 (
          ((0 0) ((0 -22)(30 -22)(30 113)(0 113)(0 -22))
                 (((0 -22)(30 -22)(30 113)(0 113))) ) )) )
      ("frame-metal"
        ("bottom" 0 (
          ((0 0) ((-5 48)(-5 83)(30 83))) ))
        ("top" 0 (
          ((0 0) ((1 120)(-20 120))) ))
        ("side" -15 (
          ((0 0) ((-15 48)(-15 119)(30 119))
                 (((-15 83)(-15 119)(30 119)(30 83))) ) ))
        ("sside" 0 (
          ((0 0) ((5 120)(55 120))) )) )
      ("sash"
        ("rot-p" -30 (0 -20 118))
        ("bottom" 85 (
          ((0 0) ((30 34)(85 34)(85 94)(30 94)(30 34))) ))
        ("top" 95 (
          ((0 0) ((-95 34)(-135 34)(-135 94)(-125 94)(-125 108)(-95 108)(-95 34))) ))
        ("toptop" 65 (
          ((0 0) ((-30 34)(-65 34)(-65 118)(-30 118)(-30 34))
                 (((-30 34)(-65 34)(-65 118)(-30 118))) ) ))
        ("sidtop" 65 (
          ((0 0) ((30 34)(65 34)(65 63)(30 63)(30 34))
                 (((30 34)(65 34)(65 63)(30 63))) ) ))
        ("side" 65 (
          ((0 0) ((30 34)(75 34)(75 94)(65 94)(65 113)(30 113)(30 34))
                 (((30 34)(75 34)(75 113)(30 113))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 48)(0 119)(40 119))) ))
        ("top" 0 (
          ((0 0) ((-135 119)(-95 119))) ))
        ("side" 75 (
          ((0 0) ((45 119)(75 119))) ))
        ("sside" 0 (
          ((0 0) ((5 120)(55 120))) )) )
      ("ventil"
        ("rot-p" -55 (0 -110 34))
        ("top" 0 (
          ((0 0) ((-55 14)(-110 14)(-110 34)(-55 34)(-55 14))
                 (((-55 14)(-110 14)(-110 34)(-55 34))) ) ))
        ("grip" 0 (
          ((0 0) ((-62.9229 -14.4565)(-65.5111 -4.7972)(-94.4889 -12.5618)(-91.9007 -22.2210)(-62.9229 -14.4565))
                 (((-62.9229 -14.4565)(-65.5111 -4.7972)(-94.4889 -12.5618)(-91.9007 -22.2210))) ) ))
        ("gbox" 10 (
          ((0 0) ((-70 -6)(-90 -11.3590)(-90 14)(-70 14)(-70 -6))
                 (((-70 -6)(-90 -11.3590)(-90 14)(-70 14)))) )) )
      ("vent" ; GPU
        ("rot-p" -55 (0 -110 34))
        ("top" 0 (
          ((0 0) ((-55 19)(-110 19)(-110 34)(-55 34)(-55 19))
                 (((-55 19)(-110 19)(-110 34)(-55 34))) ) ))
        ("grip" 0 (
          ((0 0) ((-65 -16)(-65 -1)(-95 -1)(-95 -16)(-65 -16)) ) ))
        ("gbx" -11 (
          ((0 0) ((-55 19)(-110 19)(-95 -16)(-65 -16)(-55 19))
                 (((-55 19)(-110 19)(-95 -16)(-65 -16)))) ))
        ("gbox" 45 (
          ((0 0) ((-68 19)(-92 19)(-92 -1)(-68 -1)(-68 19))
                 (((-68 19)(-92 19)(-92 -1)(-68 -1)))) )) )
      ("grip" ;GHL/GPL/GPU
        ("gbox1" 60 (
          ((0 0) ((-12.5 24)(-12.5 34)(12.5 34)(12.5 24)(-12.5 24))
                 (((-12.5 24)(-12.5 34)(12.5 34)(12.5 24))) ) ))
        ("gbox2" 25 (
          ((0 0) ((-12.5 24)(-12.5 -6)(12.5 -6)(12.5 24)(-12.5 24))
                 (((-12.5 24)(-12.5 -6)(12.5 -6)(12.5 24))) ) ))
        ("gbox3" 125 (
          ((0 0) ((-12.5 -16)(-12.5 -6)(12.5 -6)(12.5 -16)(-12.5 -16))
                 (((-12.5 -16)(-12.5 -6)(12.5 -6)(12.5 -16))) ) )) ) )
    ("big"
      ("solid"
        ("dxy-bts" (40 40 40))
        ("dz-tbx"  (113 22 82 62))
        ("dwall"   (500  500)) )
      ("glass" ((80 40 94) (160 175) ))
;      ("topcase" ((15 -150 118) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 118)(-150 143)(-20 143)(-20 118)(-150 118))
                 (((-150 118)(-150 143)(-20 143)(-20 118)) ) ) ))
      ("frame"
        ("bottom" 40 (
          ((0 0) ((0 -22)(40 -22)(40 78)(0 78)(0 -22))) ))
        ("top" 40 (
          ((0 0) ((0 -22)(-40 -22)(-40 113)(0 113)(0 -22))) ))
        ("side" 40 (
          ((0 0) ((0 -22)(40 -22)(40 113)(0 113)(0 -22))
                 (((0 -22)(40 -22)(40 113)(0 113))) ) )) )
      ("frame-metal"
        ("botbot" 0 ( ; VFE VFA VFB
          ((0 0) ((-5 78)(-5 48)(-40 40))) ))
        ("bottom" 0 (
          ((0 0) ((-5 48)(-5 83)(40 83))) ))
        ("top" 0 (
          ((0 0) ((1 120)(-20 120))) ))
        ("side" -5 (
          ((0 0) ((-5 48)(-5 119)(40 119))
                 (((-5 48)(-5 119)(40 119)(40 48)))) ))
        ("sside" 0 (
          ((0 0) ((15 120)(65 120))) )) )
      ("sash"
        ("rot-p" -30 (0 -20 118))
        ("bottom" 100 (
          ((0 0) ((40 34)(100 34)(100 94)(40 94)(40 34))) ))
        ("top" 105 (
          ((0 0) ((-105 34)(-150 34)(-150 94)(-140 94)(-140 108)(-105 108)(-105 34))) ))
        ("toptop" 75 (
          ((0 0) ((-40 34)(-75 34)(-75 118)(-40 118)(-40 34))
                 (((-40 34)(-75 34)(-75 118)(-40 118))) ) ))
        ("sidtop" 75 (
          ((0 0) ((40 34)(75 34)(75 63)(40 63)(40 34))
                 (((40 34)(75 34)(75 63)(40 63))) ) ))
        ("side" 75 (
          ((0 0) ((40 34)(85 34)(85 94)(75 94)(75 113)(40 113)(40 34))
                 (((40 34)(85 34)(85 113)(40 113))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 48)(0 119)(50 119))) ))
        ("top" 0 (
          ((0 0) ((-150 119)(-105 119))) ))
        ("side" 85 (
          ((0 0) ((55 119)(85 119))) ))
        ("sside" 0 (
          ((0 0) ((15 120)(65 120))) )) )
      ("ventil"
        ("rot-p" -55 (0 -120 34))
        ("top" 0 (
          ((0 0) ((-65 14)(-120 14)(-120 34)(-65 34)(-65 14))
                 (((-65 14)(-120 14)(-120 34)(-65 34))) ) ))
        ("grip" 0 (
          ((0 0) ((-72.9229 -14.4565)(-75.5111 -4.7972)(-104.4889 -12.5618)(-101.9007 -22.2210)(-72.9229 -14.4565))
                 (((-72.9229 -14.4565)(-75.5111 -4.7972)(-104.4889 -12.5618)(-101.9007 -22.2210))) ) ))
        ("gbox" 10 (
          ((0 0) ((-80 -6)(-100 -11.3590)(-100 14)(-80 14)(-80 -6))
                 (((-80 -6)(-100 -11.3590)(-100 14)(-80 14))) ) )) )
      ("vent" ; GPU
        ("rot-p" -55 (0 -110 34))
        ("top" 0 (
          ((0 0) ((-55 19)(-110 19)(-110 34)(-55 34)(-55 19))
                 (((-55 19)(-110 19)(-110 34)(-55 34))) ) ))
        ("grip" 0 (
          ((0 0) ((-65 -16)(-65 -1)(-95 -1)(-95 -16)(-65 -16)) ) ))
        ("gbx" -11 (
          ((0 0) ((-55 19)(-110 19)(-95 -16)(-65 -16)(-55 19))
                 (((-55 19)(-110 19)(-95 -16)(-65 -16)))) ))
        ("gbox" 45 (
          ((0 0) ((-68 19)(-92 19)(-92 -1)(-68 -1)(-68 19))
                 (((-68 19)(-92 19)(-92 -1)(-68 -1)))) )) )
      ("grip" ;GHL/GPL/GPU
        ("gbox1" 60 (
          ((0 0) ((-12.5 24)(-12.5 34)(12.5 34)(12.5 24)(-12.5 24))
                 (((-12.5 24)(-12.5 34)(12.5 34)(12.5 24))) ) ))
        ("gbox2" 25 (
          ((0 0) ((-12.5 24)(-12.5 -6)(12.5 -6)(12.5 24)(-12.5 24))
                 (((-12.5 24)(-12.5 -6)(12.5 -6)(12.5 24))) ) ))
        ("gbox3" 125 (
          ((0 0) ((-12.5 -16)(-12.5 -6)(12.5 -6)(12.5 -16)(-12.5 -16))
                 (((-12.5 -16)(-12.5 -6)(12.5 -6)(12.5 -16))) ) )) ) ))
;---------------------------------------------------------------------------
  ("_GGL" ; GGL GGU
    ("small"
      ("solid"
        ("dxy-bts" (30 30 30))
        ("dz-tbx"  (113 22 82 62))
        ("dwall"   (500  500)) )
      ("glass" ((65 30 94) (130 155) ))
;      ("topcase" ((5 -150 118) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 118)(-150 143)(-20 143)(-20 118)(-150 118))
                 (((-150 118)(-150 143)(-20 143)(-20 118)) ) ) ))
      ("frame"
        ("bottom" 30 (
          ((0 0) ((0 -22)(30 -22)(30 78)(0 78)(0 -22))) ))
        ("top" 30 (
          ((0 0) ((0 -22)(-30 -22)(-30 58)(-65 58)(-65 94)(-30 94)(-30 113)(0 113)(0 -22))) ))
        ("side" 30 (
          ((0 0) ((0 -22)(30 -22)(30 113)(0 113)(0 -22))
                 (((0 -22)(30 -22)(30 113)(0 113))) ) )) )
      ("frame-metal"
        ("bottom" 0 (
          ((0 0) ((-5 48)(-5 83)(30 83))) ))
        ("top" 0 (
          ((0 0) ((1 120)(-20 120))) ))
        ("side" -15 (
          ((0 0) ((-15 48)(-15 119)(30 119))
                 (((-15 83)(-15 119)(30 119)(30 83))) ) ))
        ("sside" 0 (
          ((0 0) ((5 120)(55 120))) )) )
      ("sash"
        ("rot-p" -25 (0 0 119))
        ("bottom" 85 (
          ((0 0) ((30 34)(85 34)(85 94)(30 94)(30 34))) ))
        ("top" 95 (
          ((0 0) ((-95 34)(-135 34)(-135 94)(-125 94)(-125 108)(-95 108)(-95 34))) ))
        ("toptop" 65 (
          ((0 0) ((-30 34)(-65 34)(-65 62)(-30 62)(-30 34))) ))
        ("sidtop" 65 (
          ((0 0) ((30 34)(65 34)(65 63)(30 63)(30 34))
                 (((30 34)(65 34)(65 63)(30 63))) ) ))
        ("side" 65 (
          ((0 0) ((30 34)(75 34)(75 94)(65 94)(65 113)(30 113)(30 34))
                 (((30 34)(75 34)(75 113)(30 113))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 48)(0 119)(40 119))) ))
        ("top" 0 (
          ((0 0) ((-135 119)(-95 119))) ))
        ("side" 75 (
          ((0 0) ((45 119)(75 119))) ))
        ("sside" 0 (
          ((0 0) ((5 120)(55 120))) )) )
      ("ventil"
        ("rot-p" -55 (0 -110 34))
        ("top" 0 (
          ((0 0) ((-55 14)(-110 14)(-110 34)(-55 34)(-55 14))
                 (((-55 14)(-110 14)(-110 34)(-55 34))) ) ))
        ("grip" 0 (
          ((0 0) ((-62.9229 -14.4565)(-65.5111 -4.7972)(-94.4889 -12.5618)(-91.9007 -22.2210)(-62.9229 -14.4565))
                 (((-62.9229 -14.4565)(-65.5111 -4.7972)(-94.4889 -12.5618)(-91.9007 -22.2210))) ) ))
        ("gbox" 10 (
          ((0 0) ((-70 -6)(-90 -11.3590)(-90 14)(-70 14)(-70 -6))
                 (((-70 -6)(-90 -11.3590)(-90 14)(-70 14)))) )) )
      ("vent" ; GGU
        ("rot-p" -55 (0 -110 34))
        ("top" 0 (
          ((0 0) ((-55 19)(-110 19)(-110 34)(-55 34)(-55 19))
                 (((-55 19)(-110 19)(-110 34)(-55 34))) ) ))
        ("grip" 0 (
          ((0 0) ((-65 -16)(-65 -1)(-95 -1)(-95 -16)(-65 -16)) ) ))
        ("gbx" -11 (
          ((0 0) ((-55 19)(-110 19)(-95 -16)(-65 -16)(-55 19))
                 (((-55 19)(-110 19)(-95 -16)(-65 -16)))) ))
        ("gbox" 45 (
          ((0 0) ((-68 19)(-92 19)(-92 -1)(-68 -1)(-68 19))
                 (((-68 19)(-92 19)(-92 -1)(-68 -1)))) )) ) )
    ("big"
      ("solid"
        ("dxy-bts" (40 40 40))
        ("dz-tbx"  (113 22 82 62))
        ("dwall"   (500  500)) )
      ("glass" ((80 40 94) (160 175) ))
;      ("topcase" ((15 -150 118) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 118)(-150 143)(-20 143)(-20 118)(-150 118))
                 (((-150 118)(-150 143)(-20 143)(-20 118)) ) ) ))
      ("frame"
        ("bottom" 40 (
          ((0 0) ((0 -22)(40 -22)(40 78)(0 78)(0 -22))) ))
        ("top" 40 (
          ((0 0) ((0 -22)(-40 -22)(-40 58)(-75 58)(-75 94)(-40 94)(-40 113)(0 113)(0 -22))) ))
        ("side" 40 (
          ((0 0) ((0 -22)(40 -22)(40 113)(0 113)(0 -22))
                 (((0 -22)(40 -22)(40 113)(0 113))) ) )) )
      ("frame-metal"
        ("botbot" 0 ( ; VFE VFA VFB
          ((0 0) ((-5 78)(-5 48)(-40 40))) ))
        ("bottom" 0 (
          ((0 0) ((-5 48)(-5 83)(40 83))) ))
        ("top" 0 (
          ((0 0) ((1 120)(-20 120))) ))
        ("side" -5 (
          ((0 0) ((-5 48)(-5 119)(40 119))
                 (((-5 48)(-5 119)(40 119)(40 48))) ) ))
        ("sside" 0 (
          ((0 0) ((15 119)(65 119))) )) )
      ("sash"
        ("rot-p" -25 (0 0 119))
        ("bottom" 100 (
          ((0 0) ((40 34)(100 34)(100 94)(40 94)(40 34))) ))
        ("top" 105 (
          ((0 0) ((-105 34)(-150 34)(-150 94)(-140 94)(-140 108)(-105 108)(-105 34))) ))
        ("toptop" 75 (
          ((0 0) ((-40 34)(-75 34)(-75 62)(-40 62)(-40 34))) ))
        ("sidtop" 75 (
          ((0 0) ((40 34)(75 34)(75 63)(40 63)(40 34))
                 (((40 34)(75 34)(75 63)(40 63))) ) ))
        ("side" 75 (
          ((0 0) ((40 34)(85 34)(85 94)(75 94)(75 113)(40 113)(40 34))
                 (((40 34)(85 34)(85 113)(40 113))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 48)(0 119)(50 119))) ))
        ("top" 0 (
          ((0 0) ((-150 119)(-105 119))) ))
        ("side" 85 (
          ((0 0) ((55 119)(85 119))) ))
        ("sside" 0 (
          ((0 0) ((15 120)(65 120))) )) )
      ("ventil"
        ("rot-p" -55 (0 -120 34))
        ("top" 0 (
          ((0 0) ((-65 14)(-120 14)(-120 34)(-65 34)(-65 14))
                 (((-65 14)(-120 14)(-120 34)(-65 34))) ) ))
        ("grip" 0 (
          ((0 0) ((-72.9229 -14.4565)(-75.5111 -4.7972)(-104.4889 -12.5618)(-101.9007 -22.2210)(-72.9229 -14.4565))
                 (((-72.9229 -14.4565)(-75.5111 -4.7972)(-104.4889 -12.5618)(-101.9007 -22.2210))) ) ))
        ("gbox" 10 (
          ((0 0) ((-80 -6)(-100 -11.3590)(-100 14)(-80 14)(-80 -6))
                 (((-80 -6)(-100 -11.3590)(-100 14)(-80 14))) ) )) )
      ("vent" ; GGU
        ("rot-p" -55 (0 -110 34))
        ("top" 0 (
          ((0 0) ((-55 19)(-110 19)(-110 34)(-55 34)(-55 19))
                 (((-55 19)(-110 19)(-110 34)(-55 34))) ) ))
        ("grip" 0 (
          ((0 0) ((-65 -16)(-65 -1)(-95 -1)(-95 -16)(-65 -16)) ) ))
        ("gbx" -11 (
          ((0 0) ((-55 19)(-110 19)(-95 -16)(-65 -16)(-55 19))
                 (((-55 19)(-110 19)(-95 -16)(-65 -16)))) ))
        ("gbox" 45 (
          ((0 0) ((-68 19)(-92 19)(-92 -1)(-68 -1)(-68 19))
                 (((-68 19)(-92 19)(-92 -1)(-68 -1)))) )) ) ))
;---------------------------------------------------------------------------
  ("_GZL" ; GZL
    ("small"
      ("solid"
        ("dxy-bts" (30 30 30))
        ("dz-tbx"  (113 22 82 62))
        ("dwall"   (500  500)) )
      ("glass" ((65 30 94) (130 155) ))
;      ("topcase" ((5 -150 118) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 118)(-150 143)(-20 143)(-20 118)(-150 118))
                 (((-150 118)(-150 143)(-20 143)(-20 118)) ) ) ))
      ("frame"
        ("bottom" 30 (
          ((0 0) ((0 -22)(30 -22)(30 78)(0 78)(0 -22))) ))
        ("top" 30 (
          ((0 0) ((0 -22)(-30 -22)(-30 58)(-65 58)(-65 94)(-30 94)(-30 113)(0 113)(0 -22))) ))
        ("side" 30 (
          ((0 0) ((0 -22)(30 -22)(30 113)(0 113)(0 -22))
                 (((0 -22)(30 -22)(30 113)(0 113))) ) )) )
      ("frame-metal"
        ("bottom" 0 (
          ((0 0) ((-5 48)(-5 83)(30 83))) ))
        ("top" 0 (
          ((0 0) ((1 120)(-20 120))) ))
        ("side" -15 (
          ((0 0) ((-15 48)(-15 119)(30 119))
                 (((-15 83)(-15 119)(30 119)(30 83))) ) ))
        ("sside" 0 (
          ((0 0) ((5 120)(55 120))) )) )
      ("sash"
        ("rot-p" -25 (0 0 119))
        ("bottom" 85 (
          ((0 0) ((30 34)(85 34)(85 94)(30 94)(30 34))) ))
        ("top" 95 (
          ((0 0) ((-95 34)(-135 34)(-135 94)(-125 94)(-125 108)(-95 108)(-95 34))) ))
        ("toptop" 65 (
          ((0 0) ((-30 34)(-95 34)(-95 63)(-30 63)(-30 34))) ))
        ("sidtop" 65 (
          ((0 0) ((30 34)(65 34)(65 63)(30 63)(30 34))
                 (((30 34)(65 34)(65 63)(30 63))) ) ))
        ("side" 65 (
          ((0 0) ((30 34)(75 34)(75 94)(65 94)(65 113)(30 113)(30 34))
                 (((30 34)(75 34)(75 113)(30 113))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 48)(0 119)(40 119))) ))
        ("top" 0 (
          ((0 0) ((-135 119)(-95 119))) ))
        ("side" 75 (
          ((0 0) ((45 119)(75 119))) ))
        ("sside" 0 (
          ((0 0) ((5 120)(55 120))) )) )
      ("ventil"
        ("rot-p" 0 (0 -103 34))
        ("grip" 0 (
          ((0 0) ((-67 -16)(-100 -16)(-100 -6)(-93 -6)(-93 3)(-73 3)(-73 -6)(-67 -6)(-67 -16))
                 (((-67 -16)(-100 -16)(-100 -6)(-67 -6))
		  ((-93 -6)(-93 3)(-73 3)(-73 -6))) ) ))
        ("gbox" 20 (
          ((0 0) ((-30 34)(-103 34)(-103 24)(-100 -6)(-93 -6)(-93 -6)
		  (-93 3)(-73 3)(-73 -6)(-67 -6)(-67 -14)(-46 2)(-46 8)
		  (-36 8)(-36 2)(-30 2)(-30 34))
                 (((-30 34)(-103 34)(-103 24)(-30 24))
		  ((-30 2)(-36 2)(-36 24)(-30 24))
		  ((-103 24)(-100 -6)(-93 -6)(-93 24))
		  ((-93 3)(-73 3)(-73 24)(-93 24))
		  ((-73 -6)(-67 -6)(-67 24)(-73 24))
		  ((-67 -14)(-46 2)(-46 24)(-67 24))
		  ((-46 8)(-36 8)(-36 24)(-46 24))) ) )) ) )
   ("big"
      ("solid"
        ("dxy-bts" (40 40 40))
        ("dz-tbx"  (113 22 82 62))
        ("dwall"   (500  500)) )
      ("glass" ((80 40 94) (160 175) ))
;      ("topcase" ((15 -150 118) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 118)(-150 143)(-20 143)(-20 118)(-150 118))
                 (((-150 118)(-150 143)(-20 143)(-20 118)) ) ) ))
      ("frame"
        ("bottom" 40 (
          ((0 0) ((0 -22)(40 -22)(40 78)(0 78)(0 -22))) ))
        ("top" 40 (
          ((0 0) ((0 -22)(-40 -22)(-40 58)(-75 58)(-75 94)(-40 94)(-40 113)(0 113)(0 -22))) ))
        ("side" 40 (
          ((0 0) ((0 -22)(40 -22)(40 113)(0 113)(0 -22))
                 (((0 -22)(40 -22)(40 113)(0 113))) ) )) )
      ("frame-metal"
        ("botbot" 0 ( ; VFE VFA VFB
          ((0 0) ((-5 78)(-5 48)(-40 40))) ))
        ("bottom" 0 (
          ((0 0) ((-5 48)(-5 83)(40 83))) ))
        ("top" 0 (
          ((0 0) ((1 120)(-20 120))) ))
        ("side" -5 (
          ((0 0) ((-5 48)(-5 119)(40 119))
                 (((-5 48)(-5 119)(40 119)(40 48))) ) ))
        ("sside" 0 (
          ((0 0) ((15 119)(65 119))) )) )
      ("sash"
        ("rot-p" -25 (0 0 119))
        ("bottom" 100 (
          ((0 0) ((40 34)(100 34)(100 94)(40 94)(40 34))) ))
        ("top" 105 (
          ((0 0) ((-105 34)(-150 34)(-150 94)(-140 94)(-140 108)(-105 108)(-105 34))) ))
        ("toptop" 75 (
          ((0 0) ((-40 34)(-105 34)(-105 63)(-40 63)(-40 34))) ))
        ("sidtop" 75 (
          ((0 0) ((40 34)(75 34)(75 63)(40 63)(40 34))
                 (((40 34)(75 34)(75 63)(40 63))) ) ))
        ("side" 75 (
          ((0 0) ((40 34)(85 34)(85 94)(75 94)(75 113)(40 113)(40 34))
                 (((40 34)(85 34)(85 113)(40 113))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 48)(0 119)(50 119))) ))
        ("top" 0 (
          ((0 0) ((-150 119)(-105 119))) ))
        ("side" 85 (
          ((0 0) ((55 119)(85 119))) ))
        ("sside" 0 (
          ((0 0) ((15 120)(65 120))) )) )
      ("ventil"
        ("rot-p" -40 (0 -113 34))
        ("grip" 0 (
          ((0 0) ((-77 -16)(-110 -16)(-110 -6)(-103 -6)(-103 3)(-83 3)(-83 -6)(-77 -6)(-77 -16))
                 (((-77 -16)(-110 -16)(-110 -6)(-77 -6))
		  ((-103 -6)(-103 3)(-83 3)(-83 -6))) ) ))
        ("gbox" 20 (
          ((0 0) ((-40 34)(-113 34)(-113 24)(-110 -6)(-103 -6)(-103 -6)
		  (-103 3)(-83 3)(-83 -6)(-77 -6)(-77 -14)(-56 2)(-56 8)
		  (-46 8)(-46 2)(-40 2)(-40 34))
                 (((-40 34)(-113 34)(-113 24)(-40 24))
		  ((-40 2)(-46 2)(-46 24)(-40 24))
		  ((-113 24)(-110 -6)(-103 -6)(-103 24))
		  ((-103 3)(-83 3)(-83 24)(-103 24))
		  ((-83 -6)(-77 -6)(-77 24)(-83 24))
		  ((-77 -14)(-56 2)(-56 24)(-77 24))
		  ((-56 8)(-46 8)(-46 24)(-56 24))
		  ) ) )) ) ))
;---------------------------------------------------------------------------



			
  ("CLI"
    ("big"
       ;("solid"
       ; ("dxy-bts" (40 40 40))
       ; ("dz-tbx"  (86 49 82 62))
       ; ("dwall"   (500  500)) )
      ("glass" ((80 40 67) (160 175) ))
;      ("topcase" ((15 -150 91) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 91)(-150 116)(-69 116)(-32.61 108.34)(-31 116)(-20 116)(-20 91)(-150 91))
                 (((-150 91)(-150 116)(-69 116)(-69 91))
                  ((-69 91)(-69 116)(-32.61 108.34)(-20 91))
                  ((-32.61 108.34)(-31 116)(-20 116)(-20 91)) ) ) ))
      ("frame"
        ("bottom" 40 (
          ((0 0) ((0 -49)(40 -49)(40 51)(0 51)(0 -49))) ))
        ("top" 40 (
          ((0 0) ((0 -49)(-40 -49)(-40 31)(-75 31)(-75 67)(-40 67)(-40 86)(0 86)(0 -49))) ))
        ("side" 40 (
          ((0 0) ((0 -49)(40 -49)(40 86)(0 86)(0 -49))
                 (((0 -49)(40 -49)(40 86)(0 86))) ) )) )
      ("frame-metal"
        ("botbot" 0 (
          ((0 0) ((-5 51)(-5 21)(-40 13))) ))
        ("bottom" 0 (
          ((0 0) ((-5 21)(-5 56)(40 56))) ))
        ("top" 0 (
          ((0 0) ((1 93)(-20 93))) ))
        ("side" -5 (
          ((0 0) ((-5 21)(-5 92)(40 92))
                 (((-5 21)(-5 92)(40 92)(40 21))) ) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("sash"
        ("rot-p" 0 (0 0 92))
        ("bottom" 100 (
          ((0 0) ((40 7)(100 7)(100 67)(40 67)(40 7))) ))
        ("top" 105 (
          ((0 0) ((-105 7)(-150 7)(-150 67)(-140 67)(-140 81)(-105 81)(-105 7))) ))
        ("toptop" 75 (
          ((0 0) ((-40 7)(-75 7)(-75 35)(-40 35)(-40 7))) ))
        ("sidtop" 75 (
          ((0 0) ((40 7)(75 7)(75 36)(40 36)(40 7))
                 (((40 7)(75 7)(75 36)(40 36))) ) ))
        ("side" 75 (
          ((0 0) ((40 7)(85 7)(85 67)(75 67)(75 86)(40 86)(40 7))
                 (((40 7)(85 7)(85 86)(40 86))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 21)(0 92)(50 92))) ))
        ("top" 0 (
          ((0 0) ((-150 92)(-105 92))) ))
        ("side" 85 (
          ((0 0) ((55 92)(85 92))) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ))
;---------------------------------------------------------------------------
  ("GGL" ; GGL GGU
    ("big"
       ("solid"
        ("dxy-bts" (40 40 40))
        ("dz-tbx"  (86 49 109 62))
        ("dwall"   (500  500)) )
      ("glass" ((80 40 67) (160 175) ))
;      ("topcase" ((15 -150 91) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 91)(-150 116)(-69 116)(-32.61 108.34)(-31 116)(-20 116)(-20 91)(-150 91))
                 (((-150 91)(-150 116)(-69 116)(-69 91))
                  ((-69 91)(-69 116)(-32.61 108.34)(-20 91))
                  ((-32.61 108.34)(-31 116)(-20 116)(-20 91)) ) ) ))
      ("frame"
        ("bottom" 40 (
          ((0 0) ((0 -49)(40 -49)(40 51)(0 51)(0 -49))) ))
        ("top" 40 (
          ((0 0) ((0 -49)(-40 -49)(-40 31)(-75 31)(-75 67)(-40 67)(-40 86)(0 86)(0 -49))) ))
        ("side" 40 (
          ((0 0) ((0 -49)(40 -49)(40 86)(0 86)(0 -49))
                 (((0 -49)(40 -49)(40 86)(0 86))) ) )) )
      ("frame-metal"
        ("botbot" 0 ( ; VFE VFA VFB
          ((0 0) ((-5 51)(-5 21)(-40 13))) ))
        ("bottom" 0 (
          ((0 0) ((-5 21)(-5 56)(40 56))) ))
        ("top" 0 (
          ((0 0) ((1 93)(-20 93))) ))
        ;("side" -5 (
        ;  ((0 0) ((-5 21)(-5 92)(40 92))
        ;         (((-5 21)(-5 92)(40 92)(40 21))) ) ))
        ("side" -5 (
          ((0 0) ((-5 21)(-5 92)(40 92))
                  ) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("sash"
        ("rot-p" -25 (0 0 92))
        ("bottom" 100 (
          ((0 0) ((40 7)(100 7)(100 67)(40 67)(40 7))) ))
        ("top" 105 (
          ((0 0) ((-105 7)(-150 7)(-150 67)(-140 67)(-140 81)(-105 81)(-105 7))) ))
        ("toptop" 75 (
          ((0 0) ((-40 7)(-75 7)(-75 35)(-40 35)(-40 7))) ))
        ("sidtop" 75 (
          ((0 0) ((40 7)(75 7)(75 36)(40 36)(40 7))
                 (((40 7)(75 7)(75 36)(40 36))) ) ))
        ("side" 75 (
          ((0 0) ((40 7)(85 7)(85 67)(75 67)(75 86)(40 86)(40 7))
                 (((40 7)(85 7)(85 86)(40 86))) ) )) )
      ("sash-metal"
        ("botbot" 0 (
          ((0 0) ((-6 21)(-6 92))) ))
        ("bottom" 0 (
          ((0 0) ((-6 21)(-6 92)(50 92))) ))
        ("top" 0 (
          ((0 0) ((-150 92)(-105 92))) ))
        ("side" 85 (
          ((0 0) ((55 92)(85 92))) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("ventil"
        ("rot-p" -55 (0 -120 7))
        ("top" 0 (
          ((0 0) ((-65 -13)(-120 -13)(-120 7)(-65 7)(-65 -13))
                 (((-65 -13)(-120 -13)(-120 7)(-65 7))) ) ))
        ("grip" 0 (
          ((0 0) ((-75 -48)(-75 -38)(-105 -38)(-105 -48)(-75 -48))
                 (((-75 -48)(-75 -38)(-105 -38)(-105 -48))) ) ))
        ("gbox" 10 (
          ((0 0) ((-80 -38)(-100 -38)(-100 -13)(-80 -13)(-80 -38))
                 (((-80 -38)(-100 -38)(-100 -13)(-80 -13))) ) )) )
      ("vent" ; GGU
        ("rot-p" -55 (0 -110 7))
        ("top" 0 (
          ((0 0) ((-55 -8)(-110 -8)(-110 7)(-55 7)(-55 -8))
                 (((-55 -8)(-110 -8)(-110 7)(-55 7))) ) ))
        ("grip" 0 (
          ((0 0) ((-65 -43)(-65 -28)(-95 -28)(-95 -43)(-65 -43)) ) ))
        ("gbx" -11 (
          ((0 0) ((-55 -8)(-110 -8)(-95 -43)(-65 -43)(-55 -8))
                 (((-55 -8)(-110 -8)(-95 -43)(-65 -43)))) ))
        ("gbox" 45 (
          ((0 0) ((-68 -8)(-92 -8)(-92 -28)(-68 -28)(-68 -8))
                 (((-68 -8)(-92 -8)(-92 -28)(-68 -28)))) )) ) ))
;---------------------------------------------------------------------------
  ("G62"
    ("big"
      ("solid"
        ("dxy-bts" (40 40 40))
        ("dz-tbx"  (86 49 109 62))
        ("dwall"   (500  500)) )
      ("glass" ((80 100 15) (160 235))
               ((80 40 81) (160 175) 10) )
;      ("topcase" ((15 -150 91) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 91)(-150 116)(-69 116)(-32.61 108.34)(-31 116)(-20 116)(-20 91)(-150 91))
                 (((-150 91)(-150 116)(-69 116)(-69 91))
                  ((-69 91)(-69 116)(-32.61 108.34)(-20 91))
                  ((-32.61 108.34)(-31 116)(-20 116)(-20 91)) ) ) ))
      ("frame"
        ("bottom" 40 (
          ((0 0) ((0 -47)(40 -47)(40 51)(0 51)(0 -47))) ))
        ("top" 40 (
          ((0 0) ((0 -47)(-40 -47)(-40 31)(-75 31)(-75 67)(-40 67)(-40 86)(0 86)(0 -47))) ))
        ("side" 40 (
          ((0 0) ((0 -47)(40 -47)(40 86)(0 86)(0 -47))
                 (((0 -47)(40 -47)(40 86)(0 86))) ) )) )
      ("frame-metal"
        ("bottom" 0 (
          ((0 0) ((-5 48)(-5 56)(40 56))) ))
        ("top" 0 (
          ((0 0) ((1 93)(-20 93))) ))
        ("side" -5 (
          ((0 0) ((-5 21)(-5 92)(40 92))
                 (((-5 21)(-5 92)(40 92)(40 21))) ) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("sash"
        ("rot-p" -25 (0 0 92))
        ("bottom" 100 (
          ((0 0) ((40 -47)(100 -47)(100 67)(40 67)(40 -47))) ))
        ("top" 105 (
          ((0 0) ((-105 -47)(-150 -47)(-150 67)(-140 67)(-140 81)(-105 81)(-105 -47))) ))
        ("toptop" 75 (
          ((0 0) ((-40 -47)(-75 -47)(-75 35)(-40 35)(-40 -47))) ))
        ("sidtop" 75 (
          ((0 0) ((40 -47)(75 -47)(75 36)(40 36)(40 -47))
                 (((40 -47)(75 -47)(75 36)(40 36))) ) ))
        ("side" 75 (
          ((0 0) ((40 -47)(85 -47)(85 67)(75 67)(75 86)(40 86)(40 -47))
                 (((40 -47)(85 -47)(85 86)(40 86))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 21)(0 92)(50 92))) ))
        ("top" 0 (
          ((0 0) ((-150 92)(-105 92))) ))
        ("side" 85 (
          ((0 0) ((55 92)(85 92))) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("ventil"
        ("rot-p" -55 (0 -120 -47))
        ("top" 0 (
          ((0 0) ((-65 -69)(-120 -69)(-120 -47)(-65 -47)(-65 -69))
                 (((-65 -69)(-120 -69)(-120 -47)(-65 -47))) ) ))
        ("grip" 0 (
          ((0 0) ((-75 -48)(-75 -38)(-105 -38)(-105 -48)(-75 -48))
                 (((-75 -48)(-75 -38)(-105 -38)(-105 -48))) ) ))
        ("gbox" 10 (
          ((0 0) ((-80 -38)(-100 -38)(-100 -13)(-80 -13)(-80 -38))
                 (((-80 -38)(-100 -38)(-100 -13)(-80 -13))) ) )) ) ))
;---------------------------------------------------------------------------
  ("GHL"
    ("big"
      ("solid"
        ("dxy-bts" (40 40 40))
        ("dz-tbx"  (86 49 109 62))
        ("dwall"   (500  500)) )
      ("glass" ((80 40 67) (160 175) ))
;      ("topcase" ((15 -150 91) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 91)(-150 116)(-69 116)(-32.61 108.34)(-31 116)(-20 116)(-20 91)(-150 91))
                 (((-150 91)(-150 116)(-69 116)(-69 91))
                  ((-69 91)(-69 116)(-32.61 108.34)(-20 91))
                  ((-32.61 108.34)(-31 116)(-20 116)(-20 91)) ) ) ))
      ("frame"
        ("bottom" 40 (
          ((0 0) ((0 -47)(40 -47)(40 51)(0 51)(0 -47))) ))
        ("top" 40 (
          ((0 0) ((0 -47)(-40 -47)(-40 86)(0 86)(0 -47))) ))
        ("side" 40 (
          ((0 0) ((0 -47)(40 -47)(40 86)(0 86)(0 -47))
                 (((0 -47)(40 -47)(40 86)(0 86))) ) )) )
      ("frame-metal"
        ("botbot" 0 ( ; VFE VFA VFB
          ((0 0) ((-5 51)(-5 21)(-40 13))) ))
        ("bottom" 0 (
          ((0 0) ((-5 21)(-5 56)(40 56))) ))
        ("top" 0 (
          ((0 0) ((1 93)(-20 93))) ))
        ("side" -5 (
          ((0 0) ((-5 21)(-5 92)(40 92))
                 (((-5 21)(-5 92)(40 92)(40 21)))) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("sash"
        ("rot-p" -30 (0 -20 91))
        ("bottom" 100 (
          ((0 0) ((40 7)(100 7)(100 67)(40 67)(40 7))) ))
        ("top" 105 (
          ((0 0) ((-105 7)(-150 7)(-150 67)(-140 67)(-140 81)(-105 81)(-105 7))) ))
        ("toptop" 75 (
          ((0 0) ((-40 7)(-75 7)(-75 91)(-40 91)(-40 7))
                 (((-40 7)(-75 7)(-75 91)(-40 91))) ) ))
        ("sidtop" 75 (
          ((0 0) ((40 7)(75 7)(75 36)(40 36)(40 7))
                 (((40 7)(75 7)(75 36)(40 36))) ) ))
        ("side" 75 (
          ((0 0) ((40 7)(85 7)(85 67)(75 67)(75 86)(40 86)(40 7))
                 (((40 7)(85 7)(85 86)(40 86))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 21)(0 92)(50 92))) ))
        ("top" 0 (
          ((0 0) ((-150 92)(-105 92))) ))
        ("side" 85 (
          ((0 0) ((55 92)(85 92))) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("ventil"
        ("rot-p" -55 (0 -120 7))
        ("top" 0 (
          ((0 0) ((-65 -13)(-120 -13)(-120 7)(-65 7)(-65 -13))
                 (((-65 -13)(-120 -13)(-120 7)(-65 7))) ) ))
        ("grip" 0 (
          ((0 0) ((-75 -48)(-75 -38)(-105 -38)(-105 -48)(-75 -48))
                 (((-75 -48)(-75 -38)(-105 -38)(-105 -48))) ) ))
        ("gbox" 10 (
          ((0 0) ((-80 -38)(-100 -38)(-100 -13)(-80 -13)(-80 -38))
                 (((-80 -38)(-100 -38)(-100 -13)(-80 -13))) ) )) )
      ("vent" ; GPU
        ("rot-p" -55 (0 -110 7))
        ("top" 0 (
          ((0 0) ((-55 -8)(-110 -8)(-110 7)(-55 7)(-55 -8))
                 (((-55 -8)(-110 -8)(-110 7)(-55 7))) ) ))
        ("grip" 0 (
          ((0 0) ((-65 -43)(-65 -28)(-95 -28)(-95 -43)(-65 -43)) ) ))
        ("gbx" -11 (
          ((0 0) ((-55 -8)(-110 -8)(-95 -43)(-65 -43)(-55 -8))
                 (((-55 -8)(-110 -8)(-95 -43)(-65 -43)))) ))
        ("gbox" 45 (
          ((0 0) ((-68 -8)(-92 -8)(-92 -28)(-68 -28)(-68 -8))
                 (((-68 -8)(-92 -8)(-92 -28)(-68 -28)))) )) )
      ("grip" ;GHL/GPL/GPU
        ("gbox1" 60 (
          ((0 0) ((-12.5 -3)(-12.5 7)(12.5 7)(12.5 -3)(-12.5 -3))
                 (((-12.5 -3)(-12.5 7)(12.5 7)(12.5 -3))) ) ))
        ("gbox2" 25 (
          ((0 0) ((-12.5 -3)(-12.5 -33)(12.5 -33)(12.5 -3)(-12.5 -3))
                 (((-12.5 -3)(-12.5 -33)(12.5 -33)(12.5 -3))) ) ))
        ("gbox3" 125 (
          ((0 0) ((-12.5 -43)(-12.5 -33)(12.5 -33)(12.5 -43)(-12.5 -43))
                 (((-12.5 -43)(-12.5 -33)(12.5 -33)(12.5 -43))) ) )) ) ))
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
  ("GXL"  ; new not finish
    ("big"
      ("solid"
        ("dxy-bts" (40 40 40))
        ("dz-tbx"  (86 49 109 62))
        ("dwall"   (500  500)) )
      ("glass" ((80 40 67) (160 175) ))
;      ("topcase" ((15 -150 91) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 91)(-150 116)(-69 116)(-32.61 108.34)(-31 116)(-20 116)(-20 91)(-150 91))
                 (((-150 91)(-150 116)(-69 116)(-69 91))
                  ((-69 91)(-69 116)(-32.61 108.34)(-20 91))
                  ((-32.61 108.34)(-31 116)(-20 116)(-20 91)) ) ) ))
      ("frame"
        ("bottom" 40 (
          ((0 0) ((0 -47)(40 -47)(40 51)(0 51)(0 -47))) ))
        ("top" 40 (
          ((0 0) ((0 -47)(-40 -47)(-40 86)(0 86)(0 -47))) ))
        ("side" 40 (
          ((0 0) ((0 -47)(40 -47)(40 86)(0 86)(0 -47))
                 (((0 -47)(40 -47)(40 86)(0 86))) ) )) )
      ("frame-metal"
        ("botbot" 0 ( ; VFE VFA VFB
          ((0 0) ((-5 51)(-5 21)(-40 13))) ))
        ("bottom" 0 (
          ((0 0) ((-5 21)(-5 56)(40 56))) ))
        ("top" 0 (
          ((0 0) ((1 93)(-20 93))) ))
        ("side" -5 (
          ((0 0) ((-5 21)(-5 92)(40 92))
                 (((-5 21)(-5 92)(40 92)(40 21)))) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("sash"
        ("rot-p" 85 (0 -20 91))
        ("bottom" 100 (
          ((0 0) ((40 7)(100 7)(100 67)(40 67)(40 7))) ))
        ("top" 105 (
          ((0 0) ((-105 7)(-150 7)(-150 67)(-140 67)(-140 81)(-105 81)(-105 7))) ))
        ("toptop" 75 (
          ((0 0) ((-40 7)(-75 7)(-75 91)(-40 91)(-40 7))
                 (((-40 7)(-75 7)(-75 91)(-40 91))) ) ))
        ("sidtop" 75 (
          ((0 0) ((40 7)(75 7)(75 36)(40 36)(40 7))
                 (((40 7)(75 7)(75 36)(40 36))) ) ))
        ("side" 75 (
          ((0 0) ((40 7)(85 7)(85 67)(75 67)(75 86)(40 86)(40 7))
                 (((40 7)(85 7)(85 86)(40 86))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 21)(0 92)(50 92))) ))
        ("top" 0 (
          ((0 0) ((-150 92)(-105 92))) ))
        ("side" 85 (
          ((0 0) ((55 92)(85 92))) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("ventil"
        ("rot-p" -55 (0 -120 7))
        ("top" 0 (
          ((0 0) ((-65 -13)(-120 -13)(-120 7)(-65 7)(-65 -13))
                 (((-65 -13)(-120 -13)(-120 7)(-65 7))) ) ))
        ("grip" 0 (
          ((0 0) ((-75 -48)(-75 -38)(-105 -38)(-105 -48)(-75 -48))
                 (((-75 -48)(-75 -38)(-105 -38)(-105 -48))) ) ))
        ("gbox" 10 (
          ((0 0) ((-80 -38)(-100 -38)(-100 -13)(-80 -13)(-80 -38))
                 (((-80 -38)(-100 -38)(-100 -13)(-80 -13))) ) )) )
      ("vent" ; GPU
        ("rot-p" -55 (0 -110 7))
        ("top" 0 (
          ((0 0) ((-55 -8)(-110 -8)(-110 7)(-55 7)(-55 -8))
                 (((-55 -8)(-110 -8)(-110 7)(-55 7))) ) ))
        ("grip" 0 (
          ((0 0) ((-65 -43)(-65 -28)(-95 -28)(-95 -43)(-65 -43)) ) ))
        ("gbx" -11 (
          ((0 0) ((-55 -8)(-110 -8)(-95 -43)(-65 -43)(-55 -8))
                 (((-55 -8)(-110 -8)(-95 -43)(-65 -43)))) ))
        ("gbox" 45 (
          ((0 0) ((-68 -8)(-92 -8)(-92 -28)(-68 -28)(-68 -8))
                 (((-68 -8)(-92 -8)(-92 -28)(-68 -28)))) )) )
      ("grip"
        ("gbox1" 10 (
          ((0 0) ((35 -3)(-35 -3)(-35 7)(35 7)(35 -3))
                 (((35 -3)(-35 -3)(-35 7)(35 7))) ) ))
        ("gbox2" 10 (
          ((0 0) ((5 -3)(-35 -3)(-35 -33)(5 -33)(5 -3))
                 (((5 -3)(-35 -3)(-35 -33)(5 -33))) ) ))
        ("gbox3" 10 (
          ((0 0) ((5 -33)(-165 -33)(-165 -48)(-25 -48)(5 -33))
                 (((5 -33)(-165 -33)(-165 -48)(-25 -48))) ) )) ) ))
;---------------------------------------------------------------------------
  ("GPL"  ; GPL GPU
    ("big"
      ("solid"
        ("dxy-bts" (40 40 40))
        ("dz-tbx"  (86 49 109 62))
        ("dwall"   (500  500)) )
      ("glass" ((80 40 67) (160 175) ))
;      ("topcase" ((15 -150 91) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 91)(-150 116)(-69 116)(-32.61 108.34)(-31 116)(-20 116)(-20 91)(-150 91))
                 (((-150 91)(-150 116)(-69 116)(-69 91))
                  ((-69 91)(-69 116)(-32.61 108.34)(-20 91))
                  ((-32.61 108.34)(-31 116)(-20 116)(-20 91)) ) ) ))
      ("frame"
        ("bottom" 40 (
          ((0 0) ((0 -47)(40 -47)(40 51)(0 51)(0 -47))) ))
        ("top" 40 (
          ((0 0) ((0 -47)(-40 -47)(-40 86)(0 86)(0 -47))) ))
        ("side" 40 (
          ((0 0) ((0 -47)(40 -47)(40 86)(0 86)(0 -47))
                 (((0 -47)(40 -47)(40 86)(0 86))) ) )) )
      ("frame-metal"
        ("botbot" 0 ( ; VFE VFA VFB
          ((0 0) ((-5 51)(-5 21)(-40 13))) ))
        ("bottom" 0 (
          ((0 0) ((-5 21)(-5 56)(40 56))) ))
        ("top" 0 (
          ((0 0) ((1 93)(-20 93))) ))
        ("side" -5 (
          ((0 0) ((-5 21)(-5 92)(40 92))
                 (((-5 21)(-5 92)(40 92)(40 21)))) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("sash"
        ("rot-p" -45 (0 -20 91))
        ("bottom" 100 (
          ((0 0) ((40 7)(100 7)(100 67)(40 67)(40 7))) ))
        ("top" 105 (
          ((0 0) ((-105 7)(-150 7)(-150 67)(-140 67)(-140 81)(-105 81)(-105 7))) ))
        ("toptop" 75 (
          ((0 0) ((-40 7)(-75 7)(-75 91)(-40 91)(-40 7))
                 (((-40 7)(-75 7)(-75 91)(-40 91))) ) ))
        ("sidtop" 75 (
          ((0 0) ((40 7)(75 7)(75 36)(40 36)(40 7))
                 (((40 7)(75 7)(75 36)(40 36))) ) ))
        ("side" 75 (
          ((0 0) ((40 7)(85 7)(85 67)(75 67)(75 86)(40 86)(40 7))
                 (((40 7)(85 7)(85 86)(40 86))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 21)(0 92)(50 92))) ))
        ("top" 0 (
          ((0 0) ((-150 92)(-105 92))) ))
        ("side" 85 (
          ((0 0) ((55 92)(85 92))) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("ventil"
        ("rot-p" -55 (0 -120 7))
        ("top" 0 (
          ((0 0) ((-65 -13)(-120 -13)(-120 7)(-65 7)(-65 -13))
                 (((-65 -13)(-120 -13)(-120 7)(-65 7))) ) ))
        ("grip" 0 (
          ((0 0) ((-75 -48)(-75 -38)(-105 -38)(-105 -48)(-75 -48))
                 (((-75 -48)(-75 -38)(-105 -38)(-105 -48))) ) ))
        ("gbox" 10 (
          ((0 0) ((-80 -38)(-100 -38)(-100 -13)(-80 -13)(-80 -38))
                 (((-80 -38)(-100 -38)(-100 -13)(-80 -13))) ) )) )
      ("vent" ; GPU
        ("rot-p" -55 (0 -110 7))
        ("top" 0 (
          ((0 0) ((-55 -8)(-110 -8)(-110 7)(-55 7)(-55 -8))
                 (((-55 -8)(-110 -8)(-110 7)(-55 7))) ) ))
        ("grip" 0 (
          ((0 0) ((-65 -43)(-65 -28)(-95 -28)(-95 -43)(-65 -43)) ) ))
        ("gbx" -11 (
          ((0 0) ((-55 -8)(-110 -8)(-95 -43)(-65 -43)(-55 -8))
                 (((-55 -8)(-110 -8)(-95 -43)(-65 -43)))) ))
        ("gbox" 45 (
          ((0 0) ((-68 -8)(-92 -8)(-92 -28)(-68 -28)(-68 -8))
                 (((-68 -8)(-92 -8)(-92 -28)(-68 -28)))) )) )
      ("grip" ;GHL/GPL/GPU
        ("gbox1" 60 (
          ((0 0) ((-12.5 -3)(-12.5 7)(12.5 7)(12.5 -3)(-12.5 -3))
                 (((-12.5 -3)(-12.5 7)(12.5 7)(12.5 -3))) ) ))
        ("gbox2" 25 (
          ((0 0) ((-12.5 -3)(-12.5 -33)(12.5 -33)(12.5 -3)(-12.5 -3))
                 (((-12.5 -3)(-12.5 -33)(12.5 -33)(12.5 -3))) ) ))
        ("gbox3" 125 (
          ((0 0) ((-12.5 -43)(-12.5 -33)(12.5 -33)(12.5 -43)(-12.5 -43))
                 (((-12.5 -43)(-12.5 -33)(12.5 -33)(12.5 -43))) ) )) ) ))
;---------------------------------------------------------------------------
 ("GTL"
    ("big"
      ("solid"
        ("dxy-bts" (40 40 40))
        ("dz-tbx"  (86 49 109 62))
        ("dwall"   (500  500)) )
      ("glass" ((80 40 67) (160 175) ))
;      ("topcase" ((15 -150 91) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 91)(-150 116)(-69 116)(-32.61 108.34)(-31 116)(-20 116)(-20 91)(-150 91))
                 (((-150 91)(-150 116)(-69 116)(-69 91))
                  ((-69 91)(-69 116)(-32.61 108.34)(-20 91))
                  ((-32.61 108.34)(-31 116)(-20 116)(-20 91)) ) ) ))
      ("frame"
        ("bottom" 40 (
          ((0 0) ((0 -47)(40 -47)(40 51)(0 51)(0 -47))) ))
        ("top" 40 (
          ((0 0) ((0 -47)(-40 -47)(-40 86)(0 86)(0 -47))) ))
        ("side" 40 (
          ((0 0) ((0 -47)(40 -47)(40 86)(0 86)(0 -47))
                 (((0 -47)(40 -47)(40 86)(0 86))) ) )) )
      ("frame-metal"
        ("botbot" 0 ( ; VFE VFA VFB
          ((0 0) ((-5 51)(-5 21)(-40 13))) ))
        ("bottom" 0 (
          ((0 0) ((-5 21)(-5 56)(40 56))) ))
        ("top" 0 (
          ((0 0) ((1 93)(-20 93))) ))
        ("side" -5 (
          ((0 0) ((-5 21)(-5 92)(40 92))
                 (((-5 21)(-5 92)(40 92)(40 21))) ) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("sash"
        ("rot-p" -70 (0 -20 91))
        ("bottom" 100 (
          ((0 0) ((40 7)(100 7)(100 67)(40 67)(40 7))) ))
        ("top" 105 (
          ((0 0) ((-105 7)(-150 7)(-150 67)(-140 67)(-140 81)(-105 81)(-105 7))) ))
        ("toptop" 75 (
          ((0 0) ((-40 7)(-75 7)(-75 91)(-40 91)(-40 7))
                 (((-40 7)(-75 7)(-75 91)(-40 91))) ) ))
        ("sidtop" 75 (
          ((0 0) ((40 7)(75 7)(75 36)(40 36)(40 7))
                 (((40 7)(75 7)(75 36)(40 36))) ) ))
        ("side" 85 (
          ((0 0) ((40 7)(85 7)(85 67)(75 67)(75 86)(40 86)(40 7))
                 (((40 7)(85 7)(85 86)(40 86))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 21)(0 92)(50 92))) ))
        ("top" 0 (
          ((0 0) ((-150 92)(-105 92))) ))
        ("side" 85 (
          ((0 0) ((55 92)(85 92))) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) )
      ("ventil"
        ("rot-p" -55 (0 -120 7))
        ("top" 0 (
          ((0 0) ((-65 -13)(-120 -13)(-120 7)(-65 7)(-65 -13))
                 (((-65 -13)(-120 -13)(-120 7)(-65 7))) ) ))
        ("grip" 0 (
          ((0 0) ((-75 -48)(-75 -38)(-105 -38)(-105 -48)(-75 -48))
                 (((-75 -48)(-75 -38)(-105 -38)(-105 -48))) ) ))
        ("gbox" 10 (
          ((0 0) ((-80 -38)(-100 -38)(-100 -13)(-80 -13)(-80 -38))
                 (((-80 -38)(-100 -38)(-100 -13)(-80 -13))) ) )) )
      ("grip" ;GTL
        ("grip" 0 (
          ((0 0) ((4.0590 -27)(15.5395 -19.1179)(15.5395 -8.5984)(4.0590 0.7163)
                  (-4.0590 0.7163)(-15.5395 -8.5984)(-15.5395 -19.1179)(-4.0590 -27)
                  (4.0590 -27)) ) ))
        ("gbx" -20 (
          ((0 0) ((35 7)(-35 7)(-10 -28)(10 -28)(35 7))
                 (((35 7)(-35 7)(-10 -28)(10 -28)))) )) ) ))
;---------------------------------------------------------------------------
  ("GIL" ; GIL GIU
    ("big"
      ("solid"
        ("dxy-bts" (60 40 40))
        ("dz-tbx"  (86 49 109 62))
        ("dwall"   (500  500)) )
      ("glass" ((80 60 67) (160 130) ))
      ("frame"
        ("bottom" 60 (
          ((0 0) ((0 -47)(60 -47)(60 51)(0 51)(0 -47))) ))
        ("top" 40 (
          ((0 0) ((0 -47)(-40 -47)(-40 86)(0 86)(0 -47))) ))
        ("side" 40 (
          ((0 0) ((0 -47)(40 -47)(40 86)(0 86)(0 -47))
                 (((0 -47)(40 -47)(40 86)(0 86))) ) )) )
      ("frame-metal"
        ("bottom" 0 (
          ((0 0) ((-5 48)(-5 56)(65 56))) ))
        ("top" 0 (
          ((0 0) ((1 86)(-50 96))) ))
        ("side" -5 (
          ((0 0) ((-5 21)(-5 92)(40 92)(40 21))
                 (((-5 21)(-5 92)(40 92)(40 21)))) )) )
      ("sash"
        ("rot-p" 0 (0 0 0))
        ("bottom" 120 (
          ((0 0) ((60 7)(120 7)(120 67)(60 67)(60 7))) ))
        ("top" 40 (
          ((0 0) ((-40 7)(-85 7)(-85 67)(-75 76)(-75 81)(-40 81)(-40 7))) ))
        ("side" 75 (
          ((0 0) ((40 7)(85 7)(85 67)(75 67)(75 86)(40 86)(40 7))
                 (((40 7)(85 7)(85 86)(40 86))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((55 21)(55 92)(120 92))) ))
        ("top" 0 (
          ((0 0) ((-85 92)(-40 92))) ))
        ("side" 85 (
          ((0 0) ((55 92)(85 92))) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) ) ))
;---------------------------------------------------------------------------
  ("VIU" ; GIU variant
    ("big"
      ("solid"
        ("dxy-bts" (60 40 40))
        ("dz-tbx"  (86 49 109 62))
        ("dwall"   (500  500)) )
      ("glass" ((80 60 67) (160 130) ))
      ("frame"
        ("bottom" 60 (
          ((0 0) ((0 -47)(60 -47)(60 51)(0 51)(0 -47))) ))
        ("top" 40 (
          ((0 0) ((-50 -47)(-90 -47)(-90 86)(-50 86)(-50 -47))) ))
        ("side" 40 (
          ((0 0) ((0 -47)(40 -47)(40 86)(0 86)(0 -47))
                 (((0 -47)(40 -47)(40 86)(0 86))) ) )) )
      ("frame-metal"
        ("bottom" 0 (
          ((0 0) ((-5 48)(-5 56)(65 56))) ))
        ("top" 0 (
          ((0 0) ((1 86)(-100 96))) ))
        ("side" -5 (
          ((0 0) ((-5 21)(-5 92)(40 92)(40 21))
                 (((-5 21)(-5 92)(40 92)(40 21)))) )) )
      ("sash"
        ("rot-p" 0 (0 0 0))
        ("bottom" 120 (
          ((0 0) ((60 7)(120 7)(120 67)(60 67)(60 7))) ))
        ("top" 40 (
          ((0 0) ((-90 7)(-135 7)(-135 67)(-125 76)(-125 81)(-90 81)(-90 7))) ))
        ("side" 75 (
          ((0 0) ((40 7)(85 7)(85 67)(75 67)(75 86)(40 86)(40 7))
                 (((40 7)(85 7)(85 86)(40 86))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((55 21)(55 92)(120 92))) ))
        ("top" 0 (
          ((0 0) ((-135 92)(-40 92))) ))
        ("side" 85 (
          ((0 0) ((55 92)(85 92))) ))
        ("sside" 0 (
          ((0 0) ((10 93)(70 93))) )) ) ))
;---------------------------------------------------------------------------
  ("VFE"
    ("big"
      ("solid"
        ("dxy-bts" (45 11 40))
        ("dz-tbx"  (51 38 71 0))
        ("dwall"   (500  500)) )
      ("solid-o"
        ("dwall"   (200  800)) )
      ("glass" ((80 80 21) (160 185) ))
      ("frame"
        ("bottom" 45 (
          ((0 0) ((0 -38)(25 -38)(25 -49)(45 -49)(45 34)(0 34)(0 -38))
                 (((0 -38)(25 -38)(25 34)(0 34))) ) ))
        ("top" 74 (
          ((0 0) ((-11 -49)(-74 -49)(-74 40)(-45 40)(-11 1)(-11 -49))
                 (((-45 -49)(-45 40)(-11 1)(-11 -49))) ) ))
        ("side" 40 (
          ((0 0) ((0 -49)(40 -49)(40 40)(0 40)(0 -49))
                 (((0 -49)(40 -49)(40 40)(0 40))) ) )) )
      ("frame-metal"
        ("bottom" 0 ( ))
        ("top" 0 (
          ((0 0) ((1 7)(-40 52)(-110 52))) ))
        ("side" -5 (
          ((0 0) ((-5 37)(-5 50)(60 50))) )) )
      ("sash"
        ("rot-p" -12 (0 45 0))
        ("bottom" 100 (
          ((0 0) ((45 -33)(100 -33)(100 40)(45 40)(45 -33))) ))
        ("top" 74 (
          ((0 0) ((-74 -33)(-124 -33)(-124 40)(-74 40)(-74 -33))) ))
        ("side" 85 (
          ((0 0) ((40 -33)(85 -33)(85 40)(40 40)(40 -33))
                 (((40 -33)(85 -33)(85 40)(40 40))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((5 37)(5 48)(100 48))) ))
        ("top" 0 (
          ((0 0) ((-124 48)(-74 48))) ))
        ("side" 85 (
          ((0 0) ((40 49)(85 49))) )) )
      ("grip"
        ("grip" 0 (
          ((0 0) ((-27 -33)(0 -33)(-12 -68)(-32 -68)
                  (-32 -63)(-15 -63)(-5 -36)(-27 -36)(-27 -33))
                 (((-27 -33)(0 -33)(-5 -36)(-27 -36))
                  ((-12 -68)(-32 -68)(-32 -65)(-15 -65))
                  ((0 -33)(-12 -68)(-15 -63)(-5 -36))) ) )) ) ))
;---------------------------------------------------------------------------
  ("VFA"
    ("big"
      ("solid"
        ("dxy-bts" (45 11 40))
        ("dz-tbx"  (51 38 71 0))
        ("dwall"   (500  500)) )
      ("solid-o"
        ("dwall"   (200  800)) )
      ("glass" ((80 80 21) (160 185) ))
      ("frame"
        ("bottom" 45 (
          ((0 0) ((0 -38)(25 -38)(25 -49)(45 -49)(45 34)(0 34)(0 -38))
                 (((0 -38)(25 -38)(25 34)(0 34))) ) ))
        ("top" 74 (
          ((0 0) ((-11 -49)(-74 -49)(-74 40)(-45 40)(-11 1)(-11 -49))
                 (((-45 -49)(-45 40)(-11 1)(-11 -49))) ) ))
        ("side" 40 (
          ((0 0) ((0 -49)(40 -49)(40 40)(0 40)(0 -49))
                 (((0 -49)(40 -49)(40 40)(0 40))) ) )) )
      ("frame-metal"
        ("bottom" 0 ( ))
        ("top" 0 (
          ((0 0) ((1 7)(-40 52)(-110 52))) ))
        ("side" -5 (
          ((0 0) ((-5 37)(-5 50)(60 50))) )) )
      ("sash"
        ("rot-p" -12 (0 45 0))
        ("bottom" 100 (
          ((0 0) ((45 -33)(100 -33)(100 40)(45 40)(45 -33))) ))
        ("top" 74 (
          ((0 0) ((-74 -33)(-124 -33)(-124 40)(-74 40)(-74 -33))) ))
        ("side" 85 (
          ((0 0) ((40 -33)(85 -33)(85 40)(40 40)(40 -33))
                 (((40 -33)(85 -33)(85 40)(40 40))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((5 37)(5 48)(100 48))) ))
        ("top" 0 (
          ((0 0) ((-124 48)(-74 48))) ))
        ("side" 85 (
          ((0 0) ((40 49)(85 49))) )) )
      ("grip"
        ("gbox1" 10 (
          ((0 0) ((35 -43)(-35 -43)(-35 -33)(35 -33)(35 -43))
                 (((35 -43)(-35 -43)(-35 -33)(35 -33))) ) ))
        ("gbox2" 10 (
          ((0 0) ((5 -43)(-35 -43)(-35 -73)(5 -73)(5 -43))
                 (((5 -43)(-35 -43)(-35 -73)(5 -73))) ) ))
        ("gbox3" 10 (
          ((0 0) ((5 -73)(-165 -73)(-165 -88)(-25 -88)(5 -73))
                 (((5 -73)(-165 -73)(-165 -88)(-25 -88))) ) )) ) ))
;---------------------------------------------------------------------------
  ("GEL"
    ("big"
      ("solid"
        ("dxy-bts" (40 45 40))
        ("dz-tbx"  (113 22 109 0))
        ("dwall"   (500  500)) )
      ("glass" ((80 40 94) (160 180) ))
      ("topcase-" ((15 -150 118) (40 130) 25))
;      ("topcase" 15 (
;          ((0 0) ((-150 91)(-150 116)(-69 116)(-32.61 108.34)(-31 116)(-20 116)(-20 91)(-150 91))
;                 (((-150 91)(-150 116)(-69 116)(-69 91))
;                  ((-69 91)(-69 116)(-32.61 108.34)(-20 91))
;                  ((-32.61 108.34)(-31 116)(-20 116)(-20 91)) ) ) ))
      ("frame"
        ("bottom" 40 ( ))
        ("top" 45 (
          ((0 0) ((0 -22)(-40 -22)(-40 113)(0 113)(0 -22))) ))
        ("side" 40 (
          ((0 0) ((0 -22)(40 -22)(40 113)(0 113)(0 -22))
                 (((0 -22)(40 -22)(40 113)(0 113))) ) )) )
      ("frame-metal"
        ("bottom" 0 ( ))
        ("top" 0 (
          ((0 0) ((1 120)(-20 120))) ))
        ("side" -5 (
          ((0 0) ((-5 48)(-5 119)(40 119))
                 (((-5 48)(-5 119)(40 119)(40 48)))) ))
        ("sside" 0 (
          ((0 0) ((10 120)(70 120))) )) )
      ("sash"
        ("rot-p" -45 (0 -20 118))
        ("bottom" 100 (
          ((0 0) ((40 34)(100 34)(100 94)(40 94)(40 34))) ))
        ("top" 105 (
          ((0 0) ((-105 34)(-150 34)(-150 94)(-140 94)(-140 108)(-105 108)(-105 34))) ))
        ("toptop" 75 (
          ((0 0) ((-40 34)(-75 34)(-75 118)(-40 118)(-40 34))
                 (((-40 34)(-75 34)(-75 118)(-40 118))) ) ))
        ("sidtop" 75 (
          ((0 0) ((40 34)(75 34)(75 63)(40 63)(40 34))
                 (((40 34)(75 34)(75 63)(40 63))) ) ))
        ("side" 75 (
          ((0 0) ((40 34)(85 34)(85 94)(75 94)(75 113)(40 113)(40 34))
                 (((40 34)(85 34)(85 113)(40 113))) ) )) )
      ("sash-metal"
        ("botbot" 0 (
          ((0 0) ((50 120)(-30 150)(-50 150)(-50 120))) ))
        ("bottom" 0 (
          ((0 0) ((0 48)(0 119)(50 119))) ))
        ("top" 0 (
          ((0 0) ((-150 119)(-105 119))) ))
        ("side" 85 (
          ((0 0) ((55 119)(85 119))) ))
        ("sside" 15 (
          ((0 0) ((10 120)(70 120))) )) )
      ("ventil"
        ("rot-p" -55 (0 -120 34))
        ("top" 0 (
          ((0 0) ((-65 14)(-120 14)(-120 34)(-65 34)(-65 14))
                 (((-65 14)(-120 14)(-120 34)(-65 34))) ) ))
        ("grip" 0 (
          ((0 0) ((-72.9229 -14.4565)(-75.5111 -4.7972)(-104.4889 -12.5618)(-101.9007 -22.2210)(-72.9229 -14.4565))
                 (((-72.9229 -14.4565)(-75.5111 -4.7972)(-104.4889 -12.5618)(-101.9007 -22.2210))) ) ))
        ("gbox" 10 (
          ((0 0) ((-80 -6)(-100 -11.3590)(-100 14)(-80 14)(-80 -6))
                 (((-80 -6)(-100 -11.3590)(-100 14)(-80 14))) ) )) )
      ("grip"
        ("gbox1" 60 (
          ((0 0) ((-12.5 24)(-12.5 34)(12.5 34)(12.5 24)(-12.5 24))
                 (((-12.5 24)(-12.5 34)(12.5 34)(12.5 24))) ) ))
        ("gbox2" 25 (
          ((0 0) ((-12.5 24)(-12.5 -6)(12.5 -6)(12.5 24)(-12.5 24))
                 (((-12.5 24)(-12.5 -6)(12.5 -6)(12.5 24))) ) ))
        ("gbox3" 125 (
          ((0 0) ((-12.5 -16)(-12.5 -6)(12.5 -6)(12.5 -16)(-12.5 -16))
                 (((-12.5 -16)(-12.5 -6)(12.5 -6)(12.5 -16))) ) )) ) ))
;---------------------------------------------------------------------------
  ("VEC" ; not change for V21
    ("big"
      ("solid"
        ("dxy-bts" (89 40 40))
        ("dz-tbx"  (50 22 109 0))
        ("dwall"   (500  500)) )
      ("solid-o"
        ("dwall"   (200  800)) )
      ("glass" ((60 180 44) (120 220) ))
      ("frame"
        ("bottom" 89 (
          ((0 0) ((14 -77)(89 -77)(89 15)(39 15)(39 50)(14 50)(14 -77))) ))
        ("top" 40 ())
        ("side" 40 (
          ((0 0) ((0 -77)(40 -77)(40 50)(0 50)(0 -77))
                 (((0 -77)(40 -77)(40 50)(0 50))) ) )) )
      ("frame-metal"
        ("bottom" 0 (
          ((0 0) ((-35 25)(12 25)(12 52)(41 52)(41 17))) ))
        ("top" 0 ())
        ("side" -5 (
          ((0 0) ((-5 -50)(-5 72)(40 72)(40 50))) )) )
      ("sash"
        ("rot-p" 0 (0 0 0))
        ("bottom" 230 (
          ((0 0) ((60 18)(60 68)(150 68)(150 40)(230 40)(230 -16)(120 -16)(120 18)(60 18))
                 (((60 18)(60 68)(150 68)(150 18))) ) ))
        ("top" 9 (
          ((0 0) ((0 -16)(13 8)(0 11)(-9 75)(-39 75)(-39 40)(-55 40)(-55 -16)(0 -16))) ))
        ("side" 88 (
          ((0 0) ((40 -16)(88 -16)(88 39)(60 39)(60 68)(40 68)(40 -16))
                 (((40 -16)(88 -16)(88 68)(40 68))) ) )) )
      ("sash-metal"
        ("botbot" 0 (
          ((0 0) ((154 75)(200 75))) ))
        ("bottom" 0 (
          ((0 0) ((0 73)(152 73)(152 45)(200 45))) ))
        ("top" 0 (
          ((0 0) ((-65 75)(-39 75))) ))
        ("toptop" 0 (
          ((0 0) ((2 13)(-7 77)(-55 77))) ))
        ("side" 15 (
          ((0 0) ((60 70)(90 70))) ))
        ("sside" 0 (
          ((0 0) ((15 75)(60 75))) )) )
  ))
;---------------------------------------------------------------------------
  ("VEA" ; not change for V21
    ("big"
      ("solid"
        ("dxy-bts" (89 40 40))
        ("dz-tbx"  (50 22 109 0))
        ("dwall"   (500  500)) )
      ("solid-o"
        ("dwall"   (200  800)) )
      ("glass" ((60 180 44) (120 220) ))
      ("frame"
        ("bottom" 89 (
          ((0 0) ((14 -77)(89 -77)(89 15)(39 15)(39 50)(14 50)(14 -77))) ))
        ("top" 40 ())
        ("side" 40 (
          ((0 0) ((0 -77)(40 -77)(40 50)(0 50)(0 -77))
                 (((0 -77)(40 -77)(40 50)(0 50))) ) )) )
      ("frame-metal"
        ("bottom" 0 (
          ((0 0) ((-35 25)(12 25)(12 52)(41 52)(41 17))) ))
        ("top" 0 ())
        ("side" -5 (
          ((0 0) ((-5 -50)(-5 72)(40 72)(40 50))) )) )
      ("sash"
        ("rot-p" 70 (45 0 65))
        ("bottom" 230 (
          ((0 0) ((60 18)(60 68)(150 68)(150 40)(230 40)(230 -16)(120 -16)(120 18)(60 18))
                 (((60 18)(60 68)(150 68)(150 18))) ) ))
        ("top" 9 (
          ((0 0) ((0 -16)(13 8)(0 11)(-9 75)(-39 75)(-39 40)(-55 40)(-55 -16)(0 -16))) ))
        ("side" 88 (
          ((0 0) ((40 -16)(88 -16)(88 39)(60 39)(60 68)(40 68)(40 -16))
                 (((40 -16)(88 -16)(88 68)(40 68))) ) )) )
      ("sash-metal"
        ("botbot" 0 (
          ((0 0) ((154 75)(200 75))) ))
        ("bottom" 0 (
          ((0 0) ((0 73)(152 73)(152 45)(200 45))) ))
        ("top" 0 (
          ((0 0) ((-65 75)(-39 75))) ))
        ("toptop" 0 (
          ((0 0) ((2 13)(-7 77)(-55 77))) ))
        ("side" 15 (
          ((0 0) ((60 70)(90 70))) ))
        ("sside" 0 (
          ((0 0) ((15 75)(60 75))) )) )
      ("grip"
        ("gbox1" 25 (
          ((0 0) ((0 -26)(0 -16)(100 -16)(100 -26)(0 -26))
                 (((0 -26)(0 -16)(100 -16)(100 -26))) ) ))
        ("gbox2" 25 (
          ((0 0) ((0 -26)(0 -56)(80 -56)(100 -36)(220 -36)(220 -26)(0 -26))
                 (((0 -36)(0 -56)(80 -56)(100 -36))
                   ((0 -36)(220 -36)(220 -26)(0 -26))) ) ))
        ("gbox3" 25 (
          ((0 0) ((200 -36)(200 -66)(215 -66)(215 -36)(200 -36))
                 (((200 -36)(200 -66)(215 -66)(215 -36))) ) )) ) ))
;---------------------------------------------------------------------------
  ("GIR"
    ("big"
      ("solid"
        ("dxy-bts" (40 40 40))
        ("dz-tbx"  (91 49 109 0))
        ("dwall"   (500  500)) )
      ("glass" ((40 30 67) (80 70)))
      ;("topcase" ())
      ("frame"
        ("bottom" 0 (
          ((0 0) ((0 -47)(30 -47)(30 7)(80 7)(80 67)(0 67)(0 -47))) ))
        ("top" 0 ())
        ("side" 40 (
          ((0 0) ((0 -47)(40 -47)(40 7)(85 7)(85 91)(0 91)(0 -47))) )) )
      ("frame-metal"
        ("bottom" 0 (
          ((0 0) ((-5 96)(45 96))) ))
        ("top" 0 ())
        ("side" 0 (
          ((0 0) ((-5 -47)(-5 101)(65 101)(65 93)(3 93))) )) )
      ("sash"
        ("rot-p" 0 (0 0 -27))
        ("bottom" 0 ())
        ("top" 0 ())
        ("side" 0 ()) )
      ("sash-metal"
        ("bottom" 0 ())
        ("top" 0 ())
        ("side" 30 (
          ((0 0) ((60 101)(90 101)(90 93)(60 93))) )) ) ))
;---------------------------------------------------------------------------
  ("GDL-t"
    ("big"
      ("solid"
        ("dxy-bts" (40 40 40))
        ("dz-tbx"  (86 49 109 0))
        ("dwall"   (500  500)) )
      ("glass" ((80 40 73) (160 175) ))
;      ("topcase" ((15 -150 97) (40 130) 25))
      ("topcase" 15 (
          ((0 0) ((-150 97)(-150 122)(-69 122)(-32.61 114.34)(-31 122)(-20 122)(-20 97)(-150 97))
                 (((-150 97)(-150 122)(-69 122)(-69 97))
                  ((-69 97)(-69 122)(-32.61 114.34)(-20 97))
                  ((-32.61 114.34)(-31 122)(-20 122)(-20 97)) ) ) ))
      ("frame"
        ("bottom" -29 ( ))
        ("top" 40 (
          ((0 0) ((0 -47)(-40 -47)(-40 44)(0 44)(0 -47))) ))
        ("side" 40 (
          ((0 0) ((0 -47)(40 -47)(40 44)(0 44)(0 -47))
                 (((0 -47)(40 -47)(40 44)(0 44))) ) )) )
      ("frame-metal"
        ("bottom" 0 ( ))
        ("top" 0 (
          ((0 0) ((1 99)(-20 99))) ))
        ("side" -5 (
          ((0 0) ((-5 27)(-5 98)(40 98))
                 (((-5 27)(-5 98)(40 98)(40 27)))) ))
        ("sside" 0 (
          ((0 0) ((10 99)(70 99))) )) )
      ("sash"
        ("rot-p" -45 (0 -20 97))
        ("bottom" 100 (
          ((0 0) ((-16 13)(100 13)(100 69)(-29 69)(-16 13))) ))
        ("top" 105 (
          ((0 0) ((-105 13)(-150 13)(-150 73)(-140 73)(-140 87)(-105 87)(-105 13))) ))
        ("toptop" 75 (
          ((0 0) ((-40 13)(-75 13)(-75 92)(-40 92)(-40 7))
                 (((-40 13)(-75 13)(-75 92)(-40 92))) ) ))
        ("sidtop" 75 (
          ((0 0) ((40 13)(75 13)(75 42)(40 42)(40 13))
                 (((40 13)(75 13)(75 42)(40 42))) ) ))
        ("side" 75 (
          ((0 0) ((40 13)(85 13)(85 73)(75 73)(75 92)(40 92)(40 13))
                 (((40 13)(85 13)(85 92)(40 92))) ) )) )
      ("sash-metal"
        ("botbot" 0 (
          ((0 0) ((50 71)(-30 123)(-80 123)(-80 99))) ))
        ("bottom" 0 (
          ((0 0) ((-20 98)(50 98))) ))
        ("top" 0 (
          ((0 0) ((-150 98)(-105 98))) ))
        ("side" 85 (
          ((0 0) ((55 98)(85 98))) ))
        ("sside" 0 (
          ((0 0) ((10 99)(70 99))) )) )
      ("ventil"
        ("rot-p" -55 (0 -120 13))
        ("top" 0 (
          ((0 0) ((-65 -7)(-120 -7)(-120 13)(-65 13)(-65 -7))
                 (((-65 -7)(-120 -7)(-120 13)(-65 13))) ) ))
        ("grip" 0 (
          ((0 0) ((-75 -48)(-75 -38)(-105 -38)(-105 -48)(-75 -48))
                 (((-75 -48)(-75 -38)(-105 -38)(-105 -48))) ) ))
        ("gbox" 10 (
          ((0 0) ((-80 -38)(-100 -38)(-100 -13)(-80 -13)(-80 -38))
                 (((-80 -38)(-100 -38)(-100 -13)(-80 -13))) ) )) )
      ("grip"
        ("gbox1" 60 (
          ((0 0) ((-12.5 3)(-12.5 13)(12.5 13)(12.5 3)(-12.5 3))
                 (((-12.5 3)(-12.5 13)(12.5 13)(12.5 3))) ) ))
        ("gbox2" 25 (
          ((0 0) ((-12.5 3)(-12.5 -27)(12.5 -27)(12.5 3)(-12.5 3))
                 (((-12.5 3)(-12.5 -27)(12.5 -27)(12.5 3))) ) ))
        ("gbox3" 125 (
          ((0 0) ((-12.5 -37)(-12.5 -27)(12.5 -27)(12.5 -37)(-12.5 -37))
                 (((-12.5 -37)(-12.5 -27)(12.5 -27)(12.5 -37))) ) )) ) ))
;---------------------------------------------------------------------------
  ("GDL-b"
    ("big"
      ("solid"
        ("dxy-bts" (60  0 40))
        ("dz-tbx"  (44 49 109 0))
        ("dwall"   (500  500)) )
      ("glass" ((80 60 73) (160 130) ))
      ("frame"
        ("bottom" 60 (
          ((0 0) ((0 -47)(60 -47)(60 44)(0 44)(0 -47))) ))
        ("top" -29 ( ))
        ("side" 40 (
          ((0 0) ((0 -47)(40 -47)(40 44)(0 44)(0 -47))
                 (((0 -47)(40 -47)(40 44)(0 44))) ) )) )
      ("frame-metal"
        ("bottom" 0 (
          ((0 0) ((-5 27)(-5 62)(65 62))) ))
        ("top" 0 ( ))
        ("side" -5 (
          ((0 0) ((-5 27)(-5 99)(40 99))
                 (((-5 27)(-5 99)(40 99)(40 27)))) )) )
      ("sash"
        ;("rot-p" 0 (0 -65 -227))
        ("rot-p" 0 (0 14.52 21.27))
        ("bottom" 120 (
          ((0 0) ((60 13)(120 13)(120 73)(60 73)(60 13))) ))
        ("top" 29 (
          ((0 0) ((-16 13)(-88 13)(-88 73)(-29 73)(-16 13))
                 (((-16 13)(-88 13)(-88 73)(-29 73)))) ))
        ("sidtop" 0 ( ))
        ("side" 85 (
          ((0 0) ((40 13)(85 13)(85 73)(75 73)(75 92)(40 92)(40 13))
                 (((40 13)(85 13)(85 92)(40 92))) ) )) )
      ("sash-metal"
        ("bottom" 0 (
          ((0 0) ((0 21)(0 98)(50 98))) ))
        ("top" 0 ( ))
        ("toptop" 0 (
          ((0 0) ((-90 98)(-27 98)(-14 38))) ))
        ("side" 15 (
          ((0 0) ((55 98)(85 98))) ))
        ("sside" 0 (
          ((0 0) ((0 100)(0 99)(65 99))) )) )
      ("railing"
        ("side" 0 (
          ((0 0) ((-40 98)(-40 158)(0 158)(0 98))) ))
        ("sside" 0 (
          ((0 0) ((-30 99)(-30 148)(-10 148)(-10 99))) ))
        ("ssside" 0 (
          ((0 0) ((-30 -27)(-30 -22)(-10 -22)(-10 -27))) )) )
      ("prot-glass" ((60 60 -32) (120 440) ))
      ("prot-grip"
        ("gbox" 0 (
          ((0 0) ((25 13)(-25 13)(-10 -37)(10 -37)(25 13))
                 (((25 13)(-25 13)(-10 -37)(10 -37)))) )) )
      ("grip"
        ("grip" 0 (
          ((0 0) ((-72.9229 -19.5435)(-75.5111 -9.2028)(-104.4889 -17.4382)
                                   (-101.9007 -26.221)(-72.9229 -18.4565))
                 (((-72.9229 -19.5435)(-75.5111 -9.2028)(-104.4889 -17.4382)
                                    (-101.9007 -26.221))) ) ))
        ("gbox" 10 (
          ((0 0) ((-80 -10)(-100 -16.6410)(-100 13)(-80 13)(-80 -10))
                 (((-80 -10)(-100 -16.6410)(-100 13)(-80 13))) ) )) ) ))
;---------------------------------------------------------------------------
  ("GVT" ; GVT not change for V21
    ("small"
      ("solid"
        ("dxy-bts" (30 30 30))
        ("dz-tbx"  (113 22 109 62))
        ("dwall"   (500  500)) )
      ("glass" ((1 1 114) (2 2) ))
      ("frame"
        ("bottom" 0 (
          ((0 0) ((0 0)(30 0)(30 110)(0 110)(0 0))) ))
        ("top" 0 (
          ((0 0) ((0 0)(-30 0)(-30 110)(0 110)(0 0))) ))
        ("side" 30 (
          ((0 0) ((0 0)(30 0)(30 110)(0 110)(0 0))
                 (((0 0)(30 0)(30 110)(0 110))) ) )) )
      ("sash"
        ("rot-p" 70 (0 0 114))
        ("bottom" 0 (
          ((0 0) ((-0.5 89)(1 89)(1 129)(26 129)(26 130)(-0.5 130)(-0.5 89))) ))
        ("top" 0 (
          ((0 0) ((0.5 89)(-1 89)(-1 129)(-26 129)(-26 130)(0.5 130)(0.5 89))) ))
        ("side" 0 (
          ((0 0) ((-0.5 89)(1 89)(1 129)(26 129)(26 130)(-0.5 130)(-0.5 89))
                 (((1 89)(1 129)(26 129)(26 130))) ) )) )
      ("grip"
        ("gbox1" 25 (
          ((0 0) ((0 89)(-17.3205 119)(-24.641 126.3205)(-34.641 129)(-110 129)
		  (-124.1421 123.1421)(-130 109)(-124.1421 94.8579)(-110 89)(0 89)
		  (-23 109)(-26.8076 99.8076)(-36 96)
		  (-110 96)(-119.1924 99.8076)(-123 109)(-119.1924 118.1924)
		  (-110 122)(-36 122)(-26.8076 118.1924)(-23 109)(0 89)
		  )
                 (((0 89)(-17.3205 119)(-23 109)(0 89))
		  ((-17.3205 119)(-24.641 126.3205)(-26.8076 118.1924)(-23 109))
		  ((-24.641 126.3205)(-34.641 129)(-36 122)(-26.8076 118.1924))
		  ((-34.641 129)(-110 129)(-110 122)(-36 122))
		  ((-110 129)(-124.1421 123.1421)(-119.1924 118.1924)(-110 122))
		  ((-124.1421 123.1421)(-130 109)(-123 109)(-119.1924 118.1924))
		  ((-130 109)(-124.1421 94.8579)(-119.1924 99.8076)(-123 109))
		  ((-124.1421 94.8579)(-110 89)(-110 96)(-119.1924 99.8076))
		  ((-110 89)(0 89)(-36 96)(-110 96))
		  ((0 89)(-26.8076 99.8076)(-36 96)(0 89))
		  ((0 89)(-23 109)(-26.8076 99.8076)(0 89))
		  ) ) )) )
      ))
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
  ("GVA" ; GVA/VLT not change for V21
    ("small"
      ("solid"
        ("dxy-bts" (30 30 30))
        ("dz-tbx"  (113 22 109 62))
        ("dwall"   (500  500)) )
      ("glass" ((1 1 114) (2 2) ))
      ("frame"
        ("bottom" 0 (
          ((0 0) ((0 0)(30 0)(30 110)(0 110)(0 0))) ))
        ("top" 0 (
          ((0 0) ((0 0)(-30 0)(-30 110)(0 110)(0 0))) ))
        ("side" 30 (
          ((0 0) ((0 0)(30 0)(30 110)(0 110)(0 0))
                 (((0 0)(30 0)(30 110)(0 110))) ) )) )
      ("sash"
        ("rot-p" 70 (0 0 114))
        ("bottom" 0 (
          ((0 0) ((-0.5 89)(1 89)(1 129)(26 129)(26 130)(-0.5 130)(-0.5 89))) ))
        ("top" 0 (
          ((0 0) ((0.5 89)(-1 89)(-1 129)(-26 129)(-26 130)(0.5 130)(0.5 89))) ))
        ("side" 0 (
          ((0 0) ((-0.5 89)(1 89)(1 129)(26 129)(26 130)(-0.5 130)(-0.5 89))
                 (((1 89)(1 129)(26 129)(26 130))) ) )) )
      ))
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
  ("GVO" ; GVO not change for V21 67+9=76
    ("big"
      ("solid"
        ("dxy-bts" (30 30 30))
        ("dz-tbx"  (113 22 109 62))
        ("dwall"   (500  500)) )
      ("glass" ((1 1 114) (2 2) ))
      ("frame"
        ("bottom" 0 (
          ((0 0) ((0 0)(30 0)(30 110)(0 110)(0 0))) ))
        ("top" 0 ())
        ("side" 30 (
          ((0 0) ((0 0)(30 0)(30 110)(0 110)(0 0))
                 (((0 0)(30 0)(30 110)(0 110))) ) )) )
      ("sash"
        ("rot-p" 0 (0 0 -27))
        ("bottom" 0 ())
        ("top" 0 ())
        ("side" 0 ()) ) ))
;---------------------------------------------------------------------------
;old

;  ("EDH"  ((0 0 0)  (150 100 70) 118))
;  ("EDJ"  ((0 0 62) (350 100 70) 56))
;  ("EDN"  ((0 0 94) (270 100 70) 24))
;  ("ETW-" ((0 0 0)  (0 100 70) 118))
;  ("ETW"  ((0 0 0)  (150 0 70) 118))
;  ("EFS"  ((0 0 0)  (0 100 70) 118))
;  ("EDX"  ((0 0 0)  (150 100 70) 118))
;  ("EKW-" ((0 0 0)  (150 0 70) 118))
;  ("EKW+" ((0 0 0)  (0 100 70) 118))

;   BOTTOM TOP SIDE			
			
  ("GVT+" ((0 0 0)  (170 100 50) 118))
  ("GVO+" ((0 0 0)  (170 100 50) 118))  ; top=22 side=12 bottom=19
  ("GVA+" ((0 0 0)  (170 100 50) 118))
  ("VLT+" ((0 0 0)  (170 100 50) 118))
			
			
  ("EDH"  ((0 0 1)  (236 227 120) 89))
  ("EDW"  ((0 0 1)  (236 228 120) 89))
  ("EDS"  ((0 0 1)  (233 105 120) 89))
  ("EDL"  ((0 0 1)  (233 105 120) 89))
			
  ("EDE"  ((0 0 1)  (100 205 240) 89))
			
  ("ETW-" ((0 0 1)  (0 100 120) 89))
  ("ETW"  ((0 0 1)  (150 0 120) 89))
  ("EFS"  ((0 0 1)  (0 100 120) 89))
  ("EDX"  ((0 0 1)  (150 100 120) 89))
			
  ("EKW-" ((0 0 1)  (150 0 120) 89))
  ("EKW+" ((0 0 1)  (0 100 120) 89))
;---------------------------------------------------------------------------
  ("EE-"
    ("side" 0 (
      ((0 0) ((-5 -80)(-5 61)(-25 61)(-25 -80))) )) )
;---------------------------------------------------------------------------
  ("LFI"
    ("big"
      ("bottom" 220 (
        ((0 0) ((20 -60)(20 -80)(220 -80)(220 -60)(20 -60))
               (((20 -60)(20 -80)(220 -80)(220 -60)))) )) ) )
  ("LSC"
    ("big"
      ("bottom" 60 (
        ((0 0) ((5 0)(5 -15)(-55 -15)(-55 0)(5 0))
               (((5 0)(5 -15)(-55 -15)(-55 0)))) ))
      ("top" 60 (
        ((0 0) ((-5 0)(-5 -15)(55 -15)(55 0)(-5 0))
               (((-5 0)(-5 -15)(55 -15)(55 0)))) ))
      ("sid" 5)
      ("side" 60 (
        ((0 0) ((5 0)(5 -15)(-55 -15)(-55 0)(5 0))
               (((5 0)(5 -15)(-55 -15)(-55 0)))) )) ) )
  ("LGI"
    ("big"
      ("bottom" 40 (
        ((0 0) ((0 -109)(40 -109)(40 -49)(0 -49)(0 -109))) ))
      ("top" 40 (
        ((0 0) ((0 -109)(-40 -109)(-40 -49)(0 -49)(0 -109))) ))
      ("side" 40 (
        ((0 0) ((0 -109)(40 -109)(40 -49)(0 -49)(0 -109))
               (((0 -109)(40 -109)(40 -49)(0 -49))) ) )) ) )
;---------------------------------------------------------------------------
  ("MAL"
    ("big"   ("case" ((40 -150 107) (80 167) 2))))
  ;("SCL"
  ;  ("big"
  ;    ("bot" 0 (
  ;      ((0 0) ((-52 90)(-50 90)(-50 135)(-52 135)(-52 135))
  ;             (((-52 90)(-50 90)(-50 135)(-52 135))) ) ))
  ;    ("bottom" 0 (
  ;      ((0 0) ((-80 135)(-50 135)(-50 170)(-80 170)(-80 135))
  ;             (((-80 135)(-50 135)(-50 170)(-80 170))) ) ))
  ;    ("top" -40 (
  ;      ((0 0) ((-40 100)(115 100)(145 130)(145 190)(105 220)(-40 220)(-40 100))
  ;             (((-40 100)(115 100)(105 220)(-40 220))
  ;              ((145 130)(145 190)(105 220)(115 100))) ) ))
  ;    ("side" -40
  ;       (((-50 135)(-50 170))((-40 185)(-40 220)) 45)
  ;       (((-50 90)(-50 135))((-40 100)(-40 185)) -2) )))
  ("MML"
    ("big"
      ("top" -7 (
        ((0 0) ((-179 116)(-52 116)(-52 128.5)(-21 146.5)(-21 183)
                (-49 207.5)(-80.5 207.5)(-179 150)(-179 116))
               (((-52 128.5)(-179 150)(-179 116)(-52 116))
                ((-52 128.5)(-49 207.5)(-80.5 207.5)(-179 150))
                ((-52 128.5)(-21 146.5)(-21 183)(-49 207.5))) ) ))
      ("side" 7
         (((0 116)(0 150))
          ((-179 150)(-179 116))
          (())
          38)
         (((-31 116)(-31 125.5)(-19.5 145.5))
          ((0 150)(0 116))
          (())
          38)
       )))
  ("SML"
    ("big"
      ("top" -47.5 (
        ((0 0) ((0 107.75)(131.50 107.75)(159.50 156.25)(159.50 201.25)
                (127.75 233)(64 245.50)(29.70 245.50)(-28 236.25)
                (-89.50 210.50)(-86 151.50)(0 151.50)(0 107.75))
               (((0 151.50)(0 107.75)(131.50 107.75)(159.50 156.25))
                ((0 151.50)(159.50 156.25)(159.50 201.25)(127.75 233))
                ((0 151.50)(127.75 233)(64 245.50)(29.70 245.50))
                ((0 151.50)(29.70 245.50)(-28 236.25)(-89.50 210.50))
                ((0 151.50)(-89.50 210.50)(-86 151.50)(0 151.50))) ) ))
      ("side" 0
         (((-46 81)(-45 93)(-23 127.5)(16 145))
          ((-89.50 210.50)(-86 151.50))
          (((-46 81)(-45 93)(-23 127.5)(16 145)))
          -47.5)
         (((40 86))
          ((-86 151.50)(0 151.50)(0 116)(-56.25 116)(-56.25 84))
          (())
          -2) )))
  ("SMG-t"
    ("big"
      ("top" -47.5 (
        ((0 0) ((0 107.75)(131.50 107.75)(159.50 156.25)(159.50 201.25)
                (127.75 233)(64 245.50)(29.70 245.50)(-28 236.25)
                (-89.50 210.50)(-86 151.50)(0 151.50)(0 107.75))
               (((0 151.50)(0 107.75)(131.50 107.75)(159.50 156.25))
                ((0 151.50)(159.50 156.25)(159.50 201.25)(127.75 233))
                ((0 151.50)(127.75 233)(64 245.50)(29.70 245.50))
                ((0 151.50)(29.70 245.50)(-28 236.25)(-89.50 210.50))
                ((0 151.50)(-89.50 210.50)(-86 151.50)(0 151.50))) ) ))
      ("side" 0
         (((-100 151.5)(-100 210.5))
          ((-89.50 210.50)(-86 151.50))
          (((-100 151.5)(-100 210.5)))
          -47.5)
         (((-100 151.5))
          ((-86 151.50)(0 151.50)(0 116)(-56.25 116)(-56.25 84))
          (())
          -2) )))
  ("SMG-b"
    ("big"
      ("top" -47.5 (
        ((300 0) ((-272.5 107.75)(-141 107.75)(-113 156.25)(-113 201.25)
                (-144.75 233)(-208.5 245.50)(-242.8 245.50)(-300.5 236.25)
                (-362 210.50)(-358.5 151.50)(-272.5 151.50)(-272.5 107.75))
               (((-272.5 151.50)(-272.5 107.75)(-141 107.75)(-113 156.25))
                ((-272.5 151.50)(-113 156.25)(-113 201.25)(-144.75 233))
                ((-272.5 151.50)(-144.75 233)(-208.5 245.50)(-242.8 245.50))
                ((-272.5 151.50)(-242.8 245.50)(-300.5 236.25)(-362 210.50))
                ((-272.5 151.50)(-362 210.50)(-358.5 151.50)(-272.5 151.50))) ) ))
      ("side" 0
         (((-46 81)(-45 93)(-23 127.5)(16 145))
          ((-362 210.50)(-358.5 151.50))
          (((-46 81)(-45 93)(-23 127.5)(16 145)))
          -47.5)
         (((40 86))
          ((-358.5 151.50)(-272.5 151.50)(-272.5 116)(-328.75 116)(-328.75 84))
          (())
          -2) )))
  ("RHL"
    ("big"
      ("bottom" 0 (
        ((0 0) ((0 6)(0 60)(30 60)(30 6)(0 6))) ))
      ("top" 0 (
        ((0 0) ((0 6)(0 60)(-30 60)(-30 6)(0 6))) ))
      ("side" 10 (
        ((0 0) ((85 6)(85 20)(95 20)(95 6)(85 6))) ))
      ("case" 
        (20 2)) ))
  ("DKL"
    ("big"
      ("bottom" 0 (
        ((0 0) ((0 6)(0 60)(30 60)(30 6)(0 6))) ))
      ("top" 0 (
        ((0 0) ((0 6)(0 60)(-30 60)(-30 6)(0 6))) ))
      ("side" 10 (
        ((0 0) ((85 6)(85 20)(95 20)(95 6)(85 6))) ))
      ("case" 
        (20 5)) ))
  ("FHL"
    ("big"
      ("bottom" 0 (
        ((0 0) ((0 6)(0 60)(30 60)(30 6)(0 6))) ))
      ("top" 0 (
        ((0 0) ((0 6)(0 60)(-30 60)(-30 6)(0 6))) ))
      ("side" 10 (
        ((0 0) ((85 6)(85 20)(95 20)(95 6)(85 6))) ))
      ("case" 
        (20 -10)) ))
  ("FYL"
    ("big"
      ("bottom" 0 (
        ((0 0) ((0 6)(0 60)(30 60)(30 6)(0 6))) ))
      ("side" 10 ())
      ("case" 
        (20 -10)) ))
  ("PAL"
    ("big"
      ("top" 0 (
        ((0 0) ((0 6)(0 60)(-30 60)(-30 6)(0 6))) ))
      ("side" 10 (
        ((0 0) ((85 6)(85 20)(95 20)(95 6)(85 6))) ))
      ("case" 
        (20 -14)) ))
;---------------------------------------------------------------------------
))